% Copyright 2008 INRIA, F. Fages & J. Martin
% License GPL
%
% file compiler.pl
%

:- ensure_loaded([typ]).
:- ensure_loaded([icg]).
:- ensure_loaded([ocg]).
:- ensure_loaded([ocw]).

:- dynamic current_object_language/1.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% compilation 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
compile([], _) :-
	!,
	write('\"----------------- No file to compile -----------------\"'),
	nl.
compile(Files, ObjectLanguage) :-
	statistics(runtime, [T0 | _]),
	
	write('\"-------------- Compiler Initialization ---------------\"'),
	nl,
	init_compiler(ObjectLanguage),
	
	write('\"---------------- Source Code Parsing -----------------\"'),
	nl,
	parse(Files), 

                                % nl,
                                % write('\"------------ Source Code Type Checking ---------------\"'),
                                % nl,
                                % check_types,
                                % write('\"------------------------------------------------------\"'),
                                % nl,
        
	nl,
	write('\"------------ Intermediate Code Generation ------------\"'),
	nl,
	gen_intcode(IntCodeAsList),
	write('\"------------------------------------------------------\"'),
	nl,
				%write_list(IntCodeAsList),nl,
	write('\"------------------------------------------------------\"'),
	nl,
	
	nl,
	write('\"------------ Object Code Generation ------------------\"'),
	nl,
 	gen_objcode(IntCodeAsList, ObjCodeAsList),
	write('\"------------------------------------------------------\"'),
	nl,
				% write_list(ObjCodeAsList),nl,
	write('\"------------------------------------------------------\"'),
	nl,
	
	nl,
	write('\"------------ Object Code Writing ---------------------\"'),
	nl,
	write_code(ObjCodeAsList, Files),
	
	statistics(runtime, [T1 | _]),
        T is T1 - T0,
        format('Compilation took \"~3d sec\".~n', [T]),
	retractall(rcp_path(_)).

init_compiler(ObjectLanguage) :-
	retractall(current_object_language(_)),
	assert(current_object_language(ObjectLanguage)),
	write('Object language is \"'),
	write(ObjectLanguage),
	write('\"'), nl, nl.

object_language(X) :-
	current_object_language(X),
	!.
