:- use_module(library(clpfd)).
:- use_module('/afs/inria.fr/rocq/home/contraintes/common/src/rules2cp/interpreter/prolog/r2cp.pl').
:- init_interpreter.



rcp_s1(_A_) :- 
	rcp_make_shape_box([5,5,4], _A_).

rcp_s1_search(_A_) :- 
	rcp_make_shape_box_search([5,5,4], _A_).

rcp_s2(_A_) :- 
	rcp_make_shape_box([4,5,2], _A_).

rcp_s2_search(_A_) :- 
	rcp_make_shape_box_search([4,5,2], _A_).

rcp_s3(_A_) :- 
	rcp_make_shape_box([5,4,2], _A_).

rcp_s3_search(_A_) :- 
	rcp_make_shape_box_search([5,4,2], _A_).

rcp_o1(_B_) :- 
	s1(_A_),
	rcp_make_object_shape(_A_, [0,0,0], _B_).

rcp_o1_search(_B_) :- 
	rcp_s1_search(_A_),
	rcp_make_object_shape_search(_A_, [0,0,0], _B_).

rcp_o2(_B_) :- 
	s2(_A_),
	rcp_var(from(o2,0,1), O2),
	rcp_var(from(o2,0,2), O2_2),
	rcp_var(from(o2,0,3), O2_3),
	rcp_make_object_shape_psa(_A_, [O2,O2_2,O2_3], 2, 0, _B_).

rcp_o2_search(_B_) :- 
	rcp_s2_search(_A_),
	rcp_var(from(o2,0,1), O2),
	rcp_var(from(o2,0,2), O2_2),
	rcp_var(from(o2,0,3), O2_3),
	rcp_make_object_shape_psa_search(_A_, [O2,O2_2,O2_3], 2, 0, _B_).

rcp_o3(_B_) :- 
	s3(_A_),
	rcp_var(from(o3,0,1), O3),
	rcp_var(from(o3,0,2), O3_2),
	rcp_var(from(o3,0,3), O3_3),
	rcp_make_object_shape_psa(_A_, [O3,O3_2,O3_3], 5, 2, _B_).

rcp_o3_search(_B_) :- 
	rcp_s3_search(_A_),
	rcp_var(from(o3,0,1), O3),
	rcp_var(from(o3,0,2), O3_2),
	rcp_var(from(o3,0,3), O3_3),
	rcp_make_object_shape_psa_search(_A_, [O3,O3_2,O3_3], 5, 2, _B_).

rcp_dimensions(_A_) :- 
	_A_=[1,2,3].

rcp_dimensions_search(_A_) :- 
	_A_=[1,2,3].

rcp_bin(_A_) :- 
	o1(_A_).

rcp_bin_search(_A_) :- 
	rcp_o1_search(_A_).

rcp_items(_C_) :- 
	o2(_A_),
	o3(_B_),
	_C_=[_A_,_B_].

rcp_items_search(_C_) :- 
	rcp_o2_search(_A_),
	rcp_o3_search(_B_),
	_C_=[_A_,_B_].

rcp_sum_foldr_1([], _, 0) :- 
	!.
rcp_sum_foldr_1([X_65|Tail], [L], _B_) :- 
	rcp_sum_foldr_1(Tail, [L], _A_),
	fd_aeq(X_65+_A_, _B_).

rcp_sum_foldr_1_search([], _, 0) :- 
	!.
rcp_sum_foldr_1_search([X_65|Tail], [L], _D_) :- 
	rcp_sum_foldr_1_search(Tail, [L], _C_),
	fd_aeq(X_65+_C_, _D_).

rcp_sum(L, _A_) :- 
	rcp_sum_foldr_1(L, [L], _A_).

rcp_sum_search(L, _A_) :- 
	rcp_sum_foldr_1_search(L, [L], _A_).

rcp_product_foldr_2([], _, 1) :- 
	!.
rcp_product_foldr_2([X_66|Tail], [L], _B_) :- 
	rcp_product_foldr_2(Tail, [L], _A_),
	fd_aeq(X_66*_A_, _B_).

rcp_product_foldr_2_search([], _, 1) :- 
	!.
rcp_product_foldr_2_search([X_66|Tail], [L], _D_) :- 
	rcp_product_foldr_2_search(Tail, [L], _C_),
	fd_aeq(X_66*_C_, _D_).

rcp_product(L, _A_) :- 
	rcp_product_foldr_2(L, [L], _A_).

rcp_product_search(L, _A_) :- 
	rcp_product_foldr_2_search(L, [L], _A_).

rcp_maximum_foldr_3([], _, -268435456) :- 
	!.
rcp_maximum_foldr_3([X_67|Tail], [L], _B_) :- 
	rcp_maximum_foldr_3(Tail, [L], _A_),
	fd_aeq(max(X_67,_A_), _B_).

rcp_maximum_foldr_3_search([], _, -268435456) :- 
	!.
rcp_maximum_foldr_3_search([X_67|Tail], [L], _D_) :- 
	rcp_maximum_foldr_3_search(Tail, [L], _C_),
	fd_aeq(max(X_67,_C_), _D_).

rcp_maximum(L, _A_) :- 
	rcp_maximum_foldr_3(L, [L], _A_).

rcp_maximum_search(L, _A_) :- 
	rcp_maximum_foldr_3_search(L, [L], _A_).

rcp_minimum_foldr_4([], _, 267999999) :- 
	!.
rcp_minimum_foldr_4([X_68|Tail], [L], _B_) :- 
	rcp_minimum_foldr_4(Tail, [L], _A_),
	fd_aeq(min(X_68,_A_), _B_).

rcp_minimum_foldr_4_search([], _, 267999999) :- 
	!.
rcp_minimum_foldr_4_search([X_68|Tail], [L], _D_) :- 
	rcp_minimum_foldr_4_search(Tail, [L], _C_),
	fd_aeq(min(X_68,_C_), _D_).

rcp_minimum(L, _A_) :- 
	rcp_minimum_foldr_4(L, [L], _A_).

rcp_minimum_search(L, _A_) :- 
	rcp_minimum_foldr_4_search(L, [L], _A_).

rcp_geost_constraint_foldr_6([], _, []) :- 
	!.
rcp_geost_constraint_foldr_6([S_71|Tail], [Dims,I_69,Items], [_A_|_B_]) :- 
	rcp_att(uid, S_71, _A_),
	rcp_geost_constraint_foldr_6(Tail, [Dims,I_69,Items], _B_).

rcp_geost_constraint_foldr_6_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_6_search([S_71|Tail], [Dims,I_69,Items], [_C_|_D_]) :- 
	rcp_att(uid, S_71, _C_),
	rcp_geost_constraint_foldr_6_search(Tail, [Dims,I_69,Items], _D_).

rcp_geost_constraint_foldr_5([], _, []) :- 
	!.
rcp_geost_constraint_foldr_5([I_69|Tail], [Dims,Items], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_69, _A_),
	rcp_att(shape_index, I_69, _B_),
	rcp_att(shapes, I_69, _C_),
	rcp_geost_constraint_foldr_6(_C_, [Dims,I_69,Items], _D_),
	rcp_att(origin, I_69, _E_),
	rcp_geost_constraint_foldr_5(Tail, [Dims,Items], _F_).

rcp_geost_constraint_foldr_5_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_5_search([I_69|Tail], [Dims,Items], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_69, _G_),
	rcp_att(shape_index, I_69, _H_),
	rcp_att(shapes, I_69, _I_),
	rcp_geost_constraint_foldr_6_search(_I_, [Dims,I_69,Items], _J_),
	rcp_att(origin, I_69, _K_),
	rcp_geost_constraint_foldr_5_search(Tail, [Dims,Items], _L_).

rcp_geost_constraint_foldr_9([], _, []) :- 
	!.
rcp_geost_constraint_foldr_9([SB_77|Tail], [Dims,I_72,Items,S_75], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_75, _A_),
	rcp_att(offset, SB_77, _B_),
	rcp_att(box, SB_77, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_9(Tail, [Dims,I_72,Items,S_75], _E_).

rcp_geost_constraint_foldr_9_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_9_search([SB_77|Tail], [Dims,I_72,Items,S_75], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_75, _F_),
	rcp_att(offset, SB_77, _G_),
	rcp_att(box, SB_77, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_9_search(Tail, [Dims,I_72,Items,S_75], _J_).

rcp_geost_constraint_foldr_8([], _, []) :- 
	!.
rcp_geost_constraint_foldr_8([S_75|Tail], [Dims,I_72,Items], [_B_|_C_]) :- 
	rcp_att(sboxes, S_75, _A_),
	rcp_geost_constraint_foldr_9(_A_, [Dims,I_72,Items,S_75], _B_),
	rcp_geost_constraint_foldr_8(Tail, [Dims,I_72,Items], _C_).

rcp_geost_constraint_foldr_8_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_8_search([S_75|Tail], [Dims,I_72,Items], [_E_|_F_]) :- 
	rcp_att(sboxes, S_75, _D_),
	rcp_geost_constraint_foldr_9_search(_D_, [Dims,I_72,Items,S_75], _E_),
	rcp_geost_constraint_foldr_8_search(Tail, [Dims,I_72,Items], _F_).

rcp_geost_constraint_foldr_7([], _, []) :- 
	!.
rcp_geost_constraint_foldr_7([I_72|Tail], [Dims,Items], [_B_|_C_]) :- 
	rcp_att(shapes, I_72, _A_),
	rcp_geost_constraint_foldr_8(_A_, [Dims,I_72,Items], _B_),
	rcp_geost_constraint_foldr_7(Tail, [Dims,Items], _C_).

rcp_geost_constraint_foldr_7_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_7_search([I_72|Tail], [Dims,Items], [_E_|_F_]) :- 
	rcp_att(shapes, I_72, _D_),
	rcp_geost_constraint_foldr_8_search(_D_, [Dims,I_72,Items], _E_),
	rcp_geost_constraint_foldr_7_search(Tail, [Dims,Items], _F_).

rcp_non_overlapping(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_5(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_7(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_non_overlapping_search(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_5_search(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_7_search(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_geost_constraint_foldr_11([], _, []) :- 
	!.
rcp_geost_constraint_foldr_11([S_80|Tail], [Dims,F,I_78,Items,Patterns], [_A_|_B_]) :- 
	rcp_att(uid, S_80, _A_),
	rcp_geost_constraint_foldr_11(Tail, [Dims,F,I_78,Items,Patterns], _B_).

rcp_geost_constraint_foldr_11_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_11_search([S_80|Tail], [Dims,F,I_78,Items,Patterns], [_C_|_D_]) :- 
	rcp_att(uid, S_80, _C_),
	rcp_geost_constraint_foldr_11_search(Tail, [Dims,F,I_78,Items,Patterns], _D_).

rcp_geost_constraint_foldr_10([], _, []) :- 
	!.
rcp_geost_constraint_foldr_10([I_78|Tail], [Dims,F,Items,Patterns], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_78, _A_),
	rcp_att(shape_index, I_78, _B_),
	rcp_att(shapes, I_78, _C_),
	rcp_geost_constraint_foldr_11(_C_, [Dims,F,I_78,Items,Patterns], _D_),
	rcp_att(origin, I_78, _E_),
	rcp_geost_constraint_foldr_10(Tail, [Dims,F,Items,Patterns], _F_).

rcp_geost_constraint_foldr_10_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_10_search([I_78|Tail], [Dims,F,Items,Patterns], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_78, _G_),
	rcp_att(shape_index, I_78, _H_),
	rcp_att(shapes, I_78, _I_),
	rcp_geost_constraint_foldr_11_search(_I_, [Dims,F,I_78,Items,Patterns], _J_),
	rcp_att(origin, I_78, _K_),
	rcp_geost_constraint_foldr_10_search(Tail, [Dims,F,Items,Patterns], _L_).

rcp_geost_constraint_foldr_14([], _, []) :- 
	!.
rcp_geost_constraint_foldr_14([SB_86|Tail], [Dims,F,I_81,Items,Patterns,S_84], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_84, _A_),
	rcp_att(offset, SB_86, _B_),
	rcp_att(box, SB_86, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_14(Tail, [Dims,F,I_81,Items,Patterns,S_84], _E_).

rcp_geost_constraint_foldr_14_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_14_search([SB_86|Tail], [Dims,F,I_81,Items,Patterns,S_84], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_84, _F_),
	rcp_att(offset, SB_86, _G_),
	rcp_att(box, SB_86, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_14_search(Tail, [Dims,F,I_81,Items,Patterns,S_84], _J_).

rcp_geost_constraint_foldr_13([], _, []) :- 
	!.
rcp_geost_constraint_foldr_13([S_84|Tail], [Dims,F,I_81,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(sboxes, S_84, _A_),
	rcp_geost_constraint_foldr_14(_A_, [Dims,F,I_81,Items,Patterns,S_84], _B_),
	rcp_geost_constraint_foldr_13(Tail, [Dims,F,I_81,Items,Patterns], _C_).

rcp_geost_constraint_foldr_13_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_13_search([S_84|Tail], [Dims,F,I_81,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(sboxes, S_84, _D_),
	rcp_geost_constraint_foldr_14_search(_D_, [Dims,F,I_81,Items,Patterns,S_84], _E_),
	rcp_geost_constraint_foldr_13_search(Tail, [Dims,F,I_81,Items,Patterns], _F_).

rcp_geost_constraint_foldr_12([], _, []) :- 
	!.
rcp_geost_constraint_foldr_12([I_81|Tail], [Dims,F,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(shapes, I_81, _A_),
	rcp_geost_constraint_foldr_13(_A_, [Dims,F,I_81,Items,Patterns], _B_),
	rcp_geost_constraint_foldr_12(Tail, [Dims,F,Items,Patterns], _C_).

rcp_geost_constraint_foldr_12_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_12_search([I_81|Tail], [Dims,F,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(shapes, I_81, _D_),
	rcp_geost_constraint_foldr_13_search(_D_, [Dims,F,I_81,Items,Patterns], _E_),
	rcp_geost_constraint_foldr_12_search(Tail, [Dims,F,Items,Patterns], _F_).

rcp_non_overlapping(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_10(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_12(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_non_overlapping_search(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_10_search(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_12_search(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall_search(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_precedes(A, B, D, _C_) :- 
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_).

rcp_precedes_search(A, B, D, _C_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	fd_lt(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_meets(A, B, D, _C_) :- 
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_).

rcp_meets_search(A, B, D, _C_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	fd_eq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_overlaps(A, B, D, _K_) :- 
	fd_and(_C_, _J_, _K_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_and(_F_, _I_, _J_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_),
	rcp_origin(B, D, _G_),
	rcp_end(A, D, _H_),
	fd_lt(_G_, _H_, _I_).

rcp_overlaps_search(A, B, D, _G_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	rcp_origin_search(B, D, _E_),
	rcp_end_search(A, D, _F_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_lt(_E_, _F_),
	fd_aeq(_G_, 1).

rcp_contains(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_contains_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_starts(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_starts_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_eq(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_finishes(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_finishes_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_lt(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_equals(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_equals_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_eq(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_started_by(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_started_by_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_eq(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_finished_by(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_gt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_finished_by_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_gt(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_during(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_during_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_overlapped_by(A, B, D, _K_) :- 
	fd_and(_C_, _J_, _K_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_and(_F_, _I_, _J_),
	rcp_origin(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_),
	rcp_end(A, D, _G_),
	rcp_end(B, D, _H_),
	fd_gt(_G_, _H_, _I_).

rcp_overlapped_by_search(A, B, D, _G_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_origin_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	rcp_end_search(A, D, _E_),
	rcp_end_search(B, D, _F_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_gt(_E_, _F_),
	fd_aeq(_G_, 1).

rcp_met_by(A, B, D, _C_) :- 
	rcp_end(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_eq(_A_, _B_, _C_).

rcp_met_by_search(A, B, D, _C_) :- 
	rcp_end_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	fd_eq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_preceded_by(A, B, D, _C_) :- 
	rcp_end(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_).

rcp_preceded_by_search(A, B, D, _C_) :- 
	rcp_end_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	fd_lt(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_contains_touch(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_leq(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_leq(_D_, _E_, _F_).

rcp_contains_touch_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_leq(_A_, _B_),
	fd_leq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_overlaps_sym(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_gt(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_origin(A, D, _E_),
	fd_gt(_D_, _E_, _F_).

rcp_overlaps_sym_search(A, B, D, _E_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_origin_search(A, D, _D_),
	fd_gt(_A_, _B_),
	fd_gt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_disjoint_foldr_15([], _, 0) :- 
	!.
rcp_disjoint_foldr_15([D_87|Tail], [Ds,O1,O2], _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_or(_A_, _B_, _C_),
	rcp_precedes(O1, O2, D_87, _A_),
	rcp_preceded_by(O1, O2, D_87, _B_),
	rcp_disjoint_foldr_15(Tail, [Ds,O1,O2], _D_).

rcp_disjoint_foldr_15_search([], _, 0) :- 
	!.
rcp_disjoint_foldr_15_search([D_87|Tail], [Ds,O1,O2], _) :- 
	(
	(
	rcp_precedes_search(O1, O2, D_87, _F_),
	rcp_assert(_F_)
	;
	rcp_preceded_by_search(O1, O2, D_87, _G_),
	rcp_assert(_G_)
	)
	;
	rcp_disjoint_foldr_15_search(Tail, [Ds,O1,O2], _H_),
	rcp_assert(_H_)
	).

rcp_disjoint(O1, O2, Ds, _A_) :- 
	rcp_disjoint_foldr_15(Ds, [Ds,O1,O2], _A_).

rcp_disjoint_search(O1, O2, Ds, _A_) :- 
	rcp_disjoint_foldr_15_search(Ds, [Ds,O1,O2], _A_).

rcp_meet_foldr_16([], _, 1) :- 
	!.
rcp_meet_foldr_16([D_88|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_and(_B_, _D_, _E_),
	fd_not(_A_, _B_),
	rcp_precedes(O1, O2, D_88, _A_),
	fd_not(_C_, _D_),
	rcp_preceded_by(O1, O2, D_88, _C_),
	rcp_meet_foldr_16(Tail, [Ds,O1,O2], _F_).

rcp_meet_foldr_16_search([], _, 1) :- 
	!.
rcp_meet_foldr_16_search([D_88|Tail], [Ds,O1,O2], _) :- 
	rcp_precedes_search(O1, O2, D_88, _H_),
	fd_not(_H_, _I_),
	rcp_assert(_I_),
	rcp_preceded_by_search(O1, O2, D_88, _J_),
	fd_not(_J_, _K_),
	rcp_assert(_K_),
	rcp_meet_foldr_16_search(Tail, [Ds,O1,O2], _L_),
	rcp_assert(_L_).

rcp_meet_foldr_17([], _, 0) :- 
	!.
rcp_meet_foldr_17([D_89|Tail], [Ds,O1,O2], _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_or(_A_, _B_, _C_),
	rcp_meets(O1, O2, D_89, _A_),
	rcp_met_by(O1, O2, D_89, _B_),
	rcp_meet_foldr_17(Tail, [Ds,O1,O2], _D_).

rcp_meet_foldr_17_search([], _, 0) :- 
	!.
rcp_meet_foldr_17_search([D_89|Tail], [Ds,O1,O2], _) :- 
	(
	(
	rcp_meets_search(O1, O2, D_89, _F_),
	rcp_assert(_F_)
	;
	rcp_met_by_search(O1, O2, D_89, _G_),
	rcp_assert(_G_)
	)
	;
	rcp_meet_foldr_17_search(Tail, [Ds,O1,O2], _H_),
	rcp_assert(_H_)
	).

rcp_meet(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_meet_foldr_16(Ds, [Ds,O1,O2], _A_),
	rcp_meet_foldr_17(Ds, [Ds,O1,O2], _B_).

rcp_meet_search(O1, O2, Ds, _C_) :- 
	rcp_meet_foldr_16_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_meet_foldr_17_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_equal_foldr_18([], _, 1) :- 
	!.
rcp_equal_foldr_18([D_90|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_equals(O1, O2, D_90, _A_),
	rcp_equal_foldr_18(Tail, [Ds,O1,O2], _B_).

rcp_equal_foldr_18_search([], _, 1) :- 
	!.
rcp_equal_foldr_18_search([D_90|Tail], [Ds,O1,O2], _) :- 
	rcp_equals_search(O1, O2, D_90, _D_),
	rcp_assert(_D_),
	rcp_equal_foldr_18_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_equal(O1, O2, Ds, _A_) :- 
	rcp_equal_foldr_18(Ds, [Ds,O1,O2], _A_).

rcp_equal_search(O1, O2, Ds, _A_) :- 
	rcp_equal_foldr_18_search(Ds, [Ds,O1,O2], _A_).

rcp_covers_foldr_19([], _, 1) :- 
	!.
rcp_covers_foldr_19([D_91|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_or(_A_, _D_, _E_),
	rcp_started_by(O1, O2, D_91, _A_),
	fd_or(_B_, _C_, _D_),
	rcp_contains(O1, O2, D_91, _B_),
	rcp_finished_by(O1, O2, D_91, _C_),
	rcp_covers_foldr_19(Tail, [Ds,O1,O2], _F_).

rcp_covers_foldr_19_search([], _, 1) :- 
	!.
rcp_covers_foldr_19_search([D_91|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_started_by_search(O1, O2, D_91, _H_),
	rcp_assert(_H_)
	;
	(
	rcp_contains_search(O1, O2, D_91, _I_),
	rcp_assert(_I_)
	;
	rcp_finished_by_search(O1, O2, D_91, _J_),
	rcp_assert(_J_)
	)
	),
	rcp_covers_foldr_19_search(Tail, [Ds,O1,O2], _K_),
	rcp_assert(_K_).

rcp_covers_foldr_20([], _, 0) :- 
	!.
rcp_covers_foldr_20([D_92|Tail], [Ds,O1,O2], _D_) :- 
	fd_or(_B_, _C_, _D_),
	fd_not(_A_, _B_),
	rcp_contains(O1, O2, D_92, _A_),
	rcp_covers_foldr_20(Tail, [Ds,O1,O2], _C_).

rcp_covers_foldr_20_search([], _, 0) :- 
	!.
rcp_covers_foldr_20_search([D_92|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_contains_search(O1, O2, D_92, _E_),
	fd_not(_E_, _F_),
	rcp_assert(_F_)
	;
	rcp_covers_foldr_20_search(Tail, [Ds,O1,O2], _G_),
	rcp_assert(_G_)
	).

rcp_covers(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_covers_foldr_19(Ds, [Ds,O1,O2], _A_),
	rcp_covers_foldr_20(Ds, [Ds,O1,O2], _B_).

rcp_covers_search(O1, O2, Ds, _C_) :- 
	rcp_covers_foldr_19_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_covers_foldr_20_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_covered_by_foldr_21([], _, 1) :- 
	!.
rcp_covered_by_foldr_21([D_93|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_or(_A_, _D_, _E_),
	rcp_starts(O1, O2, D_93, _A_),
	fd_or(_B_, _C_, _D_),
	rcp_during(O1, O2, D_93, _B_),
	rcp_finishes(O1, O2, D_93, _C_),
	rcp_covered_by_foldr_21(Tail, [Ds,O1,O2], _F_).

rcp_covered_by_foldr_21_search([], _, 1) :- 
	!.
rcp_covered_by_foldr_21_search([D_93|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_starts_search(O1, O2, D_93, _H_),
	rcp_assert(_H_)
	;
	(
	rcp_during_search(O1, O2, D_93, _I_),
	rcp_assert(_I_)
	;
	rcp_finishes_search(O1, O2, D_93, _J_),
	rcp_assert(_J_)
	)
	),
	rcp_covered_by_foldr_21_search(Tail, [Ds,O1,O2], _K_),
	rcp_assert(_K_).

rcp_covered_by_foldr_22([], _, 0) :- 
	!.
rcp_covered_by_foldr_22([D_94|Tail], [Ds,O1,O2], _D_) :- 
	fd_or(_B_, _C_, _D_),
	fd_not(_A_, _B_),
	rcp_during(O1, O2, D_94, _A_),
	rcp_covered_by_foldr_22(Tail, [Ds,O1,O2], _C_).

rcp_covered_by_foldr_22_search([], _, 0) :- 
	!.
rcp_covered_by_foldr_22_search([D_94|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_during_search(O1, O2, D_94, _E_),
	fd_not(_E_, _F_),
	rcp_assert(_F_)
	;
	rcp_covered_by_foldr_22_search(Tail, [Ds,O1,O2], _G_),
	rcp_assert(_G_)
	).

rcp_covered_by(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_covered_by_foldr_21(Ds, [Ds,O1,O2], _A_),
	rcp_covered_by_foldr_22(Ds, [Ds,O1,O2], _B_).

rcp_covered_by_search(O1, O2, Ds, _C_) :- 
	rcp_covered_by_foldr_21_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_covered_by_foldr_22_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_contains_rcc_foldr_23([], _, 1) :- 
	!.
rcp_contains_rcc_foldr_23([D_95|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains(O1, O2, D_95, _A_),
	rcp_contains_rcc_foldr_23(Tail, [Ds,O1,O2], _B_).

rcp_contains_rcc_foldr_23_search([], _, 1) :- 
	!.
rcp_contains_rcc_foldr_23_search([D_95|Tail], [Ds,O1,O2], _) :- 
	rcp_contains_search(O1, O2, D_95, _D_),
	rcp_assert(_D_),
	rcp_contains_rcc_foldr_23_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_contains_rcc(O1, O2, Ds, _A_) :- 
	rcp_contains_rcc_foldr_23(Ds, [Ds,O1,O2], _A_).

rcp_contains_rcc_search(O1, O2, Ds, _A_) :- 
	rcp_contains_rcc_foldr_23_search(Ds, [Ds,O1,O2], _A_).

rcp_inside_foldr_24([], _, 1) :- 
	!.
rcp_inside_foldr_24([D_96|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_during(O1, O2, D_96, _A_),
	rcp_inside_foldr_24(Tail, [Ds,O1,O2], _B_).

rcp_inside_foldr_24_search([], _, 1) :- 
	!.
rcp_inside_foldr_24_search([D_96|Tail], [Ds,O1,O2], _) :- 
	rcp_during_search(O1, O2, D_96, _D_),
	rcp_assert(_D_),
	rcp_inside_foldr_24_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_inside(O1, O2, Ds, _A_) :- 
	rcp_inside_foldr_24(Ds, [Ds,O1,O2], _A_).

rcp_inside_search(O1, O2, Ds, _A_) :- 
	rcp_inside_foldr_24_search(Ds, [Ds,O1,O2], _A_).

rcp_overlap_foldr_25([], _, 1) :- 
	!.
rcp_overlap_foldr_25([D_97|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_overlaps_sym(O1, O2, D_97, _A_),
	rcp_overlap_foldr_25(Tail, [Ds,O1,O2], _B_).

rcp_overlap_foldr_25_search([], _, 1) :- 
	!.
rcp_overlap_foldr_25_search([D_97|Tail], [Ds,O1,O2], _) :- 
	rcp_overlaps_sym_search(O1, O2, D_97, _D_),
	rcp_assert(_D_),
	rcp_overlap_foldr_25_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_overlap(O1, O2, Ds, _A_) :- 
	rcp_overlap_foldr_25(Ds, [Ds,O1,O2], _A_).

rcp_overlap_search(O1, O2, Ds, _A_) :- 
	rcp_overlap_foldr_25_search(Ds, [Ds,O1,O2], _A_).

rcp_contains_touch_rcc_foldr_26([], _, 1) :- 
	!.
rcp_contains_touch_rcc_foldr_26([D_98|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains_touch(O1, O2, D_98, _A_),
	rcp_contains_touch_rcc_foldr_26(Tail, [Ds,O1,O2], _B_).

rcp_contains_touch_rcc_foldr_26_search([], _, 1) :- 
	!.
rcp_contains_touch_rcc_foldr_26_search([D_98|Tail], [Ds,O1,O2], _) :- 
	rcp_contains_touch_search(O1, O2, D_98, _D_),
	rcp_assert(_D_),
	rcp_contains_touch_rcc_foldr_26_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_contains_touch_rcc(O1, O2, Ds, _A_) :- 
	rcp_contains_touch_rcc_foldr_26(Ds, [Ds,O1,O2], _A_).

rcp_contains_touch_rcc_search(O1, O2, Ds, _A_) :- 
	rcp_contains_touch_rcc_foldr_26_search(Ds, [Ds,O1,O2], _A_).

rcp_above(O1, O2, _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_and(_A_, _B_, _C_),
	rcp_overlap(O1, O2, [1,2], _A_),
	rcp_preceded_by(O1, O2, 3, _B_),
	rcp_met_by(O1, O2, 3, _D_).

rcp_above_search(O1, O2, _D_) :- 
	(
	rcp_overlap_search(O1, O2, [1,2], _A_),
	rcp_assert(_A_),
	rcp_preceded_by_search(O1, O2, 3, _B_),
	rcp_assert(_B_)
	;
	rcp_met_by_search(O1, O2, 3, _C_),
	rcp_assert(_C_)
	),
	fd_aeq(_D_, 1).

rcp_on_top(O1, O2, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_overlap(O1, O2, [1,2], _A_),
	rcp_met_by(O1, O2, 3, _B_).

rcp_on_top_search(O1, O2, _C_) :- 
	rcp_overlap_search(O1, O2, [1,2], _A_),
	rcp_assert(_A_),
	rcp_met_by_search(O1, O2, 3, _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_oversize(O1, O2, D, _O_) :- 
	rcp_origin(O1, D, _A_),
	rcp_origin(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_origin(O1, D, _D_),
	rcp_origin(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	rcp_end(O1, D, _H_),
	rcp_end(O2, D, _I_),
	fd_aeq(max(_H_,_I_), _J_),
	rcp_end(O1, D, _K_),
	rcp_end(O2, D, _L_),
	fd_aeq(min(_K_,_L_), _M_),
	fd_aeq(_J_-_M_, _N_),
	fd_aeq(max(_G_,_N_), _O_).

rcp_oversize_search(O1, O2, D, _O_) :- 
	rcp_origin_search(O1, D, _A_),
	rcp_origin_search(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_origin_search(O1, D, _D_),
	rcp_origin_search(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	rcp_end_search(O1, D, _H_),
	rcp_end_search(O2, D, _I_),
	fd_aeq(max(_H_,_I_), _J_),
	rcp_end_search(O1, D, _K_),
	rcp_end_search(O2, D, _L_),
	fd_aeq(min(_K_,_L_), _M_),
	fd_aeq(_J_-_M_, _N_),
	fd_aeq(max(_G_,_N_), _O_).

rcp_stack_oversize_foldr_29([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_29([D_104|Tail], [Items,Length,O1_99,O2_102], _D_) :- 
	fd_and(_B_, _C_, _D_),
	rcp_oversize(O1_99, O2_102, D_104, _A_),
	fd_leq(_A_, Length, _B_),
	rcp_stack_oversize_foldr_29(Tail, [Items,Length,O1_99,O2_102], _C_).

rcp_stack_oversize_foldr_29_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_29_search([D_104|Tail], [Items,Length,O1_99,O2_102], _) :- 
	rcp_oversize_search(O1_99, O2_102, D_104, _E_),
	fd_leq(_E_, Length),
	rcp_stack_oversize_foldr_29_search(Tail, [Items,Length,O1_99,O2_102], _F_),
	rcp_assert(_F_).

rcp_stack_oversize_foldr_28([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_28([O2_102|Tail], [Items,Length,O1_99], _I_) :- 
	fd_and(_G_, _H_, _I_),
	fd_implies(_E_, _F_, _G_),
	fd_and(_A_, _D_, _E_),
	rcp_overlap(O1_99, O2_102, [1,2], _A_),
	rcp_att(uid, O1_99, _B_),
	rcp_att(uid, O2_102, _C_),
	fd_neq(_B_, _C_, _D_),
	rcp_stack_oversize_foldr_29([1,2], [Items,Length,O1_99,O2_102], _F_),
	rcp_stack_oversize_foldr_28(Tail, [Items,Length,O1_99], _H_).

rcp_stack_oversize_foldr_28_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_28_search([O2_102|Tail], [Items,Length,O1_99], _) :- 
	rcp_att(uid, O1_99, _K_),
	rcp_att(uid, O2_102, _L_),
	rcp_att(uid, O1_99, _O_),
	rcp_att(uid, O2_102, _P_),
	(
	rcp_overlap_search(O1_99, O2_102, [1,2], _J_),
	rcp_assert(_J_),
	fd_neq(_K_, _L_),
	rcp_stack_oversize_foldr_29_search([1,2], [Items,Length,O1_99,O2_102], _Q_),
	fd_equiv(_Q_, _R_, 1)
	;
	(
	rcp_overlap_search(O1_99, O2_102, [1,2], _M_),
	fd_not(_M_, _N_),
	rcp_assert(_N_)
	;
	fd_eq(_O_, _P_)
	),
	fd_aeq(_R_, 1)
	),
	rcp_assert(_R_),
	rcp_stack_oversize_foldr_28_search(Tail, [Items,Length,O1_99], _S_),
	rcp_assert(_S_).

rcp_stack_oversize_foldr_27([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_27([O1_99|Tail], [Items,Length], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_stack_oversize_foldr_28(Items, [Items,Length,O1_99], _A_),
	rcp_stack_oversize_foldr_27(Tail, [Items,Length], _B_).

rcp_stack_oversize_foldr_27_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_27_search([O1_99|Tail], [Items,Length], _) :- 
	rcp_stack_oversize_foldr_28_search(Items, [Items,Length,O1_99], _D_),
	rcp_assert(_D_),
	rcp_stack_oversize_foldr_27_search(Tail, [Items,Length], _E_),
	rcp_assert(_E_).

rcp_stack_oversize(Items, Length, _A_) :- 
	rcp_stack_oversize_foldr_27(Items, [Items,Length], _A_).

rcp_stack_oversize_search(Items, Length, _A_) :- 
	rcp_stack_oversize_foldr_27_search(Items, [Items,Length], _A_).

rcp_lighter(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_leq(_A_, _B_, _C_).

rcp_lighter_search(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_leq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_heavier(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_geq(_A_, _B_, _C_).

rcp_heavier_search(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_geq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_gravity_foldr_31([], _, 0) :- 
	!.
rcp_gravity_foldr_31([O2_107|Tail], [Items,O1_105], _G_) :- 
	fd_or(_E_, _F_, _G_),
	fd_and(_C_, _D_, _E_),
	rcp_att(uid, O1_105, _A_),
	rcp_att(uid, O2_107, _B_),
	fd_neq(_A_, _B_, _C_),
	rcp_on_top(O1_105, O2_107, _D_),
	rcp_gravity_foldr_31(Tail, [Items,O1_105], _F_).

rcp_gravity_foldr_31_search([], _, 0) :- 
	!.
rcp_gravity_foldr_31_search([O2_107|Tail], [Items,O1_105], _) :- 
	rcp_att(uid, O1_105, _H_),
	rcp_att(uid, O2_107, _I_),
	(
	fd_neq(_H_, _I_),
	rcp_on_top_search(O1_105, O2_107, _J_),
	rcp_assert(_J_)
	;
	rcp_gravity_foldr_31_search(Tail, [Items,O1_105], _K_),
	rcp_assert(_K_)
	).

rcp_gravity_foldr_30([], _, 1) :- 
	!.
rcp_gravity_foldr_30([O1_105|Tail], [Items], _F_) :- 
	fd_and(_D_, _E_, _F_),
	fd_or(_B_, _C_, _D_),
	rcp_origin(O1_105, 3, _A_),
	fd_eq(_A_, 0, _B_),
	rcp_gravity_foldr_31(Items, [Items,O1_105], _C_),
	rcp_gravity_foldr_30(Tail, [Items], _E_).

rcp_gravity_foldr_30_search([], _, 1) :- 
	!.
rcp_gravity_foldr_30_search([O1_105|Tail], [Items], _) :- 
	rcp_origin_search(O1_105, 3, _G_),
	(
	fd_eq(_G_, 0)
	;
	rcp_gravity_foldr_31_search(Items, [Items,O1_105], _H_),
	rcp_assert(_H_)
	),
	rcp_gravity_foldr_30_search(Tail, [Items], _I_),
	rcp_assert(_I_).

rcp_gravity(Items, _A_) :- 
	rcp_gravity_foldr_30(Items, [Items], _A_).

rcp_gravity_search(Items, _A_) :- 
	rcp_gravity_foldr_30_search(Items, [Items], _A_).

rcp_weight_stacking_foldr_33([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_33([O2_110|Tail], [Items,O1_108], _I_) :- 
	fd_and(_G_, _H_, _I_),
	fd_implies(_E_, _F_, _G_),
	fd_and(_C_, _D_, _E_),
	rcp_att(uid, O1_108, _A_),
	rcp_att(uid, O2_110, _B_),
	fd_neq(_A_, _B_, _C_),
	rcp_above(O1_108, O2_110, _D_),
	rcp_lighter(O1_108, O2_110, _F_),
	rcp_weight_stacking_foldr_33(Tail, [Items,O1_108], _H_).

rcp_weight_stacking_foldr_33_search([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_33_search([O2_110|Tail], [Items,O1_108], _) :- 
	rcp_att(uid, O1_108, _J_),
	rcp_att(uid, O2_110, _K_),
	rcp_att(uid, O1_108, _M_),
	rcp_att(uid, O2_110, _N_),
	(
	fd_neq(_J_, _K_),
	rcp_above_search(O1_108, O2_110, _L_),
	rcp_assert(_L_),
	rcp_lighter_search(O1_108, O2_110, _Q_),
	fd_equiv(_Q_, _R_, 1)
	;
	(
	fd_eq(_M_, _N_)
	;
	rcp_above_search(O1_108, O2_110, _O_),
	fd_not(_O_, _P_),
	rcp_assert(_P_)
	),
	fd_aeq(_R_, 1)
	),
	rcp_assert(_R_),
	rcp_weight_stacking_foldr_33_search(Tail, [Items,O1_108], _S_),
	rcp_assert(_S_).

rcp_weight_stacking_foldr_32([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_32([O1_108|Tail], [Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_weight_stacking_foldr_33(Items, [Items,O1_108], _A_),
	rcp_weight_stacking_foldr_32(Tail, [Items], _B_).

rcp_weight_stacking_foldr_32_search([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_32_search([O1_108|Tail], [Items], _) :- 
	rcp_weight_stacking_foldr_33_search(Items, [Items,O1_108], _D_),
	rcp_assert(_D_),
	rcp_weight_stacking_foldr_32_search(Tail, [Items], _E_),
	rcp_assert(_E_).

rcp_weight_stacking(Items, _A_) :- 
	rcp_weight_stacking_foldr_32(Items, [Items], _A_).

rcp_weight_stacking_search(Items, _A_) :- 
	rcp_weight_stacking_foldr_32_search(Items, [Items], _A_).

rcp_sum_foldr_34([], _, []) :- 
	!.
rcp_sum_foldr_34([Il_111|Tail], [Bin,D,Items,Ratio], [_F_|_G_]) :- 
	rcp_att(weight, Il_111, _A_),
	rcp_end(Il_111, D, _B_),
	rcp_end(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_leq(_B_, _D_, _E_),
	fd_aeq(_A_*_E_, _F_),
	rcp_sum_foldr_34(Tail, [Bin,D,Items,Ratio], _G_).

rcp_sum_foldr_34_search([], _, []) :- 
	!.
rcp_sum_foldr_34_search([Il_111|Tail], [Bin,D,Items,Ratio], [_L_|_M_]) :- 
	rcp_att(weight, Il_111, _H_),
	rcp_end_search(Il_111, D, _I_),
	rcp_end_search(Bin, D, _J_),
	fd_aeq(_J_/2, _K_),
	fd_aeq(_H_*fd_leq(_I_,_K_), _L_),
	rcp_sum_foldr_34_search(Tail, [Bin,D,Items,Ratio], _M_).

rcp_sum_foldr_35([], _, []) :- 
	!.
rcp_sum_foldr_35([Ir_115|Tail], [Bin,D,Items,L_112,Ratio], [_F_|_G_]) :- 
	rcp_att(weight, Ir_115, _A_),
	rcp_origin(Ir_115, D, _B_),
	rcp_end(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_geq(_B_, _D_, _E_),
	fd_aeq(_A_*_E_, _F_),
	rcp_sum_foldr_35(Tail, [Bin,D,Items,L_112,Ratio], _G_).

rcp_sum_foldr_35_search([], _, []) :- 
	!.
rcp_sum_foldr_35_search([Ir_115|Tail], [Bin,D,Items,L_112,Ratio], [_L_|_M_]) :- 
	rcp_att(weight, Ir_115, _H_),
	rcp_origin_search(Ir_115, D, _I_),
	rcp_end_search(Bin, D, _J_),
	fd_aeq(_J_/2, _K_),
	fd_aeq(_H_*fd_geq(_I_,_K_), _L_),
	rcp_sum_foldr_35_search(Tail, [Bin,D,Items,L_112,Ratio], _M_).

rcp_weight_balancing(Items, Bin, D, Ratio, _J_) :- 
	rcp_sum_foldr_34(Items, [Bin,D,Items,Ratio], _A_),
	rcp_sum(_A_, L_112),
	rcp_sum_foldr_35(Items, [Bin,D,Items,L_112,Ratio], _C_),
	rcp_sum(_C_, R_116),
	fd_aeq(max(L_112,R_116), _E_),
	fd_aeq(100*_E_, _F_),
	fd_aeq(100+Ratio, _G_),
	fd_aeq(min(L_112,R_116), _H_),
	fd_aeq(_G_*_H_, _I_),
	fd_leq(_F_, _I_, _J_).

rcp_weight_balancing_search(Items, Bin, D, Ratio, _J_) :- 
	rcp_sum_foldr_34_search(Items, [Bin,D,Items,Ratio], _A_),
	rcp_sum_search(_A_, L_112),
	rcp_sum_foldr_35_search(Items, [Bin,D,Items,L_112,Ratio], _C_),
	rcp_sum_search(_C_, R_116),
	fd_aeq(max(L_112,R_116), _E_),
	fd_aeq(100*_E_, _F_),
	fd_aeq(100+Ratio, _G_),
	fd_aeq(min(L_112,R_116), _H_),
	fd_aeq(_G_*_H_, _I_),
	fd_leq(_F_, _I_),
	fd_aeq(_J_, 1).

rcp_make_box(L, _A_) :- 
	rcp_rec([size=L], _A_).

rcp_make_box_search(L, _A_) :- 
	rcp_rec([size=L], _A_).

rcp_box_volume(B, _B_) :- 
	rcp_att(size, B, _A_),
	rcp_product(_A_, _B_).

rcp_box_volume_search(B, _B_) :- 
	rcp_att(size, B, _A_),
	rcp_product_search(_A_, _B_).

rcp_make_sbox(B, O, _A_) :- 
	rcp_rec([box=B,offset=O], _A_).

rcp_make_sbox_search(B, O, _A_) :- 
	rcp_rec([box=B,offset=O], _A_).

rcp_sbox_size(SB, D, _C_) :- 
	rcp_att(box, SB, _A_),
	rcp_att(size, _A_, _B_),
	nth1(D, _B_, _C_).

rcp_sbox_size_search(SB, D, _C_) :- 
	rcp_att(box, SB, _A_),
	rcp_att(size, _A_, _B_),
	nth1(D, _B_, _C_).

rcp_sbox_offset(SB, D, _B_) :- 
	rcp_att(offset, SB, _A_),
	nth1(D, _A_, _B_).

rcp_sbox_offset_search(SB, D, _B_) :- 
	rcp_att(offset, SB, _A_),
	nth1(D, _A_, _B_).

rcp_sbox_end(SB, D, _C_) :- 
	rcp_sbox_offset(SB, D, _A_),
	rcp_sbox_size(SB, D, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_sbox_end_search(SB, D, _C_) :- 
	rcp_sbox_offset_search(SB, D, _A_),
	rcp_sbox_size_search(SB, D, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_make_shape(SBs, _A_) :- 
	rcp_rec([sboxes=SBs], _A_).

rcp_make_shape_search(SBs, _A_) :- 
	rcp_rec([sboxes=SBs], _A_).

rcp_make_sbox_foldr_36([], _, []) :- 
	!.
rcp_make_sbox_foldr_36([_free_var_117|Tail], [L], [0|_A_]) :- 
	rcp_make_sbox_foldr_36(Tail, [L], _A_).

rcp_make_sbox_foldr_36_search([], _, []) :- 
	!.
rcp_make_sbox_foldr_36_search([_free_var_117|Tail], [L], [0|_B_]) :- 
	rcp_make_sbox_foldr_36_search(Tail, [L], _B_).

rcp_make_shape_box(L, _D_) :- 
	rcp_make_box(L, _A_),
	rcp_make_sbox_foldr_36(L, [L], _B_),
	rcp_make_sbox(_A_, _B_, _C_),
	rcp_make_shape([_C_], _D_).

rcp_make_shape_box_search(L, _D_) :- 
	rcp_make_box_search(L, _A_),
	rcp_make_sbox_foldr_36_search(L, [L], _B_),
	rcp_make_sbox_search(_A_, _B_, _C_),
	rcp_make_shape_search([_C_], _D_).

rcp_sum_foldr_37([], _, []) :- 
	!.
rcp_sum_foldr_37([SB_118|Tail], [S], [_B_|_C_]) :- 
	rcp_att(box, SB_118, _A_),
	rcp_box_volume(_A_, _B_),
	rcp_sum_foldr_37(Tail, [S], _C_).

rcp_sum_foldr_37_search([], _, []) :- 
	!.
rcp_sum_foldr_37_search([SB_118|Tail], [S], [_E_|_F_]) :- 
	rcp_att(box, SB_118, _D_),
	rcp_box_volume_search(_D_, _E_),
	rcp_sum_foldr_37_search(Tail, [S], _F_).

rcp_shape_volume(S, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_sum_foldr_37(_A_, [S], _B_),
	rcp_sum(_B_, _C_).

rcp_shape_volume_search(S, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_sum_foldr_37_search(_A_, [S], _B_),
	rcp_sum_search(_B_, _C_).

rcp_minimum_foldr_38([], _, []) :- 
	!.
rcp_minimum_foldr_38([SB_119|Tail], [D,S], [_A_|_B_]) :- 
	rcp_sbox_offset(SB_119, D, _A_),
	rcp_minimum_foldr_38(Tail, [D,S], _B_).

rcp_minimum_foldr_38_search([], _, []) :- 
	!.
rcp_minimum_foldr_38_search([SB_119|Tail], [D,S], [_C_|_D_]) :- 
	rcp_sbox_offset_search(SB_119, D, _C_),
	rcp_minimum_foldr_38_search(Tail, [D,S], _D_).

rcp_shape_origin(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_minimum_foldr_38(_A_, [D,S], _B_),
	rcp_minimum(_B_, _C_).

rcp_shape_origin_search(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_minimum_foldr_38_search(_A_, [D,S], _B_),
	rcp_minimum_search(_B_, _C_).

rcp_maximum_foldr_39([], _, []) :- 
	!.
rcp_maximum_foldr_39([SB_120|Tail], [D,S], [_A_|_B_]) :- 
	rcp_sbox_end(SB_120, D, _A_),
	rcp_maximum_foldr_39(Tail, [D,S], _B_).

rcp_maximum_foldr_39_search([], _, []) :- 
	!.
rcp_maximum_foldr_39_search([SB_120|Tail], [D,S], [_C_|_D_]) :- 
	rcp_sbox_end_search(SB_120, D, _C_),
	rcp_maximum_foldr_39_search(Tail, [D,S], _D_).

rcp_shape_end(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_maximum_foldr_39(_A_, [D,S], _B_),
	rcp_maximum(_B_, _C_).

rcp_shape_end_search(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_maximum_foldr_39_search(_A_, [D,S], _B_),
	rcp_maximum_search(_B_, _C_).

rcp_shape_size(S, D, _C_) :- 
	rcp_shape_end(S, D, _A_),
	rcp_shape_origin(S, D, _B_),
	fd_aeq(_A_-_B_, _C_).

rcp_shape_size_search(S, D, _C_) :- 
	rcp_shape_end_search(S, D, _A_),
	rcp_shape_origin_search(S, D, _B_),
	fd_aeq(_A_-_B_, _C_).

rcp_make_object(SL, OL, _A_) :- 
	rcp_var(from(make_object(SL,OL),0,0), Make_object_SL_OL),
	rcp_rec([shapes=SL,shape_index=Make_object_SL_OL,origin=OL], _A_).

rcp_make_object_search(SL, OL, _A_) :- 
	rcp_var(from(make_object(SL,OL),0,0), Make_object_SL_OL),
	rcp_rec([shapes=SL,shape_index=Make_object_SL_OL,origin=OL], _A_).

rcp_make_object(SL, OL, S, W, _A_) :- 
	rcp_rec([shapes=SL,shape_index=S,origin=OL,weight=W], _A_).

rcp_make_object_search(SL, OL, S, W, _A_) :- 
	rcp_rec([shapes=SL,shape_index=S,origin=OL,weight=W], _A_).

rcp_make_object_shape(S, L, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L], _A_).

rcp_make_object_shape_search(S, L, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L], _A_).

rcp_make_object_shape(S, L, W, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W], _A_).

rcp_make_object_shape_search(S, L, W, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W], _A_).

rcp_object_shape_domain(O, _E_) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	length(_B_, _C_),
	rcp_range([1.._C_], _D_),
	_A_ in _D_,
	fd_aeq(_E_, 1).

rcp_object_shape_domain_search(O, _E_) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	length(_B_, _C_),
	rcp_range([1.._C_], _D_),
	_A_ in _D_,
	fd_aeq(_E_, 1).

rcp_object_shape_domains_foldr_40([], _, 1) :- 
	!.
rcp_object_shape_domains_foldr_40([I_121|Tail], [Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_object_shape_domain(I_121, _A_),
	rcp_object_shape_domains_foldr_40(Tail, [Items], _B_).

rcp_object_shape_domains_foldr_40_search([], _, 1) :- 
	!.
rcp_object_shape_domains_foldr_40_search([I_121|Tail], [Items], _) :- 
	rcp_object_shape_domain_search(I_121, _D_),
	rcp_assert(_D_),
	rcp_object_shape_domains_foldr_40_search(Tail, [Items], _E_),
	rcp_assert(_E_).

rcp_object_shape_domains(Items, _A_) :- 
	rcp_object_shape_domains_foldr_40(Items, [Items], _A_).

rcp_object_shape_domains_search(Items, _A_) :- 
	rcp_object_shape_domains_foldr_40_search(Items, [Items], _A_).

rcp_origin(O, D, _B_) :- 
	rcp_att(origin, O, _A_),
	nth1(D, _A_, _B_).

rcp_origin_search(O, D, _B_) :- 
	rcp_att(origin, O, _A_),
	nth1(D, _A_, _B_).

rcp_x(O, _A_) :- 
	rcp_origin(O, 1, _A_).

rcp_x_search(O, _A_) :- 
	rcp_origin_search(O, 1, _A_).

rcp_y(O, _A_) :- 
	rcp_origin(O, 2, _A_).

rcp_y_search(O, _A_) :- 
	rcp_origin_search(O, 2, _A_).

rcp_z(O, _A_) :- 
	rcp_origin(O, 3, _A_).

rcp_z_search(O, _A_) :- 
	rcp_origin_search(O, 3, _A_).

rcp_sum_foldr_41([], _, []) :- 
	!.
rcp_sum_foldr_41([S_122|Tail], [D,O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_122),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_end(S_122, D, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_sum_foldr_41(Tail, [D,O], _G_).

rcp_sum_foldr_41_search([], _, []) :- 
	!.
rcp_sum_foldr_41_search([S_122|Tail], [D,O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_122),
	rcp_shape_end_search(S_122, D, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_sum_foldr_41_search(Tail, [D,O], _M_).

rcp_end(O, D, _E_) :- 
	rcp_origin(O, D, _A_),
	rcp_att(shapes, O, _B_),
	rcp_sum_foldr_41(_B_, [D,O], _C_),
	rcp_sum(_C_, _D_),
	fd_aeq(_A_+_D_, _E_).

rcp_end_search(O, D, _E_) :- 
	rcp_origin_search(O, D, _A_),
	rcp_att(shapes, O, _B_),
	rcp_sum_foldr_41_search(_B_, [D,O], _C_),
	rcp_sum_search(_C_, _D_),
	fd_aeq(_A_+_D_, _E_).

rcp_sum_foldr_42([], _, []) :- 
	!.
rcp_sum_foldr_42([S_123|Tail], [D,O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_123),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_size(S_123, D, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_sum_foldr_42(Tail, [D,O], _G_).

rcp_sum_foldr_42_search([], _, []) :- 
	!.
rcp_sum_foldr_42_search([S_123|Tail], [D,O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_123),
	rcp_shape_size_search(S_123, D, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_sum_foldr_42_search(Tail, [D,O], _M_).

rcp_size(O, D, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_sum_foldr_42(_A_, [D,O], _B_),
	rcp_sum(_B_, _C_).

rcp_size_search(O, D, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_sum_foldr_42_search(_A_, [D,O], _B_),
	rcp_sum_search(_B_, _C_).

rcp_sum_foldr_43([], _, []) :- 
	!.
rcp_sum_foldr_43([S_124|Tail], [O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_124),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_volume(S_124, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_sum_foldr_43(Tail, [O], _G_).

rcp_sum_foldr_43_search([], _, []) :- 
	!.
rcp_sum_foldr_43_search([S_124|Tail], [O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_124),
	rcp_shape_volume_search(S_124, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_sum_foldr_43_search(Tail, [O], _M_).

rcp_volume(O, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_sum_foldr_43(_A_, [O], _B_),
	rcp_sum(_B_, _C_).

rcp_volume_search(O, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_sum_foldr_43_search(_A_, [O], _B_),
	rcp_sum_search(_B_, _C_).

rcp_distance(O1, O2, D, _H_) :- 
	rcp_origin(O1, D, _A_),
	rcp_origin(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_end(O1, D, _D_),
	rcp_end(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	fd_aeq(max(0,_G_), _H_).

rcp_distance_search(O1, O2, D, _H_) :- 
	rcp_origin_search(O1, D, _A_),
	rcp_origin_search(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_end_search(O1, D, _D_),
	rcp_end_search(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	fd_aeq(max(0,_G_), _H_).

rcp_non_overlapping_binary_foldr_45([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_45([O2_127|Tail], [Dims,Items,O1_125], _H_) :- 
	fd_and(_F_, _G_, _H_),
	fd_implies(_C_, _E_, _F_),
	rcp_att(uid, O1_125, _A_),
	rcp_att(uid, O2_127, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_not(_D_, _E_),
	rcp_overlap(O1_125, O2_127, Dims, _D_),
	rcp_non_overlapping_binary_foldr_45(Tail, [Dims,Items,O1_125], _G_).

rcp_non_overlapping_binary_foldr_45_search([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_45_search([O2_127|Tail], [Dims,Items,O1_125], _) :- 
	rcp_att(uid, O1_125, _I_),
	rcp_att(uid, O2_127, _J_),
	rcp_att(uid, O1_125, _K_),
	rcp_att(uid, O2_127, _L_),
	(
	fd_lt(_I_, _J_),
	rcp_overlap_search(O1_125, O2_127, Dims, _M_),
	fd_not(_M_, _N_),
	fd_equiv(_N_, _O_, 1)
	;
	fd_geq(_K_, _L_),
	fd_aeq(_O_, 1)
	),
	rcp_assert(_O_),
	rcp_non_overlapping_binary_foldr_45_search(Tail, [Dims,Items,O1_125], _P_),
	rcp_assert(_P_).

rcp_non_overlapping_binary_foldr_44([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_44([O1_125|Tail], [Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_non_overlapping_binary_foldr_45(Items, [Dims,Items,O1_125], _A_),
	rcp_non_overlapping_binary_foldr_44(Tail, [Dims,Items], _B_).

rcp_non_overlapping_binary_foldr_44_search([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_44_search([O1_125|Tail], [Dims,Items], _) :- 
	rcp_non_overlapping_binary_foldr_45_search(Items, [Dims,Items,O1_125], _D_),
	rcp_assert(_D_),
	rcp_non_overlapping_binary_foldr_44_search(Tail, [Dims,Items], _E_),
	rcp_assert(_E_).

rcp_non_overlapping_binary(Items, Dims, _A_) :- 
	rcp_non_overlapping_binary_foldr_44(Items, [Dims,Items], _A_).

rcp_non_overlapping_binary_search(Items, Dims, _A_) :- 
	rcp_non_overlapping_binary_foldr_44_search(Items, [Dims,Items], _A_).

rcp_containmentAE_foldr_47([], _, 0) :- 
	!.
rcp_containmentAE_foldr_47([B_130|Tail], [Bins,Dims,I_128,Items], _C_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_contains_touch_rcc(B_130, I_128, Dims, _A_),
	rcp_containmentAE_foldr_47(Tail, [Bins,Dims,I_128,Items], _B_).

rcp_containmentAE_foldr_47_search([], _, 0) :- 
	!.
rcp_containmentAE_foldr_47_search([B_130|Tail], [Bins,Dims,I_128,Items], _) :- 
	(
	rcp_contains_touch_rcc_search(B_130, I_128, Dims, _D_),
	rcp_assert(_D_)
	;
	rcp_containmentAE_foldr_47_search(Tail, [Bins,Dims,I_128,Items], _E_),
	rcp_assert(_E_)
	).

rcp_containmentAE_foldr_46([], _, 1) :- 
	!.
rcp_containmentAE_foldr_46([I_128|Tail], [Bins,Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_containmentAE_foldr_47(Bins, [Bins,Dims,I_128,Items], _A_),
	rcp_containmentAE_foldr_46(Tail, [Bins,Dims,Items], _B_).

rcp_containmentAE_foldr_46_search([], _, 1) :- 
	!.
rcp_containmentAE_foldr_46_search([I_128|Tail], [Bins,Dims,Items], _) :- 
	rcp_containmentAE_foldr_47_search(Bins, [Bins,Dims,I_128,Items], _D_),
	rcp_assert(_D_),
	rcp_containmentAE_foldr_46_search(Tail, [Bins,Dims,Items], _E_),
	rcp_assert(_E_).

rcp_containmentAE(Items, Bins, Dims, _A_) :- 
	rcp_containmentAE_foldr_46(Items, [Bins,Dims,Items], _A_).

rcp_containmentAE_search(Items, Bins, Dims, _A_) :- 
	rcp_containmentAE_foldr_46_search(Items, [Bins,Dims,Items], _A_).

rcp_bin_packing_binary(Items, Bins, Dims, _D_) :- 
	fd_and(_A_, _B_, _D_),
	rcp_containmentAE(Items, Bins, Dims, _A_),
	rcp_non_overlapping_binary(Items, Dims, _B_),
	variables(Items, _C_),
	rcp_labeling(_C_).

rcp_bin_packing_binary_search(Items, Bins, Dims, _D_) :- 
	variables(Items, _C_),
	rcp_containmentAE_search(Items, Bins, Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_binary_search(Items, Dims, _B_),
	rcp_assert(_B_),
	rcp_labeling(_C_),
	fd_aeq(_D_, 1).

rcp_bin_packing(Items, Bins, Dims, _D_) :- 
	fd_and(_A_, _B_, _D_),
	rcp_containmentAE(Items, Bins, Dims, _A_),
	rcp_non_overlapping(Items, Dims, _B_),
	variables(Items, _C_),
	rcp_labeling(_C_).

rcp_bin_packing_search(Items, Bins, Dims, _D_) :- 
	variables(Items, _C_),
	rcp_containmentAE_search(Items, Bins, Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_search(Items, Dims, _B_),
	rcp_assert(_B_),
	rcp_labeling(_C_),
	fd_aeq(_D_, 1).

rcp_containmentEA_foldr_49([], _, 1) :- 
	!.
rcp_containmentEA_foldr_49([I_133|Tail], [B_131,Bins,Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains_touch_rcc(B_131, I_133, Dims, _A_),
	rcp_containmentEA_foldr_49(Tail, [B_131,Bins,Dims,Items], _B_).

rcp_containmentEA_foldr_49_search([], _, 1) :- 
	!.
rcp_containmentEA_foldr_49_search([I_133|Tail], [B_131,Bins,Dims,Items], _) :- 
	rcp_contains_touch_rcc_search(B_131, I_133, Dims, _D_),
	rcp_assert(_D_),
	rcp_containmentEA_foldr_49_search(Tail, [B_131,Bins,Dims,Items], _E_),
	rcp_assert(_E_).

rcp_containmentEA_foldr_48([], _, 0) :- 
	!.
rcp_containmentEA_foldr_48([B_131|Tail], [Bins,Dims,Items], _C_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_containmentEA_foldr_49(Items, [B_131,Bins,Dims,Items], _A_),
	rcp_containmentEA_foldr_48(Tail, [Bins,Dims,Items], _B_).

rcp_containmentEA_foldr_48_search([], _, 0) :- 
	!.
rcp_containmentEA_foldr_48_search([B_131|Tail], [Bins,Dims,Items], _) :- 
	(
	rcp_containmentEA_foldr_49_search(Items, [B_131,Bins,Dims,Items], _D_),
	rcp_assert(_D_)
	;
	rcp_containmentEA_foldr_48_search(Tail, [Bins,Dims,Items], _E_),
	rcp_assert(_E_)
	).

rcp_containmentEA(Items, Bins, Dims, _A_) :- 
	rcp_containmentEA_foldr_48(Bins, [Bins,Dims,Items], _A_).

rcp_containmentEA_search(Items, Bins, Dims, _A_) :- 
	rcp_containmentEA_foldr_48_search(Bins, [Bins,Dims,Items], _A_).

rcp_bin_design(Bin, Items, Dims, _E_) :- 
	fd_and(_A_, _B_, _E_),
	rcp_containmentEA(Items, [Bin], Dims, _A_),
	rcp_non_overlapping(Items, Dims, _B_),
	rcp_volume(Bin, _D_),
	minimize(((variables(Items,_C_),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_).

rcp_bin_design_search(Bin, Items, Dims, _E_) :- 
	rcp_volume(Bin, _D_),
	rcp_containmentEA_search(Items, [Bin], Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_search(Items, Dims, _B_),
	rcp_assert(_B_),
	minimize(((variables(Items,_C_),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_),
	fd_aeq(_E_, 1).

rcp_make_object_shape_psa(S, L, W, T, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W,piling=T], _A_).

rcp_make_object_shape_psa_search(S, L, W, T, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W,piling=T], _A_).

rcp_w(O, _A_) :- 
	rcp_size(O, 1, _A_).

rcp_w_search(O, _A_) :- 
	rcp_size_search(O, 1, _A_).

rcp_h(O, _A_) :- 
	rcp_size(O, 2, _A_).

rcp_h_search(O, _A_) :- 
	rcp_size_search(O, 2, _A_).

rcp_l(O, _A_) :- 
	rcp_size(O, 3, _A_).

rcp_l_search(O, _A_) :- 
	rcp_size_search(O, 3, _A_).

rcp_items_domain_foldr_50([], _, 1) :- 
	!.
rcp_items_domain_foldr_50([I_134|Tail], [Bin,Items], _K_) :- 
	fd_and((domain(_E_,0,_F_),domain(_H_,0,_I_)), _J_, _K_),
	rcp_x(I_134, _A_),
	variables(_A_, _B_),
	rcp_w(Bin, _C_),
	domain(_B_, 0, _C_),
	rcp_y(I_134, _D_),
	variables(_D_, _E_),
	rcp_h(Bin, _F_),
	rcp_z(I_134, _G_),
	variables(_G_, _H_),
	rcp_l(Bin, _I_),
	rcp_items_domain_foldr_50(Tail, [Bin,Items], _J_).

rcp_items_domain_foldr_50_search([], _, 1) :- 
	!.
rcp_items_domain_foldr_50_search([I_134|Tail], [Bin,Items], _) :- 
	rcp_x_search(I_134, _L_),
	variables(_L_, _M_),
	rcp_w_search(Bin, _N_),
	rcp_y_search(I_134, _O_),
	variables(_O_, _P_),
	rcp_h_search(Bin, _Q_),
	rcp_z_search(I_134, _R_),
	variables(_R_, _S_),
	rcp_l_search(Bin, _T_),
	domain(_M_, 0, _N_),
	domain(_P_, 0, _Q_),
	domain(_S_, 0, _T_),
	rcp_items_domain_foldr_50_search(Tail, [Bin,Items], _U_),
	rcp_assert(_U_).

rcp_items_domain(Items, Bin, _A_) :- 
	rcp_items_domain_foldr_50(Items, [Bin,Items], _A_).

rcp_items_domain_search(Items, Bin, _A_) :- 
	rcp_items_domain_foldr_50_search(Items, [Bin,Items], _A_).

rcp_sum_foldr_52([], _, []) :- 
	!.
rcp_sum_foldr_52([O2_137|Tail], [Items,O1_135], [_A_|_B_]) :- 
	rcp_above(O2_137, O1_135, _A_),
	rcp_sum_foldr_52(Tail, [Items,O1_135], _B_).

rcp_sum_foldr_52_search([], _, []) :- 
	!.
rcp_sum_foldr_52_search([O2_137|Tail], [Items,O1_135], [_C_|_D_]) :- 
	rcp_above_search(O2_137, O1_135, _C_),
	rcp_sum_foldr_52_search(Tail, [Items,O1_135], _D_).

rcp_cardinality_on_top_foldr_51([], _, 1) :- 
	!.
rcp_cardinality_on_top_foldr_51([O1_135|Tail], [Items], _F_) :- 
	fd_and(_D_, _E_, _F_),
	rcp_sum_foldr_52(Items, [Items,O1_135], _A_),
	rcp_sum(_A_, _B_),
	rcp_att(piling, O1_135, _C_),
	fd_leq(_B_, _C_, _D_),
	rcp_cardinality_on_top_foldr_51(Tail, [Items], _E_).

rcp_cardinality_on_top_foldr_51_search([], _, 1) :- 
	!.
rcp_cardinality_on_top_foldr_51_search([O1_135|Tail], [Items], _) :- 
	rcp_sum_foldr_52_search(Items, [Items,O1_135], _G_),
	rcp_sum_search(_G_, _H_),
	rcp_att(piling, O1_135, _I_),
	fd_leq(_H_, _I_),
	rcp_cardinality_on_top_foldr_51_search(Tail, [Items], _J_),
	rcp_assert(_J_).

rcp_cardinality_on_top(Items, _A_) :- 
	rcp_cardinality_on_top_foldr_51(Items, [Items], _A_).

rcp_cardinality_on_top_search(Items, _A_) :- 
	rcp_cardinality_on_top_foldr_51_search(Items, [Items], _A_).

solve([O2,O2_2,O2_3,O3,O3_2,O3_3]) :- 
	statistics(runtime, [_Runtime_0_|_]),
	fd_statistics(backtracks, _),
	R_138#<=>O2+4#>O2,
	R_139#<=>O2+4#>O2,
	R_140#<=>R_138#/\R_139,
	R_141#<=>O2_2+5#>O2_2,
	R_142#<=>O2_2+5#>O2_2,
	R_143#<=>R_141#/\R_142,
	R_144#<=>R_140#/\R_143,
	R_145#<=>O2_3+2#<O2_3,
	R_146#<=>R_144#/\R_145,
	R_147#<=>O2_3+2#=O2_3,
	R_148#<=>R_146#\/R_147,
	R_149#<=>O3+5#>O2,
	R_150#<=>O2+4#>O3,
	R_151#<=>R_149#/\R_150,
	R_152#<=>O3_2+4#>O2_2,
	R_153#<=>O2_2+5#>O3_2,
	R_154#<=>R_152#/\R_153,
	R_155#<=>R_151#/\R_154,
	R_156#<=>O2_3+2#<O3_3,
	R_157#<=>R_155#/\R_156,
	R_158#<=>O2_3+2#=O3_3,
	R_159#<=>R_157#\/R_158,
	R_160#<=>O2+4#>O3,
	R_161#<=>O3+5#>O2,
	R_162#<=>R_160#/\R_161,
	R_163#<=>O2_2+5#>O3_2,
	R_164#<=>O3_2+4#>O2_2,
	R_165#<=>R_163#/\R_164,
	R_166#<=>R_162#/\R_165,
	R_167#<=>O3_3+2#<O2_3,
	R_168#<=>R_166#/\R_167,
	R_169#<=>O3_3+2#=O2_3,
	R_170#<=>R_168#\/R_169,
	R_171#<=>O3+5#>O3,
	R_172#<=>O3+5#>O3,
	R_173#<=>R_171#/\R_172,
	R_174#<=>O3_2+4#>O3_2,
	R_175#<=>O3_2+4#>O3_2,
	R_176#<=>R_174#/\R_175,
	R_177#<=>R_173#/\R_176,
	R_178#<=>O3_3+2#<O3_3,
	R_179#<=>R_177#/\R_178,
	R_180#<=>O3_3+2#=O3_3,
	R_181#<=>R_179#\/R_180,
	rcp_var(from(o3,0,3), O3_3),
	rcp_var(from(o3,0,1), O3),
	rcp_var(from(o3,0,2), O3_2),
	rcp_var(from(o2,0,3), O2_3),
	rcp_var(from(o2,0,1), O2),
	rcp_var(from(o2,0,2), O2_2),
	domain([O2], 0, 5),
	domain([O2_2], 0, 5),
	domain([O2_3], 0, 4),
	domain([O3], 0, 5),
	domain([O3_2], 0, 5),
	domain([O3_3], 0, 4),
	R_148+R_159#=<0,
	R_170+R_181#=<2,
	0#=<O2,
	O2+4#=<5,
	0#=<O2_2,
	O2_2+5#=<5,
	0#=<O2_3,
	O2_3+2#=<4,
	0#=<O3,
	O3+5#=<5,
	0#=<O3_2,
	O3_2+4#=<5,
	0#=<O3_3,
	O3_3+2#=<4,
	rcp_geost([object(4,3,[O2,O2_2,O2_3],[]),object(8,7,[O3,O3_2,O3_3],[])], [sbox(3,[0,0,0],[4,5,2]),sbox(7,[0,0,0],[5,4,2])], [non_overlapping(objects([4,8]),[1,2,3])]),
	labeling([], [O3_3,O3,O3_2,O2_3,O2,O2_2]),
	statistics(runtime, [_Runtime_1_|_]),
	fd_statistics(backtracks, _Backtracks_),
	_Runtime_ is _Runtime_1_-_Runtime_0_,
	format('~3d seconds\n', [_Runtime_]),
	format('~w bactracks\n\n', [_Backtracks_]).
