:- use_module(library(clpfd)).
:- use_module('/afs/inria.fr/rocq/home/contraintes/common/src/rules2cp/interpreter/prolog/r2cp.pl').
:- init_interpreter.

rcp_rule(s1, make_shape_box([5,4,4])).
rcp_rule(s2, make_shape_box([4,5,2])).
rcp_rule(s3, make_shape_box([5,4,2])).
rcp_rule(o1, make_object_shape(s1,[0,0,0])).
rcp_rule(o2, make_object([s2,s3],[free_var('_',0,1),free_var('_',0,2),free_var('_',0,3)],free_var('_',0,4),10)).
rcp_rule(o3, make_object([s2,s3],[free_var('_',0,1),free_var('_',0,2),free_var('_',0,3)],free_var('_',0,4),11)).
rcp_rule(dimensions, [1,2,3]).
rcp_rule(bin, o1).
rcp_rule(items, [o2,o3]).
rcp_rule(sum(var('L',0)), foldr(var('X',64),var('L',0),+,0,var('X',64))).
rcp_rule(product(var('L',0)), foldr(var('X',66),var('L',0),*,1,var('X',66))).
rcp_rule(maximum(var('L',0)), foldr(var('X',68),var('L',0),max,min_integer,var('X',68))).
rcp_rule(minimum(var('L',0)), foldr(var('X',70),var('L',0),min,max_integer,var('X',70))).
rcp_rule(oversize(var('O1',0),var('O2',0),var('D',0)), max(max(origin(var('O1',0),var('D',0)),origin(var('O2',0),var('D',0)))-min(origin(var('O1',0),var('D',0)),origin(var('O2',0),var('D',0))),max(end(var('O1',0),var('D',0)),end(var('O2',0),var('D',0)))-min(end(var('O1',0),var('D',0)),end(var('O2',0),var('D',0))))).
rcp_rule(make_box(var('L',0)), rcp_rec([size=var('L',0)])).
rcp_rule(box_volume(var('B',0)), product(rcp_att(size,[var('B',0)]))).
rcp_rule(make_sbox(var('B',0),var('O',0)), rcp_rec([box=var('B',0),offset=var('O',0)])).
rcp_rule(sbox_size(var('SB',0),var('D',0)), nth(var('D',0),rcp_att(size,[rcp_att(box,[var('SB',0)])]))).
rcp_rule(sbox_offset(var('SB',0),var('D',0)), nth(var('D',0),rcp_att(offset,[var('SB',0)]))).
rcp_rule(sbox_end(var('SB',0),var('D',0)), sbox_offset(var('SB',0),var('D',0))+sbox_size(var('SB',0),var('D',0))).
rcp_rule(make_shape(var('SBs',0)), rcp_rec([sboxes=var('SBs',0)])).
rcp_rule(make_shape_box(var('L',0)), make_shape([make_sbox(make_box(var('L',0)),foldr(var('_',72),var('L',0),cons,[],0))])).
rcp_rule(shape_volume(var('S',0)), sum(foldr(var('SB',74),rcp_att(sboxes,[var('S',0)]),cons,[],box_volume(rcp_att(box,[var('SB',74)]))))).
rcp_rule(shape_origin(var('S',0),var('D',0)), minimum(foldr(var('SB',76),rcp_att(sboxes,[var('S',0)]),cons,[],sbox_offset(var('SB',76),var('D',0))))).
rcp_rule(shape_end(var('S',0),var('D',0)), maximum(foldr(var('SB',78),rcp_att(sboxes,[var('S',0)]),cons,[],sbox_end(var('SB',78),var('D',0))))).
rcp_rule(shape_size(var('S',0),var('D',0)), shape_end(var('S',0),var('D',0))-shape_origin(var('S',0),var('D',0))).
rcp_rule(make_object(var('SL',0),var('OL',0)), rcp_rec([shapes=var('SL',0),shape_index=free_var('S',0,0),origin=var('OL',0)])).
rcp_rule(make_object(var('SL',0),var('OL',0),var('S',0),var('W',0)), rcp_rec([shapes=var('SL',0),shape_index=var('S',0),origin=var('OL',0),weight=var('W',0)])).
rcp_rule(make_object_shape(var('S',0),var('L',0)), rcp_rec([shapes=[var('S',0)],shape_index=1,origin=var('L',0)])).
rcp_rule(make_object_shape(var('S',0),var('L',0),var('W',0)), rcp_rec([shapes=[var('S',0)],shape_index=1,origin=var('L',0),weight=var('W',0)])).
rcp_rule(origin(var('O',0),var('D',0)), nth(var('D',0),rcp_att(origin,[var('O',0)]))).
rcp_rule(x(var('O',0)), origin(var('O',0),1)).
rcp_rule(y(var('O',0)), origin(var('O',0),2)).
rcp_rule(z(var('O',0)), origin(var('O',0),3)).
rcp_rule(end(var('O',0),var('D',0)), origin(var('O',0),var('D',0))+sum(foldr(var('S',80),rcp_att(shapes,[var('O',0)]),cons,[],(rcp_att(shape_index,[var('O',0)])=pos(var('S',80),rcp_att(shapes,[var('O',0)])))*shape_end(var('S',80),var('D',0))))).
rcp_rule(size(var('O',0),var('D',0)), sum(foldr(var('S',82),rcp_att(shapes,[var('O',0)]),cons,[],(rcp_att(shape_index,[var('O',0)])=pos(var('S',82),rcp_att(shapes,[var('O',0)])))*shape_size(var('S',82),var('D',0))))).
rcp_rule(volume(var('O',0)), sum(foldr(var('S',84),rcp_att(shapes,[var('O',0)]),cons,[],(rcp_att(shape_index,[var('O',0)])=pos(var('S',84),rcp_att(shapes,[var('O',0)])))*shape_volume(var('S',84))))).
rcp_rule(distance(var('O1',0),var('O2',0),var('D',0)), max(0,max(origin(var('O1',0),var('D',0)),origin(var('O2',0),var('D',0)))-min(end(var('O1',0),var('D',0)),end(var('O2',0),var('D',0))))).
rcp_rule(w(var('O',0)), size(var('O',0),1)).
rcp_rule(h(var('O',0)), size(var('O',0),2)).
rcp_rule(l(var('O',0)), size(var('O',0),3)).
rcp_rule(non_overlapping(var('Items',0),var('Dims',0)), geost_constraint(foldr(var('I',94),var('Items',0),cons,[],[rcp_att(uid,[var('I',94)]),rcp_att(shape_index,[var('I',94)]),foldr(var('S',96),rcp_att(shapes,[var('I',94)]),cons,[],rcp_att(uid,[var('S',96)])),rcp_att(origin,[var('I',94)])]),foldr(var('I',97),var('Items',0),cons,[],foldr(var('S',100),rcp_att(shapes,[var('I',97)]),cons,[],foldr(var('SB',102),rcp_att(sboxes,[var('S',100)]),cons,[],[rcp_att(uid,[var('S',100)]),rcp_att(offset,[var('SB',102)]),rcp_att(size,[rcp_att(box,[var('SB',102)])])]))),length(var('Dims',0)))).
rcp_rule(precedes(var('A',0),var('B',0),var('D',0)), end(var('A',0),var('D',0))<origin(var('B',0),var('D',0))).
rcp_rule(meets(var('A',0),var('B',0),var('D',0)), end(var('A',0),var('D',0))=origin(var('B',0),var('D',0))).
rcp_rule(overlaps(var('A',0),var('B',0),var('D',0)), origin(var('A',0),var('D',0))<origin(var('B',0),var('D',0))and end(var('A',0),var('D',0))<end(var('B',0),var('D',0))and origin(var('B',0),var('D',0))<end(var('A',0),var('D',0))).
rcp_rule(contains(var('A',0),var('B',0),var('D',0)), origin(var('A',0),var('D',0))<origin(var('B',0),var('D',0))and end(var('B',0),var('D',0))<end(var('A',0),var('D',0))).
rcp_rule(starts(var('A',0),var('B',0),var('D',0)), origin(var('A',0),var('D',0))=origin(var('B',0),var('D',0))and end(var('A',0),var('D',0))<end(var('B',0),var('D',0))).
rcp_rule(finishes(var('A',0),var('B',0),var('D',0)), origin(var('B',0),var('D',0))<origin(var('A',0),var('D',0))and end(var('A',0),var('D',0))=end(var('B',0),var('D',0))).
rcp_rule(equals(var('A',0),var('B',0),var('D',0)), origin(var('A',0),var('D',0))=origin(var('B',0),var('D',0))and end(var('A',0),var('D',0))=end(var('B',0),var('D',0))).
rcp_rule(started_by(var('A',0),var('B',0),var('D',0)), origin(var('A',0),var('D',0))=origin(var('B',0),var('D',0))and end(var('B',0),var('D',0))<end(var('A',0),var('D',0))).
rcp_rule(finished_by(var('A',0),var('B',0),var('D',0)), origin(var('B',0),var('D',0))>origin(var('A',0),var('D',0))and end(var('A',0),var('D',0))=end(var('B',0),var('D',0))).
rcp_rule(during(var('A',0),var('B',0),var('D',0)), origin(var('B',0),var('D',0))<origin(var('A',0),var('D',0))and end(var('A',0),var('D',0))<end(var('B',0),var('D',0))).
rcp_rule(overlapped_by(var('A',0),var('B',0),var('D',0)), origin(var('B',0),var('D',0))<origin(var('A',0),var('D',0))and origin(var('A',0),var('D',0))<end(var('B',0),var('D',0))and end(var('A',0),var('D',0))>end(var('B',0),var('D',0))).
rcp_rule(met_by(var('A',0),var('B',0),var('D',0)), end(var('B',0),var('D',0))=origin(var('A',0),var('D',0))).
rcp_rule(preceded_by(var('A',0),var('B',0),var('D',0)), end(var('B',0),var('D',0))<origin(var('A',0),var('D',0))).
rcp_rule(contains_touch(var('A',0),var('B',0),var('D',0)), origin(var('A',0),var('D',0))=<origin(var('B',0),var('D',0))and end(var('B',0),var('D',0))=<end(var('A',0),var('D',0))).
rcp_rule(overlaps_sym(var('A',0),var('B',0),var('D',0)), end(var('A',0),var('D',0))>origin(var('B',0),var('D',0))and end(var('B',0),var('D',0))>origin(var('A',0),var('D',0))).
rcp_rule(disjoint(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',104),var('Ds',0),or,0,precedes(var('O1',0),var('O2',0),var('D',104))or preceded_by(var('O1',0),var('O2',0),var('D',104)))).
rcp_rule(meet(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',107),var('Ds',0),and,1,not precedes(var('O1',0),var('O2',0),var('D',107))and not preceded_by(var('O1',0),var('O2',0),var('D',107)))and foldl(var('D',108),var('Ds',0),or,0,meets(var('O1',0),var('O2',0),var('D',108))or met_by(var('O1',0),var('O2',0),var('D',108)))).
rcp_rule(equal(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',110),var('Ds',0),and,1,equals(var('O1',0),var('O2',0),var('D',110)))).
rcp_rule(covers(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',113),var('Ds',0),and,1,started_by(var('O1',0),var('O2',0),var('D',113))or contains(var('O1',0),var('O2',0),var('D',113))or finished_by(var('O1',0),var('O2',0),var('D',113)))and foldl(var('D',114),var('Ds',0),or,0,not contains(var('O1',0),var('O2',0),var('D',114)))).
rcp_rule(covered_by(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',117),var('Ds',0),and,1,starts(var('O1',0),var('O2',0),var('D',117))or during(var('O1',0),var('O2',0),var('D',117))or finishes(var('O1',0),var('O2',0),var('D',117)))and foldl(var('D',118),var('Ds',0),or,0,not during(var('O1',0),var('O2',0),var('D',118)))).
rcp_rule(contains_rcc(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',120),var('Ds',0),and,1,contains(var('O1',0),var('O2',0),var('D',120)))).
rcp_rule(inside(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',122),var('Ds',0),and,1,during(var('O1',0),var('O2',0),var('D',122)))).
rcp_rule(overlap(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',124),var('Ds',0),and,1,overlaps_sym(var('O1',0),var('O2',0),var('D',124)))).
rcp_rule(contains_touch_rcc(var('O1',0),var('O2',0),var('Ds',0)), foldl(var('D',126),var('Ds',0),and,1,contains_touch(var('O1',0),var('O2',0),var('D',126)))).
rcp_rule(above(var('O1',0),var('O2',0)), overlap(var('O1',0),var('O2',0),[1,2])and preceded_by(var('O1',0),var('O2',0),3)or met_by(var('O1',0),var('O2',0),3)).
rcp_rule(on_top(var('O1',0),var('O2',0)), overlap(var('O1',0),var('O2',0),[1,2])and met_by(var('O1',0),var('O2',0),3)).
rcp_rule(stack_oversize(var('Items',0),var('Length',0)), foldl(var('O1',133),var('Items',0),and,1,foldl(var('O2',136),var('Items',0),and,1,overlap(var('O1',133),var('O2',136),[1,2])and rcp_att(uid,[var('O1',133)])#rcp_att(uid,[var('O2',136)])implies foldl(var('D',138),[1,2],and,1,oversize(var('O1',133),var('O2',136),var('D',138))=<var('Length',0))))).
rcp_rule(lighter(var('O1',0),var('O2',0)), rcp_att(weight,[var('O1',0)])=<rcp_att(weight,[var('O2',0)])).
rcp_rule(heavier(var('O1',0),var('O2',0)), rcp_att(weight,[var('O1',0)])>=rcp_att(weight,[var('O2',0)])).
rcp_rule(gravity(var('Items',0)), foldl(var('O1',142),var('Items',0),and,1,origin(var('O1',142),3)=0 or foldl(var('O2',144),var('Items',0),or,0,rcp_att(uid,[var('O1',142)])#rcp_att(uid,[var('O2',144)])and on_top(var('O1',142),var('O2',144))))).
rcp_rule(weight_stacking(var('Items',0)), foldl(var('O1',148),var('Items',0),and,1,foldl(var('O2',150),var('Items',0),and,1,rcp_att(uid,[var('O1',148)])#rcp_att(uid,[var('O2',150)])and above(var('O1',148),var('O2',150))implies lighter(var('O1',148),var('O2',150))))).
rcp_rule(weight_balancing(var('Items',0),var('Bin',0),var('D',0),var('Ratio',0)), let(var('L',158),sum(foldr(var('Il',157),var('Items',0),cons,[],rcp_att(weight,[var('Il',157)])*(end(var('Il',157),var('D',0))=<end(var('Bin',0),var('D',0))/2))),let(var('R',162),sum(foldr(var('Ir',161),var('Items',0),cons,[],rcp_att(weight,[var('Ir',161)])*(origin(var('Ir',161),var('D',0))>=end(var('Bin',0),var('D',0))/2))),100*max(var('L',158),var('R',162))=<(100+var('Ratio',0))*min(var('L',158),var('R',162))))).
rcp_rule(object_shape_domain(var('O',0)), rcp_att(shape_index,[var('O',0)])in[1..length(rcp_att(shapes,[var('O',0)]))]).
rcp_rule(object_shape_domains(var('Items',0)), foldl(var('I',164),var('Items',0),and,1,object_shape_domain(var('I',164)))).
rcp_rule(non_overlapping_binary(var('Items',0),var('Dims',0)), foldl(var('O1',168),var('Items',0),and,1,foldl(var('O2',170),var('Items',0),and,1,rcp_att(uid,[var('O1',168)])<rcp_att(uid,[var('O2',170)])implies not overlap(var('O1',168),var('O2',170),var('Dims',0))))).
rcp_rule(containmentAE(var('Items',0),var('Bins',0),var('Dims',0)), foldl(var('I',174),var('Items',0),and,1,foldl(var('B',176),var('Bins',0),or,0,contains_touch_rcc(var('B',176),var('I',174),var('Dims',0))))).
rcp_rule(bin_packing_binary(var('Items',0),var('Bins',0),var('Dims',0)), containmentAE(var('Items',0),var('Bins',0),var('Dims',0))and non_overlapping_binary(var('Items',0),var('Dims',0))and labeling(variables(var('Items',0)))).
rcp_rule(bin_packing(var('Items',0),var('Bins',0),var('Dims',0)), containmentAE(var('Items',0),var('Bins',0),var('Dims',0))and non_overlapping(var('Items',0),var('Dims',0))and labeling(variables(var('Items',0)))).
rcp_rule(containmentEA(var('Items',0),var('Bins',0),var('Dims',0)), foldl(var('B',180),var('Bins',0),or,0,foldl(var('I',182),var('Items',0),and,1,contains_touch_rcc(var('B',180),var('I',182),var('Dims',0))))).
rcp_rule(bin_design(var('Bin',0),var('Items',0),var('Dims',0)), containmentEA(var('Items',0),[var('Bin',0)],var('Dims',0))and non_overlapping(var('Items',0),var('Dims',0))and minimize(search(labeling(variables(var('Items',0)))),volume(var('Bin',0)))).
rcp_rule(items_domain(var('Items',0),var('Bin',0)), foldl(var('I',184),var('Items',0),and,1,domain(variables(x(var('I',184))),0,w(var('Bin',0)))and domain(variables(y(var('I',184))),0,h(var('Bin',0)))and domain(variables(z(var('I',184))),0,l(var('Bin',0))))).
rcp_rule(solve_query, items_domain(items,bin)and object_shape_domains(items)and variable_ordering([greatest(rcp_att(weight,[^])),is(rcp_att(shape_index,[^])),is(z(^))])and bin_packing(items,[bin],dimensions)).


rcp_s1(_A_) :- 
	rcp_make_shape_box([5,4,4], _A_).

rcp_s1_search(_A_) :- 
	rcp_make_shape_box_search([5,4,4], _A_).

rcp_s2(_A_) :- 
	rcp_make_shape_box([4,5,2], _A_).

rcp_s2_search(_A_) :- 
	rcp_make_shape_box_search([4,5,2], _A_).

rcp_s3(_A_) :- 
	rcp_make_shape_box([5,4,2], _A_).

rcp_s3_search(_A_) :- 
	rcp_make_shape_box_search([5,4,2], _A_).

rcp_o1(_B_) :- 
	rcp_s1(_A_),
	rcp_make_object_shape(_A_, [0,0,0], _B_).

rcp_o1_search(_B_) :- 
	rcp_s1_search(_A_),
	rcp_make_object_shape_search(_A_, [0,0,0], _B_).

rcp_o2(_C_) :- 
	rcp_s2(_A_),
	rcp_s3(_B_),
	rcp_var(from(o2,0,1), O2),
	rcp_var(from(o2,0,2), O2_2),
	rcp_var(from(o2,0,3), O2_3),
	rcp_var(from(o2,0,4), O2_4),
	rcp_make_object([_A_,_B_], [O2,O2_2,O2_3], O2_4, 10, _C_).

rcp_o2_search(_C_) :- 
	rcp_s2_search(_A_),
	rcp_s3_search(_B_),
	rcp_var(from(o2,0,1), O2),
	rcp_var(from(o2,0,2), O2_2),
	rcp_var(from(o2,0,3), O2_3),
	rcp_var(from(o2,0,4), O2_4),
	rcp_make_object_search([_A_,_B_], [O2,O2_2,O2_3], O2_4, 10, _C_).

rcp_o3(_C_) :- 
	rcp_s2(_A_),
	rcp_s3(_B_),
	rcp_var(from(o3,0,1), O3),
	rcp_var(from(o3,0,2), O3_2),
	rcp_var(from(o3,0,3), O3_3),
	rcp_var(from(o3,0,4), O3_4),
	rcp_make_object([_A_,_B_], [O3,O3_2,O3_3], O3_4, 11, _C_).

rcp_o3_search(_C_) :- 
	rcp_s2_search(_A_),
	rcp_s3_search(_B_),
	rcp_var(from(o3,0,1), O3),
	rcp_var(from(o3,0,2), O3_2),
	rcp_var(from(o3,0,3), O3_3),
	rcp_var(from(o3,0,4), O3_4),
	rcp_make_object_search([_A_,_B_], [O3,O3_2,O3_3], O3_4, 11, _C_).

rcp_dimensions(_A_) :- 
	_A_=[1,2,3].

rcp_dimensions_search(_A_) :- 
	_A_=[1,2,3].

rcp_bin(_A_) :- 
	rcp_o1(_A_).

rcp_bin_search(_A_) :- 
	rcp_o1_search(_A_).

rcp_items(_C_) :- 
	rcp_o2(_A_),
	rcp_o3(_B_),
	_C_=[_A_,_B_].

rcp_items_search(_C_) :- 
	rcp_o2_search(_A_),
	rcp_o3_search(_B_),
	_C_=[_A_,_B_].

rcp_sum_foldr_1([], _, 0) :- 
	!.
rcp_sum_foldr_1([X_63|Tail], [L], _B_) :- 
	rcp_sum_foldr_1(Tail, [L], _A_),
	fd_aeq(X_63+_A_, _B_).

rcp_sum_foldr_1_search([], _, 0) :- 
	!.
rcp_sum_foldr_1_search([X_63|Tail], [L], _B_) :- 
	rcp_sum_foldr_1_search(Tail, [L], _A_),
	fd_aeq(X_63+_A_, _B_).

rcp_sum(L, _A_) :- 
	rcp_sum_foldr_1(L, [L], _A_).

rcp_sum_search(L, _A_) :- 
	rcp_sum_foldr_1_search(L, [L], _A_).

rcp_product_foldr_1([], _, 1) :- 
	!.
rcp_product_foldr_1([X_65|Tail], [L], _B_) :- 
	rcp_product_foldr_1(Tail, [L], _A_),
	fd_aeq(X_65*_A_, _B_).

rcp_product_foldr_1_search([], _, 1) :- 
	!.
rcp_product_foldr_1_search([X_65|Tail], [L], _B_) :- 
	rcp_product_foldr_1_search(Tail, [L], _A_),
	fd_aeq(X_65*_A_, _B_).

rcp_product(L, _A_) :- 
	rcp_product_foldr_1(L, [L], _A_).

rcp_product_search(L, _A_) :- 
	rcp_product_foldr_1_search(L, [L], _A_).

rcp_maximum_foldr_1([], _, -2147483616) :- 
	!.
rcp_maximum_foldr_1([X_67|Tail], [L], _B_) :- 
	rcp_maximum_foldr_1(Tail, [L], _A_),
	fd_aeq(max(X_67,_A_), _B_).

rcp_maximum_foldr_1_search([], _, -2147483616) :- 
	!.
rcp_maximum_foldr_1_search([X_67|Tail], [L], _B_) :- 
	rcp_maximum_foldr_1_search(Tail, [L], _A_),
	fd_aeq(max(X_67,_A_), _B_).

rcp_maximum(L, _A_) :- 
	rcp_maximum_foldr_1(L, [L], _A_).

rcp_maximum_search(L, _A_) :- 
	rcp_maximum_foldr_1_search(L, [L], _A_).

rcp_minimum_foldr_1([], _, 2147483616) :- 
	!.
rcp_minimum_foldr_1([X_69|Tail], [L], _B_) :- 
	rcp_minimum_foldr_1(Tail, [L], _A_),
	fd_aeq(min(X_69,_A_), _B_).

rcp_minimum_foldr_1_search([], _, 2147483616) :- 
	!.
rcp_minimum_foldr_1_search([X_69|Tail], [L], _B_) :- 
	rcp_minimum_foldr_1_search(Tail, [L], _A_),
	fd_aeq(min(X_69,_A_), _B_).

rcp_minimum(L, _A_) :- 
	rcp_minimum_foldr_1(L, [L], _A_).

rcp_minimum_search(L, _A_) :- 
	rcp_minimum_foldr_1_search(L, [L], _A_).

rcp_oversize(O1, O2, D, _O_) :- 
	rcp_origin(O1, D, _A_),
	rcp_origin(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_origin(O1, D, _D_),
	rcp_origin(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	rcp_end(O1, D, _H_),
	rcp_end(O2, D, _I_),
	fd_aeq(max(_H_,_I_), _J_),
	rcp_end(O1, D, _K_),
	rcp_end(O2, D, _L_),
	fd_aeq(min(_K_,_L_), _M_),
	fd_aeq(_J_-_M_, _N_),
	fd_aeq(max(_G_,_N_), _O_).

rcp_oversize_search(O1, O2, D, _O_) :- 
	rcp_origin_search(O1, D, _A_),
	rcp_origin_search(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_origin_search(O1, D, _D_),
	rcp_origin_search(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	rcp_end_search(O1, D, _H_),
	rcp_end_search(O2, D, _I_),
	fd_aeq(max(_H_,_I_), _J_),
	rcp_end_search(O1, D, _K_),
	rcp_end_search(O2, D, _L_),
	fd_aeq(min(_K_,_L_), _M_),
	fd_aeq(_J_-_M_, _N_),
	fd_aeq(max(_G_,_N_), _O_).

rcp_make_box(L, _A_) :- 
	rcp_rec([size=L], _A_).

rcp_make_box_search(L, _A_) :- 
	rcp_rec([size=L], _A_).

rcp_box_volume(B, _B_) :- 
	rcp_att(size, B, _A_),
	rcp_product(_A_, _B_).

rcp_box_volume_search(B, _B_) :- 
	rcp_att(size, B, _A_),
	rcp_product_search(_A_, _B_).

rcp_make_sbox(B, O, _A_) :- 
	rcp_rec([box=B,offset=O], _A_).

rcp_make_sbox_search(B, O, _A_) :- 
	rcp_rec([box=B,offset=O], _A_).

rcp_sbox_size(SB, D, _C_) :- 
	rcp_att(box, SB, _A_),
	rcp_att(size, _A_, _B_),
	nth1(D, _B_, _C_).

rcp_sbox_size_search(SB, D, _C_) :- 
	rcp_att(box, SB, _A_),
	rcp_att(size, _A_, _B_),
	nth1(D, _B_, _C_).

rcp_sbox_offset(SB, D, _B_) :- 
	rcp_att(offset, SB, _A_),
	nth1(D, _A_, _B_).

rcp_sbox_offset_search(SB, D, _B_) :- 
	rcp_att(offset, SB, _A_),
	nth1(D, _A_, _B_).

rcp_sbox_end(SB, D, _C_) :- 
	rcp_sbox_offset(SB, D, _A_),
	rcp_sbox_size(SB, D, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_sbox_end_search(SB, D, _C_) :- 
	rcp_sbox_offset_search(SB, D, _A_),
	rcp_sbox_size_search(SB, D, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_make_shape(SBs, _A_) :- 
	rcp_rec([sboxes=SBs], _A_).

rcp_make_shape_search(SBs, _A_) :- 
	rcp_rec([sboxes=SBs], _A_).

rcp_make_shape_box_foldr_1([], _, []) :- 
	!.
rcp_make_shape_box_foldr_1([_free_var_71|Tail], [L], [0|_A_]) :- 
	rcp_make_shape_box_foldr_1(Tail, [L], _A_).

rcp_make_shape_box_foldr_1_search([], _, []) :- 
	!.
rcp_make_shape_box_foldr_1_search([_free_var_71|Tail], [L], [0|_A_]) :- 
	rcp_make_shape_box_foldr_1_search(Tail, [L], _A_).

rcp_make_shape_box(L, _D_) :- 
	rcp_make_box(L, _A_),
	rcp_make_shape_box_foldr_1(L, [L], _B_),
	rcp_make_sbox(_A_, _B_, _C_),
	rcp_make_shape([_C_], _D_).

rcp_make_shape_box_search(L, _D_) :- 
	rcp_make_box_search(L, _A_),
	rcp_make_shape_box_foldr_1_search(L, [L], _B_),
	rcp_make_sbox_search(_A_, _B_, _C_),
	rcp_make_shape_search([_C_], _D_).

rcp_shape_volume_foldr_1([], _, []) :- 
	!.
rcp_shape_volume_foldr_1([SB_73|Tail], [S], [_B_|_C_]) :- 
	rcp_shape_volume_foldr_1(Tail, [S], _C_),
	rcp_att(box, SB_73, _A_),
	rcp_box_volume(_A_, _B_).

rcp_shape_volume_foldr_1_search([], _, []) :- 
	!.
rcp_shape_volume_foldr_1_search([SB_73|Tail], [S], [_B_|_C_]) :- 
	rcp_shape_volume_foldr_1_search(Tail, [S], _C_),
	rcp_att(box, SB_73, _A_),
	rcp_box_volume_search(_A_, _B_).

rcp_shape_volume(S, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_volume_foldr_1(_A_, [S], _B_),
	rcp_sum(_B_, _C_).

rcp_shape_volume_search(S, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_volume_foldr_1_search(_A_, [S], _B_),
	rcp_sum_search(_B_, _C_).

rcp_shape_origin_foldr_1([], _, []) :- 
	!.
rcp_shape_origin_foldr_1([SB_75|Tail], [D,S], [_A_|_B_]) :- 
	rcp_shape_origin_foldr_1(Tail, [D,S], _B_),
	rcp_sbox_offset(SB_75, D, _A_).

rcp_shape_origin_foldr_1_search([], _, []) :- 
	!.
rcp_shape_origin_foldr_1_search([SB_75|Tail], [D,S], [_A_|_B_]) :- 
	rcp_shape_origin_foldr_1_search(Tail, [D,S], _B_),
	rcp_sbox_offset_search(SB_75, D, _A_).

rcp_shape_origin(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_origin_foldr_1(_A_, [D,S], _B_),
	rcp_minimum(_B_, _C_).

rcp_shape_origin_search(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_origin_foldr_1_search(_A_, [D,S], _B_),
	rcp_minimum_search(_B_, _C_).

rcp_shape_end_foldr_1([], _, []) :- 
	!.
rcp_shape_end_foldr_1([SB_77|Tail], [D,S], [_A_|_B_]) :- 
	rcp_shape_end_foldr_1(Tail, [D,S], _B_),
	rcp_sbox_end(SB_77, D, _A_).

rcp_shape_end_foldr_1_search([], _, []) :- 
	!.
rcp_shape_end_foldr_1_search([SB_77|Tail], [D,S], [_A_|_B_]) :- 
	rcp_shape_end_foldr_1_search(Tail, [D,S], _B_),
	rcp_sbox_end_search(SB_77, D, _A_).

rcp_shape_end(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_end_foldr_1(_A_, [D,S], _B_),
	rcp_maximum(_B_, _C_).

rcp_shape_end_search(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_end_foldr_1_search(_A_, [D,S], _B_),
	rcp_maximum_search(_B_, _C_).

rcp_shape_size(S, D, _C_) :- 
	rcp_shape_end(S, D, _A_),
	rcp_shape_origin(S, D, _B_),
	fd_aeq(_A_-_B_, _C_).

rcp_shape_size_search(S, D, _C_) :- 
	rcp_shape_end_search(S, D, _A_),
	rcp_shape_origin_search(S, D, _B_),
	fd_aeq(_A_-_B_, _C_).

rcp_make_object(SL, OL, _A_) :- 
	rcp_var(from(make_object(SL,OL),0,0), Make_object_SL_OL),
	rcp_rec([shapes=SL,shape_index=Make_object_SL_OL,origin=OL], _A_).

rcp_make_object_search(SL, OL, _A_) :- 
	rcp_var(from(make_object(SL,OL),0,0), Make_object_SL_OL),
	rcp_rec([shapes=SL,shape_index=Make_object_SL_OL,origin=OL], _A_).

rcp_make_object(SL, OL, S, W, _A_) :- 
	rcp_rec([shapes=SL,shape_index=S,origin=OL,weight=W], _A_).

rcp_make_object_search(SL, OL, S, W, _A_) :- 
	rcp_rec([shapes=SL,shape_index=S,origin=OL,weight=W], _A_).

rcp_make_object_shape(S, L, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L], _A_).

rcp_make_object_shape_search(S, L, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L], _A_).

rcp_make_object_shape(S, L, W, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W], _A_).

rcp_make_object_shape_search(S, L, W, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W], _A_).

rcp_origin(O, D, _B_) :- 
	rcp_att(origin, O, _A_),
	nth1(D, _A_, _B_).

rcp_origin_search(O, D, _B_) :- 
	rcp_att(origin, O, _A_),
	nth1(D, _A_, _B_).

rcp_x(O, _A_) :- 
	rcp_origin(O, 1, _A_).

rcp_x_search(O, _A_) :- 
	rcp_origin_search(O, 1, _A_).

rcp_y(O, _A_) :- 
	rcp_origin(O, 2, _A_).

rcp_y_search(O, _A_) :- 
	rcp_origin_search(O, 2, _A_).

rcp_z(O, _A_) :- 
	rcp_origin(O, 3, _A_).

rcp_z_search(O, _A_) :- 
	rcp_origin_search(O, 3, _A_).

rcp_end_foldr_1([], _, []) :- 
	!.
rcp_end_foldr_1([S_79|Tail], [D,O], [_F_|_G_]) :- 
	rcp_end_foldr_1(Tail, [D,O], _G_),
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_79),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_end(S_79, D, _E_),
	fd_aeq(_D_*_E_, _F_).

rcp_end_foldr_1_search([], _, []) :- 
	!.
rcp_end_foldr_1_search([S_79|Tail], [D,O], [_E_|_F_]) :- 
	rcp_end_foldr_1_search(Tail, [D,O], _F_),
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_79),
	rcp_shape_end_search(S_79, D, _D_),
	fd_aeq(fd_eq(_A_,_C_)*_D_, _E_).

rcp_end(O, D, _E_) :- 
	rcp_origin(O, D, _A_),
	rcp_att(shapes, O, _B_),
	rcp_end_foldr_1(_B_, [D,O], _C_),
	rcp_sum(_C_, _D_),
	fd_aeq(_A_+_D_, _E_).

rcp_end_search(O, D, _E_) :- 
	rcp_origin_search(O, D, _A_),
	rcp_att(shapes, O, _B_),
	rcp_end_foldr_1_search(_B_, [D,O], _C_),
	rcp_sum_search(_C_, _D_),
	fd_aeq(_A_+_D_, _E_).

rcp_size_foldr_1([], _, []) :- 
	!.
rcp_size_foldr_1([S_81|Tail], [D,O], [_F_|_G_]) :- 
	rcp_size_foldr_1(Tail, [D,O], _G_),
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_81),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_size(S_81, D, _E_),
	fd_aeq(_D_*_E_, _F_).

rcp_size_foldr_1_search([], _, []) :- 
	!.
rcp_size_foldr_1_search([S_81|Tail], [D,O], [_E_|_F_]) :- 
	rcp_size_foldr_1_search(Tail, [D,O], _F_),
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_81),
	rcp_shape_size_search(S_81, D, _D_),
	fd_aeq(fd_eq(_A_,_C_)*_D_, _E_).

rcp_size(O, D, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_size_foldr_1(_A_, [D,O], _B_),
	rcp_sum(_B_, _C_).

rcp_size_search(O, D, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_size_foldr_1_search(_A_, [D,O], _B_),
	rcp_sum_search(_B_, _C_).

rcp_volume_foldr_1([], _, []) :- 
	!.
rcp_volume_foldr_1([S_83|Tail], [O], [_F_|_G_]) :- 
	rcp_volume_foldr_1(Tail, [O], _G_),
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_83),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_volume(S_83, _E_),
	fd_aeq(_D_*_E_, _F_).

rcp_volume_foldr_1_search([], _, []) :- 
	!.
rcp_volume_foldr_1_search([S_83|Tail], [O], [_E_|_F_]) :- 
	rcp_volume_foldr_1_search(Tail, [O], _F_),
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_83),
	rcp_shape_volume_search(S_83, _D_),
	fd_aeq(fd_eq(_A_,_C_)*_D_, _E_).

rcp_volume(O, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_volume_foldr_1(_A_, [O], _B_),
	rcp_sum(_B_, _C_).

rcp_volume_search(O, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_volume_foldr_1_search(_A_, [O], _B_),
	rcp_sum_search(_B_, _C_).

rcp_distance(O1, O2, D, _H_) :- 
	rcp_origin(O1, D, _A_),
	rcp_origin(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_end(O1, D, _D_),
	rcp_end(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	fd_aeq(max(0,_G_), _H_).

rcp_distance_search(O1, O2, D, _H_) :- 
	rcp_origin_search(O1, D, _A_),
	rcp_origin_search(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_end_search(O1, D, _D_),
	rcp_end_search(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	fd_aeq(max(0,_G_), _H_).

rcp_w(O, _A_) :- 
	rcp_size(O, 1, _A_).

rcp_w_search(O, _A_) :- 
	rcp_size_search(O, 1, _A_).

rcp_h(O, _A_) :- 
	rcp_size(O, 2, _A_).

rcp_h_search(O, _A_) :- 
	rcp_size_search(O, 2, _A_).

rcp_l(O, _A_) :- 
	rcp_size(O, 3, _A_).

rcp_l_search(O, _A_) :- 
	rcp_size_search(O, 3, _A_).

rcp_geost_constraint_foldr_2([], _, []) :- 
	!.
rcp_geost_constraint_foldr_2([S_87|Tail], [Dims,I_85,Items], [_A_|_B_]) :- 
	rcp_geost_constraint_foldr_2(Tail, [Dims,I_85,Items], _B_),
	rcp_att(uid, S_87, _A_).

rcp_geost_constraint_foldr_2_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_2_search([S_87|Tail], [Dims,I_85,Items], [_A_|_B_]) :- 
	rcp_geost_constraint_foldr_2_search(Tail, [Dims,I_85,Items], _B_),
	rcp_att(uid, S_87, _A_).

rcp_geost_constraint_foldr_1([], _, []) :- 
	!.
rcp_geost_constraint_foldr_1([I_85|Tail], [Dims,Items], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_geost_constraint_foldr_1(Tail, [Dims,Items], _F_),
	rcp_att(uid, I_85, _A_),
	rcp_att(shape_index, I_85, _B_),
	rcp_att(shapes, I_85, _C_),
	rcp_geost_constraint_foldr_2(_C_, [Dims,I_85,Items], _D_),
	rcp_att(origin, I_85, _E_).

rcp_geost_constraint_foldr_1_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_1_search([I_85|Tail], [Dims,Items], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_geost_constraint_foldr_1_search(Tail, [Dims,Items], _F_),
	rcp_att(uid, I_85, _A_),
	rcp_att(shape_index, I_85, _B_),
	rcp_att(shapes, I_85, _C_),
	rcp_geost_constraint_foldr_2_search(_C_, [Dims,I_85,Items], _D_),
	rcp_att(origin, I_85, _E_).

rcp_geost_constraint_foldr_5([], _, []) :- 
	!.
rcp_geost_constraint_foldr_5([SB_93|Tail], [Dims,I_88,Items,S_91], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_geost_constraint_foldr_5(Tail, [Dims,I_88,Items,S_91], _E_),
	rcp_att(uid, S_91, _A_),
	rcp_att(offset, SB_93, _B_),
	rcp_att(box, SB_93, _C_),
	rcp_att(size, _C_, _D_).

rcp_geost_constraint_foldr_5_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_5_search([SB_93|Tail], [Dims,I_88,Items,S_91], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_geost_constraint_foldr_5_search(Tail, [Dims,I_88,Items,S_91], _E_),
	rcp_att(uid, S_91, _A_),
	rcp_att(offset, SB_93, _B_),
	rcp_att(box, SB_93, _C_),
	rcp_att(size, _C_, _D_).

rcp_geost_constraint_foldr_4([], _, []) :- 
	!.
rcp_geost_constraint_foldr_4([S_91|Tail], [Dims,I_88,Items], [_B_|_C_]) :- 
	rcp_geost_constraint_foldr_4(Tail, [Dims,I_88,Items], _C_),
	rcp_att(sboxes, S_91, _A_),
	rcp_geost_constraint_foldr_5(_A_, [Dims,I_88,Items,S_91], _B_).

rcp_geost_constraint_foldr_4_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_4_search([S_91|Tail], [Dims,I_88,Items], [_B_|_C_]) :- 
	rcp_geost_constraint_foldr_4_search(Tail, [Dims,I_88,Items], _C_),
	rcp_att(sboxes, S_91, _A_),
	rcp_geost_constraint_foldr_5_search(_A_, [Dims,I_88,Items,S_91], _B_).

rcp_geost_constraint_foldr_3([], _, []) :- 
	!.
rcp_geost_constraint_foldr_3([I_88|Tail], [Dims,Items], [_B_|_C_]) :- 
	rcp_geost_constraint_foldr_3(Tail, [Dims,Items], _C_),
	rcp_att(shapes, I_88, _A_),
	rcp_geost_constraint_foldr_4(_A_, [Dims,I_88,Items], _B_).

rcp_geost_constraint_foldr_3_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_3_search([I_88|Tail], [Dims,Items], [_B_|_C_]) :- 
	rcp_geost_constraint_foldr_3_search(Tail, [Dims,Items], _C_),
	rcp_att(shapes, I_88, _A_),
	rcp_geost_constraint_foldr_4_search(_A_, [Dims,I_88,Items], _B_).

rcp_non_overlapping(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_1(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_3(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_non_overlapping_search(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_1_search(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_3_search(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_precedes(A, B, D, _C_) :- 
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_).

rcp_precedes_search(A, B, D, _C_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	fd_lt(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_meets(A, B, D, _C_) :- 
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_).

rcp_meets_search(A, B, D, _C_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	fd_eq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_overlaps(A, B, D, _K_) :- 
	fd_and(_G_, _J_, _K_),
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_),
	rcp_origin(B, D, _H_),
	rcp_end(A, D, _I_),
	fd_lt(_H_, _I_, _J_).

rcp_overlaps_search(A, B, D, _G_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	rcp_origin_search(B, D, _E_),
	rcp_end_search(A, D, _F_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_lt(_E_, _F_),
	fd_aeq(_G_, 1).

rcp_contains(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_contains_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_starts(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_starts_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_eq(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_finishes(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_finishes_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_lt(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_equals(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_equals_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_eq(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_started_by(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_started_by_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_eq(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_finished_by(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_gt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_finished_by_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_gt(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_during(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_during_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_overlapped_by(A, B, D, _K_) :- 
	fd_and(_G_, _J_, _K_),
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_origin(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_),
	rcp_end(A, D, _H_),
	rcp_end(B, D, _I_),
	fd_gt(_H_, _I_, _J_).

rcp_overlapped_by_search(A, B, D, _G_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_origin_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	rcp_end_search(A, D, _E_),
	rcp_end_search(B, D, _F_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_gt(_E_, _F_),
	fd_aeq(_G_, 1).

rcp_met_by(A, B, D, _C_) :- 
	rcp_end(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_eq(_A_, _B_, _C_).

rcp_met_by_search(A, B, D, _C_) :- 
	rcp_end_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	fd_eq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_preceded_by(A, B, D, _C_) :- 
	rcp_end(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_).

rcp_preceded_by_search(A, B, D, _C_) :- 
	rcp_end_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	fd_lt(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_contains_touch(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_leq(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_leq(_D_, _E_, _F_).

rcp_contains_touch_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_leq(_A_, _B_),
	fd_leq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_overlaps_sym(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_gt(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_origin(A, D, _E_),
	fd_gt(_D_, _E_, _F_).

rcp_overlaps_sym_search(A, B, D, _E_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_origin_search(A, D, _D_),
	fd_gt(_A_, _B_),
	fd_gt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_disjoint_foldl_1([], I_or, _, I_or) :- 
	!.
rcp_disjoint_foldl_1([D_103|Tail], I_or, [Ds,O1,O2], _D_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_precedes(O1, O2, D_103, _A_),
	rcp_preceded_by(O1, O2, D_103, _B_),
	fd_or(I_or, _C_, _E_),
	rcp_disjoint_foldl_1(Tail, _E_, [Ds,O1,O2], _D_).

rcp_disjoint_foldl_1_search([], I_or, _, I_or) :- 
	!.
rcp_disjoint_foldl_1_search([D_103|Tail], I_or, [Ds,O1,O2], _C_) :- 
	(
	rcp_assert(I_or)
	;
	rcp_rcp_precedes_search_search(O1, O2, D_103, _A_, _D_),
	rcp_rcp_assert_search(_A_, _E_),
	rcp_,(_D_, _E_, _F_),
	rcp_rcp_preceded_by_search_search(O1, O2, D_103, _B_, _G_),
	rcp_rcp_assert_search(_B_, _H_),
	rcp_,(_G_, _H_, _I_),
	rcp_;(_F_, _I_, _J_),
	rcp_assert(_J_)
	),
	rcp_disjoint_foldl_1_search(Tail, _K_, [Ds,O1,O2], _C_).

rcp_disjoint(O1, O2, Ds, _A_) :- 
	rcp_disjoint_foldl_1(Ds, 0, [Ds,O1,O2], _A_).

rcp_disjoint_search(O1, O2, Ds, _A_) :- 
	rcp_disjoint_foldl_1_search(Ds, 0, [Ds,O1,O2], _A_).

rcp_meet_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_meet_foldl_1([D_105|Tail], I_and, [Ds,O1,O2], _F_) :- 
	fd_and(_B_, _D_, _E_),
	fd_not(_A_, _B_),
	rcp_precedes(O1, O2, D_105, _A_),
	fd_not(_C_, _D_),
	rcp_preceded_by(O1, O2, D_105, _C_),
	fd_and(I_and, _E_, _G_),
	rcp_meet_foldl_1(Tail, _G_, [Ds,O1,O2], _F_).

rcp_meet_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_meet_foldl_1_search([D_105|Tail], I_and, [Ds,O1,O2], _E_) :- 
	rcp_assert(I_and),
	rcp_rcp_precedes_search_search(O1, O2, D_105, _A_, _F_),
	rcp_fd_not_search(_A_, _B_, _G_),
	rcp_rcp_assert_search(_B_, _H_),
	rcp_,(_G_, _H_, _I_),
	rcp_,(_F_, _I_, _J_),
	rcp_rcp_preceded_by_search_search(O1, O2, D_105, _C_, _K_),
	rcp_fd_not_search(_C_, _D_, _L_),
	rcp_rcp_assert_search(_D_, _M_),
	rcp_,(_L_, _M_, _N_),
	rcp_,(_K_, _N_, _O_),
	rcp_,(_J_, _O_, _P_),
	rcp_assert(_P_),
	rcp_meet_foldl_1_search(Tail, _Q_, [Ds,O1,O2], _E_).

rcp_meet_foldl_2([], I_or, _, I_or) :- 
	!.
rcp_meet_foldl_2([D_106|Tail], I_or, [Ds,O1,O2], _D_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_meets(O1, O2, D_106, _A_),
	rcp_met_by(O1, O2, D_106, _B_),
	fd_or(I_or, _C_, _E_),
	rcp_meet_foldl_2(Tail, _E_, [Ds,O1,O2], _D_).

rcp_meet_foldl_2_search([], I_or, _, I_or) :- 
	!.
rcp_meet_foldl_2_search([D_106|Tail], I_or, [Ds,O1,O2], _C_) :- 
	(
	rcp_assert(I_or)
	;
	rcp_rcp_meets_search_search(O1, O2, D_106, _A_, _D_),
	rcp_rcp_assert_search(_A_, _E_),
	rcp_,(_D_, _E_, _F_),
	rcp_rcp_met_by_search_search(O1, O2, D_106, _B_, _G_),
	rcp_rcp_assert_search(_B_, _H_),
	rcp_,(_G_, _H_, _I_),
	rcp_;(_F_, _I_, _J_),
	rcp_assert(_J_)
	),
	rcp_meet_foldl_2_search(Tail, _K_, [Ds,O1,O2], _C_).

rcp_meet(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_meet_foldl_1(Ds, 1, [Ds,O1,O2], _A_),
	rcp_meet_foldl_2(Ds, 0, [Ds,O1,O2], _B_).

rcp_meet_search(O1, O2, Ds, _C_) :- 
	rcp_meet_foldl_1_search(Ds, 1, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_meet_foldl_2_search(Ds, 0, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_equal_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_equal_foldl_1([D_109|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_equals(O1, O2, D_109, _A_),
	fd_and(I_and, _A_, _C_),
	rcp_equal_foldl_1(Tail, _C_, [Ds,O1,O2], _B_).

rcp_equal_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_equal_foldl_1_search([D_109|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_equals_search(O1, O2, D_109, _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_equal_foldl_1_search(Tail, _C_, [Ds,O1,O2], _B_).

rcp_equal(O1, O2, Ds, _A_) :- 
	rcp_equal_foldl_1(Ds, 1, [Ds,O1,O2], _A_).

rcp_equal_search(O1, O2, Ds, _A_) :- 
	rcp_equal_foldl_1_search(Ds, 1, [Ds,O1,O2], _A_).

rcp_covers_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_covers_foldl_1([D_111|Tail], I_and, [Ds,O1,O2], _F_) :- 
	fd_or(_C_, _D_, _E_),
	fd_or(_A_, _B_, _C_),
	rcp_started_by(O1, O2, D_111, _A_),
	rcp_contains(O1, O2, D_111, _B_),
	rcp_finished_by(O1, O2, D_111, _D_),
	fd_and(I_and, _E_, _G_),
	rcp_covers_foldl_1(Tail, _G_, [Ds,O1,O2], _F_).

rcp_covers_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_covers_foldl_1_search([D_111|Tail], I_and, [Ds,O1,O2], _D_) :- 
	rcp_assert(I_and),
	rcp_rcp_started_by_search_search(O1, O2, D_111, _A_, _E_),
	rcp_rcp_assert_search(_A_, _F_),
	rcp_,(_E_, _F_, _G_),
	rcp_rcp_contains_search_search(O1, O2, D_111, _B_, _H_),
	rcp_rcp_assert_search(_B_, _I_),
	rcp_,(_H_, _I_, _J_),
	rcp_;(_G_, _J_, _K_),
	rcp_rcp_finished_by_search_search(O1, O2, D_111, _C_, _L_),
	rcp_rcp_assert_search(_C_, _M_),
	rcp_,(_L_, _M_, _N_),
	rcp_;(_K_, _N_, _O_),
	rcp_assert(_O_),
	rcp_covers_foldl_1_search(Tail, _P_, [Ds,O1,O2], _D_).

rcp_covers_foldl_2([], I_or, _, I_or) :- 
	!.
rcp_covers_foldl_2([D_112|Tail], I_or, [Ds,O1,O2], _C_) :- 
	fd_not(_A_, _B_),
	rcp_contains(O1, O2, D_112, _A_),
	fd_or(I_or, _B_, _D_),
	rcp_covers_foldl_2(Tail, _D_, [Ds,O1,O2], _C_).

rcp_covers_foldl_2_search([], I_or, _, I_or) :- 
	!.
rcp_covers_foldl_2_search([D_112|Tail], I_or, [Ds,O1,O2], _C_) :- 
	rcp_contains_search(O1, O2, D_112, _A_),
	fd_not(_A_, _B_),
	(
	rcp_assert(I_or)
	;
	rcp_assert(_B_)
	),
	rcp_covers_foldl_2_search(Tail, _D_, [Ds,O1,O2], _C_).

rcp_covers(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_covers_foldl_1(Ds, 1, [Ds,O1,O2], _A_),
	rcp_covers_foldl_2(Ds, 0, [Ds,O1,O2], _B_).

rcp_covers_search(O1, O2, Ds, _C_) :- 
	rcp_covers_foldl_1_search(Ds, 1, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_covers_foldl_2_search(Ds, 0, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_covered_by_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_covered_by_foldl_1([D_115|Tail], I_and, [Ds,O1,O2], _F_) :- 
	fd_or(_C_, _D_, _E_),
	fd_or(_A_, _B_, _C_),
	rcp_starts(O1, O2, D_115, _A_),
	rcp_during(O1, O2, D_115, _B_),
	rcp_finishes(O1, O2, D_115, _D_),
	fd_and(I_and, _E_, _G_),
	rcp_covered_by_foldl_1(Tail, _G_, [Ds,O1,O2], _F_).

rcp_covered_by_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_covered_by_foldl_1_search([D_115|Tail], I_and, [Ds,O1,O2], _D_) :- 
	rcp_assert(I_and),
	rcp_rcp_starts_search_search(O1, O2, D_115, _A_, _E_),
	rcp_rcp_assert_search(_A_, _F_),
	rcp_,(_E_, _F_, _G_),
	rcp_rcp_during_search_search(O1, O2, D_115, _B_, _H_),
	rcp_rcp_assert_search(_B_, _I_),
	rcp_,(_H_, _I_, _J_),
	rcp_;(_G_, _J_, _K_),
	rcp_rcp_finishes_search_search(O1, O2, D_115, _C_, _L_),
	rcp_rcp_assert_search(_C_, _M_),
	rcp_,(_L_, _M_, _N_),
	rcp_;(_K_, _N_, _O_),
	rcp_assert(_O_),
	rcp_covered_by_foldl_1_search(Tail, _P_, [Ds,O1,O2], _D_).

rcp_covered_by_foldl_2([], I_or, _, I_or) :- 
	!.
rcp_covered_by_foldl_2([D_116|Tail], I_or, [Ds,O1,O2], _C_) :- 
	fd_not(_A_, _B_),
	rcp_during(O1, O2, D_116, _A_),
	fd_or(I_or, _B_, _D_),
	rcp_covered_by_foldl_2(Tail, _D_, [Ds,O1,O2], _C_).

rcp_covered_by_foldl_2_search([], I_or, _, I_or) :- 
	!.
rcp_covered_by_foldl_2_search([D_116|Tail], I_or, [Ds,O1,O2], _C_) :- 
	rcp_during_search(O1, O2, D_116, _A_),
	fd_not(_A_, _B_),
	(
	rcp_assert(I_or)
	;
	rcp_assert(_B_)
	),
	rcp_covered_by_foldl_2_search(Tail, _D_, [Ds,O1,O2], _C_).

rcp_covered_by(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_covered_by_foldl_1(Ds, 1, [Ds,O1,O2], _A_),
	rcp_covered_by_foldl_2(Ds, 0, [Ds,O1,O2], _B_).

rcp_covered_by_search(O1, O2, Ds, _C_) :- 
	rcp_covered_by_foldl_1_search(Ds, 1, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_covered_by_foldl_2_search(Ds, 0, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_contains_rcc_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_contains_rcc_foldl_1([D_119|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_contains(O1, O2, D_119, _A_),
	fd_and(I_and, _A_, _C_),
	rcp_contains_rcc_foldl_1(Tail, _C_, [Ds,O1,O2], _B_).

rcp_contains_rcc_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_contains_rcc_foldl_1_search([D_119|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_contains_search(O1, O2, D_119, _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_contains_rcc_foldl_1_search(Tail, _C_, [Ds,O1,O2], _B_).

rcp_contains_rcc(O1, O2, Ds, _A_) :- 
	rcp_contains_rcc_foldl_1(Ds, 1, [Ds,O1,O2], _A_).

rcp_contains_rcc_search(O1, O2, Ds, _A_) :- 
	rcp_contains_rcc_foldl_1_search(Ds, 1, [Ds,O1,O2], _A_).

rcp_inside_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_inside_foldl_1([D_121|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_during(O1, O2, D_121, _A_),
	fd_and(I_and, _A_, _C_),
	rcp_inside_foldl_1(Tail, _C_, [Ds,O1,O2], _B_).

rcp_inside_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_inside_foldl_1_search([D_121|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_during_search(O1, O2, D_121, _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_inside_foldl_1_search(Tail, _C_, [Ds,O1,O2], _B_).

rcp_inside(O1, O2, Ds, _A_) :- 
	rcp_inside_foldl_1(Ds, 1, [Ds,O1,O2], _A_).

rcp_inside_search(O1, O2, Ds, _A_) :- 
	rcp_inside_foldl_1_search(Ds, 1, [Ds,O1,O2], _A_).

rcp_overlap_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_overlap_foldl_1([D_123|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_overlaps_sym(O1, O2, D_123, _A_),
	fd_and(I_and, _A_, _C_),
	rcp_overlap_foldl_1(Tail, _C_, [Ds,O1,O2], _B_).

rcp_overlap_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_overlap_foldl_1_search([D_123|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_overlaps_sym_search(O1, O2, D_123, _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_overlap_foldl_1_search(Tail, _C_, [Ds,O1,O2], _B_).

rcp_overlap(O1, O2, Ds, _A_) :- 
	rcp_overlap_foldl_1(Ds, 1, [Ds,O1,O2], _A_).

rcp_overlap_search(O1, O2, Ds, _A_) :- 
	rcp_overlap_foldl_1_search(Ds, 1, [Ds,O1,O2], _A_).

rcp_contains_touch_rcc_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_contains_touch_rcc_foldl_1([D_125|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_contains_touch(O1, O2, D_125, _A_),
	fd_and(I_and, _A_, _C_),
	rcp_contains_touch_rcc_foldl_1(Tail, _C_, [Ds,O1,O2], _B_).

rcp_contains_touch_rcc_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_contains_touch_rcc_foldl_1_search([D_125|Tail], I_and, [Ds,O1,O2], _B_) :- 
	rcp_contains_touch_search(O1, O2, D_125, _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_contains_touch_rcc_foldl_1_search(Tail, _C_, [Ds,O1,O2], _B_).

rcp_contains_touch_rcc(O1, O2, Ds, _A_) :- 
	rcp_contains_touch_rcc_foldl_1(Ds, 1, [Ds,O1,O2], _A_).

rcp_contains_touch_rcc_search(O1, O2, Ds, _A_) :- 
	rcp_contains_touch_rcc_foldl_1_search(Ds, 1, [Ds,O1,O2], _A_).

rcp_above(O1, O2, _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_and(_A_, _B_, _C_),
	rcp_overlap(O1, O2, [1,2], _A_),
	rcp_preceded_by(O1, O2, 3, _B_),
	rcp_met_by(O1, O2, 3, _D_).

rcp_above_search(O1, O2, _D_) :- 
	(
	rcp_overlap_search(O1, O2, [1,2], _A_),
	rcp_assert(_A_),
	rcp_preceded_by_search(O1, O2, 3, _B_),
	rcp_assert(_B_)
	;
	rcp_met_by_search(O1, O2, 3, _C_),
	rcp_assert(_C_)
	),
	fd_aeq(_D_, 1).

rcp_on_top(O1, O2, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_overlap(O1, O2, [1,2], _A_),
	rcp_met_by(O1, O2, 3, _B_).

rcp_on_top_search(O1, O2, _C_) :- 
	rcp_overlap_search(O1, O2, [1,2], _A_),
	rcp_assert(_A_),
	rcp_met_by_search(O1, O2, 3, _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_stack_oversize_foldl_3([], I_and, _, I_and) :- 
	!.
rcp_stack_oversize_foldl_3([D_132|Tail], I_and, [Items,Length,O1_127,O2_130], _C_) :- 
	rcp_oversize(O1_127, O2_130, D_132, _A_),
	fd_leq(_A_, Length, _B_),
	fd_and(I_and, _B_, _D_),
	rcp_stack_oversize_foldl_3(Tail, _D_, [Items,Length,O1_127,O2_130], _C_).

rcp_stack_oversize_foldl_3_search([], I_and, _, I_and) :- 
	!.
rcp_stack_oversize_foldl_3_search([D_132|Tail], I_and, [Items,Length,O1_127,O2_130], _B_) :- 
	rcp_oversize_search(O1_127, O2_130, D_132, _A_),
	rcp_assert(I_and),
	rcp_fd_leq_search(_A_, Length, _C_),
	rcp_assert(_C_),
	rcp_stack_oversize_foldl_3_search(Tail, _D_, [Items,Length,O1_127,O2_130], _B_).

rcp_stack_oversize_foldl_2([], I_and, _, I_and) :- 
	!.
rcp_stack_oversize_foldl_2([O2_130|Tail], I_and, [Items,Length,O1_127], _H_) :- 
	fd_implies(_E_, _F_, _G_),
	fd_and(_A_, _D_, _E_),
	rcp_overlap(O1_127, O2_130, [1,2], _A_),
	rcp_att(uid, O1_127, _B_),
	rcp_att(uid, O2_130, _C_),
	fd_neq(_B_, _C_, _D_),
	rcp_stack_oversize_foldl_3([1,2], 1, [Items,Length,O1_127,O2_130], _F_),
	fd_and(I_and, _G_, _I_),
	rcp_stack_oversize_foldl_2(Tail, _I_, [Items,Length,O1_127], _H_).

rcp_stack_oversize_foldl_2_search([], I_and, _, I_and) :- 
	!.
rcp_stack_oversize_foldl_2_search([O2_130|Tail], I_and, [Items,Length,O1_127], _J_) :- 
	rcp_att(uid, O1_127, _B_),
	rcp_att(uid, O2_130, _C_),
	rcp_att(uid, O1_127, _F_),
	rcp_att(uid, O2_130, _G_),
	(
	rcp_overlap_search(O1_127, O2_130, [1,2], _A_),
	rcp_assert(_A_),
	fd_neq(_B_, _C_),
	rcp_stack_oversize_foldl_3_search([1,2], 1, [Items,Length,O1_127,O2_130], _H_),
	fd_equiv(_H_, _I_, 1)
	;
	(
	rcp_overlap_search(O1_127, O2_130, [1,2], _D_),
	fd_not(_D_, _E_),
	rcp_assert(_E_)
	;
	fd_eq(_F_, _G_)
	),
	fd_aeq(_I_, 1)
	),
	rcp_assert(I_and),
	rcp_assert(_I_),
	rcp_stack_oversize_foldl_2_search(Tail, _K_, [Items,Length,O1_127], _J_).

rcp_stack_oversize_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_stack_oversize_foldl_1([O1_127|Tail], I_and, [Items,Length], _B_) :- 
	rcp_stack_oversize_foldl_2(Items, 1, [Items,Length,O1_127], _A_),
	fd_and(I_and, _A_, _C_),
	rcp_stack_oversize_foldl_1(Tail, _C_, [Items,Length], _B_).

rcp_stack_oversize_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_stack_oversize_foldl_1_search([O1_127|Tail], I_and, [Items,Length], _B_) :- 
	rcp_stack_oversize_foldl_2_search(Items, 1, [Items,Length,O1_127], _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_stack_oversize_foldl_1_search(Tail, _C_, [Items,Length], _B_).

rcp_stack_oversize(Items, Length, _A_) :- 
	rcp_stack_oversize_foldl_1(Items, 1, [Items,Length], _A_).

rcp_stack_oversize_search(Items, Length, _A_) :- 
	rcp_stack_oversize_foldl_1_search(Items, 1, [Items,Length], _A_).

rcp_lighter(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_leq(_A_, _B_, _C_).

rcp_lighter_search(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_leq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_heavier(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_geq(_A_, _B_, _C_).

rcp_heavier_search(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_geq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_gravity_foldl_2([], I_or, _, I_or) :- 
	!.
rcp_gravity_foldl_2([O2_141|Tail], I_or, [Items,O1_139], _F_) :- 
	fd_and(_C_, _D_, _E_),
	rcp_att(uid, O1_139, _A_),
	rcp_att(uid, O2_141, _B_),
	fd_neq(_A_, _B_, _C_),
	rcp_on_top(O1_139, O2_141, _D_),
	fd_or(I_or, _E_, _G_),
	rcp_gravity_foldl_2(Tail, _G_, [Items,O1_139], _F_).

rcp_gravity_foldl_2_search([], I_or, _, I_or) :- 
	!.
rcp_gravity_foldl_2_search([O2_141|Tail], I_or, [Items,O1_139], _D_) :- 
	rcp_att(uid, O1_139, _A_),
	rcp_att(uid, O2_141, _B_),
	(
	rcp_assert(I_or)
	;
	rcp_fd_neq_search(_A_, _B_, _E_),
	rcp_rcp_on_top_search_search(O1_139, O2_141, _C_, _F_),
	rcp_rcp_assert_search(_C_, _G_),
	rcp_,(_F_, _G_, _H_),
	rcp_,(_E_, _H_, _I_),
	rcp_assert(_I_)
	),
	rcp_gravity_foldl_2_search(Tail, _J_, [Items,O1_139], _D_).

rcp_gravity_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_gravity_foldl_1([O1_139|Tail], I_and, [Items], _E_) :- 
	fd_or(_B_, _C_, _D_),
	rcp_origin(O1_139, 3, _A_),
	fd_eq(_A_, 0, _B_),
	rcp_gravity_foldl_2(Items, 0, [Items,O1_139], _C_),
	fd_and(I_and, _D_, _F_),
	rcp_gravity_foldl_1(Tail, _F_, [Items], _E_).

rcp_gravity_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_gravity_foldl_1_search([O1_139|Tail], I_and, [Items], _C_) :- 
	rcp_origin_search(O1_139, 3, _A_),
	rcp_assert(I_and),
	rcp_fd_eq_search(_A_, 0, _D_),
	rcp_rcp_gravity_foldl_2_search_search(Items, 0, [Items,O1_139], _B_, _E_),
	rcp_rcp_assert_search(_B_, _F_),
	rcp_,(_E_, _F_, _G_),
	rcp_;(_D_, _G_, _H_),
	rcp_assert(_H_),
	rcp_gravity_foldl_1_search(Tail, _I_, [Items], _C_).

rcp_gravity(Items, _A_) :- 
	rcp_gravity_foldl_1(Items, 1, [Items], _A_).

rcp_gravity_search(Items, _A_) :- 
	rcp_gravity_foldl_1_search(Items, 1, [Items], _A_).

rcp_weight_stacking_foldl_2([], I_and, _, I_and) :- 
	!.
rcp_weight_stacking_foldl_2([O2_147|Tail], I_and, [Items,O1_145], _H_) :- 
	fd_implies(_E_, _F_, _G_),
	fd_and(_C_, _D_, _E_),
	rcp_att(uid, O1_145, _A_),
	rcp_att(uid, O2_147, _B_),
	fd_neq(_A_, _B_, _C_),
	rcp_above(O1_145, O2_147, _D_),
	rcp_lighter(O1_145, O2_147, _F_),
	fd_and(I_and, _G_, _I_),
	rcp_weight_stacking_foldl_2(Tail, _I_, [Items,O1_145], _H_).

rcp_weight_stacking_foldl_2_search([], I_and, _, I_and) :- 
	!.
rcp_weight_stacking_foldl_2_search([O2_147|Tail], I_and, [Items,O1_145], _J_) :- 
	rcp_att(uid, O1_145, _A_),
	rcp_att(uid, O2_147, _B_),
	rcp_att(uid, O1_145, _D_),
	rcp_att(uid, O2_147, _E_),
	(
	fd_neq(_A_, _B_),
	rcp_above_search(O1_145, O2_147, _C_),
	rcp_assert(_C_),
	rcp_lighter_search(O1_145, O2_147, _H_),
	fd_equiv(_H_, _I_, 1)
	;
	(
	fd_eq(_D_, _E_)
	;
	rcp_above_search(O1_145, O2_147, _F_),
	fd_not(_F_, _G_),
	rcp_assert(_G_)
	),
	fd_aeq(_I_, 1)
	),
	rcp_assert(I_and),
	rcp_assert(_I_),
	rcp_weight_stacking_foldl_2_search(Tail, _K_, [Items,O1_145], _J_).

rcp_weight_stacking_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_weight_stacking_foldl_1([O1_145|Tail], I_and, [Items], _B_) :- 
	rcp_weight_stacking_foldl_2(Items, 1, [Items,O1_145], _A_),
	fd_and(I_and, _A_, _C_),
	rcp_weight_stacking_foldl_1(Tail, _C_, [Items], _B_).

rcp_weight_stacking_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_weight_stacking_foldl_1_search([O1_145|Tail], I_and, [Items], _B_) :- 
	rcp_weight_stacking_foldl_2_search(Items, 1, [Items,O1_145], _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_weight_stacking_foldl_1_search(Tail, _C_, [Items], _B_).

rcp_weight_stacking(Items, _A_) :- 
	rcp_weight_stacking_foldl_1(Items, 1, [Items], _A_).

rcp_weight_stacking_search(Items, _A_) :- 
	rcp_weight_stacking_foldl_1_search(Items, 1, [Items], _A_).

rcp_weight_balancing_foldr_1([], _, []) :- 
	!.
rcp_weight_balancing_foldr_1([Il_151|Tail], [Bin,D,Items,Ratio], [_F_|_G_]) :- 
	rcp_weight_balancing_foldr_1(Tail, [Bin,D,Items,Ratio], _G_),
	rcp_att(weight, Il_151, _A_),
	rcp_end(Il_151, D, _B_),
	rcp_end(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_leq(_B_, _D_, _E_),
	fd_aeq(_A_*_E_, _F_).

rcp_weight_balancing_foldr_1_search([], _, []) :- 
	!.
rcp_weight_balancing_foldr_1_search([Il_151|Tail], [Bin,D,Items,Ratio], [_E_|_F_]) :- 
	rcp_weight_balancing_foldr_1_search(Tail, [Bin,D,Items,Ratio], _F_),
	rcp_att(weight, Il_151, _A_),
	rcp_end_search(Il_151, D, _B_),
	rcp_end_search(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_aeq(_A_*fd_leq(_B_,_D_), _E_).

rcp_weight_balancing_foldr_2([], _, []) :- 
	!.
rcp_weight_balancing_foldr_2([Ir_155|Tail], [Bin,D,Items,Ratio], [_F_|_G_]) :- 
	rcp_weight_balancing_foldr_2(Tail, [Bin,D,Items,Ratio], _G_),
	rcp_att(weight, Ir_155, _A_),
	rcp_origin(Ir_155, D, _B_),
	rcp_end(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_geq(_B_, _D_, _E_),
	fd_aeq(_A_*_E_, _F_).

rcp_weight_balancing_foldr_2_search([], _, []) :- 
	!.
rcp_weight_balancing_foldr_2_search([Ir_155|Tail], [Bin,D,Items,Ratio], [_E_|_F_]) :- 
	rcp_weight_balancing_foldr_2_search(Tail, [Bin,D,Items,Ratio], _F_),
	rcp_att(weight, Ir_155, _A_),
	rcp_origin_search(Ir_155, D, _B_),
	rcp_end_search(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_aeq(_A_*fd_geq(_B_,_D_), _E_).

rcp_weight_balancing(Items, Bin, D, Ratio, _J_) :- 
	rcp_weight_balancing_foldr_1(Items, [Bin,D,Items,Ratio], _A_),
	rcp_sum(_A_, _B_),
	L_152=_B_,
	rcp_weight_balancing_foldr_2(Items, [Bin,D,Items,Ratio], _C_),
	rcp_sum(_C_, _D_),
	R_156=_D_,
	fd_aeq(max(L_152,R_156), _E_),
	fd_aeq(100*_E_, _F_),
	fd_aeq(100+Ratio, _G_),
	fd_aeq(min(L_152,R_156), _H_),
	fd_aeq(_G_*_H_, _I_),
	fd_leq(_F_, _I_, _J_).

rcp_weight_balancing_search(Items, Bin, D, Ratio, _J_) :- 
	rcp_weight_balancing_foldr_1_search(Items, [Bin,D,Items,Ratio], _A_),
	rcp_sum_search(_A_, _B_),
	L_152=_B_,
	rcp_weight_balancing_foldr_2_search(Items, [Bin,D,Items,Ratio], _C_),
	rcp_sum_search(_C_, _D_),
	R_156=_D_,
	fd_aeq(max(L_152,R_156), _E_),
	fd_aeq(100*_E_, _F_),
	fd_aeq(100+Ratio, _G_),
	fd_aeq(min(L_152,R_156), _H_),
	fd_aeq(_G_*_H_, _I_),
	fd_leq(_F_, _I_),
	fd_aeq(_J_, 1).

rcp_object_shape_domain(O, _D_) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	length(_B_, _C_),
	_A_ in 1.._C_,
	fd_aeq(_D_, 1).

rcp_object_shape_domain_search(O, _D_) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	length(_B_, _C_),
	_A_ in 1.._C_,
	fd_aeq(_D_, 1).

rcp_object_shape_domains_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_object_shape_domains_foldl_1([I_163|Tail], I_and, [Items], _B_) :- 
	rcp_object_shape_domain(I_163, _A_),
	fd_and(I_and, _A_, _C_),
	rcp_object_shape_domains_foldl_1(Tail, _C_, [Items], _B_).

rcp_object_shape_domains_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_object_shape_domains_foldl_1_search([I_163|Tail], I_and, [Items], _B_) :- 
	rcp_object_shape_domain_search(I_163, _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_object_shape_domains_foldl_1_search(Tail, _C_, [Items], _B_).

rcp_object_shape_domains(Items, _A_) :- 
	rcp_object_shape_domains_foldl_1(Items, 1, [Items], _A_).

rcp_object_shape_domains_search(Items, _A_) :- 
	rcp_object_shape_domains_foldl_1_search(Items, 1, [Items], _A_).

rcp_non_overlapping_binary_foldl_2([], I_and, _, I_and) :- 
	!.
rcp_non_overlapping_binary_foldl_2([O2_167|Tail], I_and, [Dims,Items,O1_165], _G_) :- 
	fd_implies(_C_, _E_, _F_),
	rcp_att(uid, O1_165, _A_),
	rcp_att(uid, O2_167, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_not(_D_, _E_),
	rcp_overlap(O1_165, O2_167, Dims, _D_),
	fd_and(I_and, _F_, _H_),
	rcp_non_overlapping_binary_foldl_2(Tail, _H_, [Dims,Items,O1_165], _G_).

rcp_non_overlapping_binary_foldl_2_search([], I_and, _, I_and) :- 
	!.
rcp_non_overlapping_binary_foldl_2_search([O2_167|Tail], I_and, [Dims,Items,O1_165], _H_) :- 
	rcp_att(uid, O1_165, _A_),
	rcp_att(uid, O2_167, _B_),
	rcp_att(uid, O1_165, _C_),
	rcp_att(uid, O2_167, _D_),
	(
	fd_lt(_A_, _B_),
	rcp_overlap_search(O1_165, O2_167, Dims, _E_),
	fd_not(_E_, _F_),
	fd_equiv(_F_, _G_, 1)
	;
	fd_geq(_C_, _D_),
	fd_aeq(_G_, 1)
	),
	rcp_assert(I_and),
	rcp_assert(_G_),
	rcp_non_overlapping_binary_foldl_2_search(Tail, _I_, [Dims,Items,O1_165], _H_).

rcp_non_overlapping_binary_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_non_overlapping_binary_foldl_1([O1_165|Tail], I_and, [Dims,Items], _B_) :- 
	rcp_non_overlapping_binary_foldl_2(Items, 1, [Dims,Items,O1_165], _A_),
	fd_and(I_and, _A_, _C_),
	rcp_non_overlapping_binary_foldl_1(Tail, _C_, [Dims,Items], _B_).

rcp_non_overlapping_binary_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_non_overlapping_binary_foldl_1_search([O1_165|Tail], I_and, [Dims,Items], _B_) :- 
	rcp_non_overlapping_binary_foldl_2_search(Items, 1, [Dims,Items,O1_165], _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_non_overlapping_binary_foldl_1_search(Tail, _C_, [Dims,Items], _B_).

rcp_non_overlapping_binary(Items, Dims, _A_) :- 
	rcp_non_overlapping_binary_foldl_1(Items, 1, [Dims,Items], _A_).

rcp_non_overlapping_binary_search(Items, Dims, _A_) :- 
	rcp_non_overlapping_binary_foldl_1_search(Items, 1, [Dims,Items], _A_).

rcp_containmentAE_foldl_2([], I_or, _, I_or) :- 
	!.
rcp_containmentAE_foldl_2([B_173|Tail], I_or, [Bins,Dims,I_171,Items], _B_) :- 
	rcp_contains_touch_rcc(B_173, I_171, Dims, _A_),
	fd_or(I_or, _A_, _C_),
	rcp_containmentAE_foldl_2(Tail, _C_, [Bins,Dims,I_171,Items], _B_).

rcp_containmentAE_foldl_2_search([], I_or, _, I_or) :- 
	!.
rcp_containmentAE_foldl_2_search([B_173|Tail], I_or, [Bins,Dims,I_171,Items], _B_) :- 
	rcp_contains_touch_rcc_search(B_173, I_171, Dims, _A_),
	(
	rcp_assert(I_or)
	;
	rcp_assert(_A_)
	),
	rcp_containmentAE_foldl_2_search(Tail, _C_, [Bins,Dims,I_171,Items], _B_).

rcp_containmentAE_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_containmentAE_foldl_1([I_171|Tail], I_and, [Bins,Dims,Items], _B_) :- 
	rcp_containmentAE_foldl_2(Bins, 0, [Bins,Dims,I_171,Items], _A_),
	fd_and(I_and, _A_, _C_),
	rcp_containmentAE_foldl_1(Tail, _C_, [Bins,Dims,Items], _B_).

rcp_containmentAE_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_containmentAE_foldl_1_search([I_171|Tail], I_and, [Bins,Dims,Items], _B_) :- 
	rcp_containmentAE_foldl_2_search(Bins, 0, [Bins,Dims,I_171,Items], _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_containmentAE_foldl_1_search(Tail, _C_, [Bins,Dims,Items], _B_).

rcp_containmentAE(Items, Bins, Dims, _A_) :- 
	rcp_containmentAE_foldl_1(Items, 1, [Bins,Dims,Items], _A_).

rcp_containmentAE_search(Items, Bins, Dims, _A_) :- 
	rcp_containmentAE_foldl_1_search(Items, 1, [Bins,Dims,Items], _A_).

rcp_bin_packing_binary(Items, Bins, Dims, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_containmentAE(Items, Bins, Dims, _A_),
	rcp_non_overlapping_binary(Items, Dims, _B_),
	variables(Items, _D_),
	rcp_labeling(_D_).

rcp_bin_packing_binary_search(Items, Bins, Dims, _D_) :- 
	variables(Items, _C_),
	rcp_containmentAE_search(Items, Bins, Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_binary_search(Items, Dims, _B_),
	rcp_assert(_B_),
	rcp_labeling(_C_),
	fd_aeq(_D_, 1).

rcp_bin_packing(Items, Bins, Dims, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_containmentAE(Items, Bins, Dims, _A_),
	rcp_non_overlapping(Items, Dims, _B_),
	variables(Items, _D_),
	rcp_labeling(_D_).

rcp_bin_packing_search(Items, Bins, Dims, _D_) :- 
	variables(Items, _C_),
	rcp_containmentAE_search(Items, Bins, Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_search(Items, Dims, _B_),
	rcp_assert(_B_),
	rcp_labeling(_C_),
	fd_aeq(_D_, 1).

rcp_containmentEA_foldl_2([], I_and, _, I_and) :- 
	!.
rcp_containmentEA_foldl_2([I_179|Tail], I_and, [B_177,Bins,Dims,Items], _B_) :- 
	rcp_contains_touch_rcc(B_177, I_179, Dims, _A_),
	fd_and(I_and, _A_, _C_),
	rcp_containmentEA_foldl_2(Tail, _C_, [B_177,Bins,Dims,Items], _B_).

rcp_containmentEA_foldl_2_search([], I_and, _, I_and) :- 
	!.
rcp_containmentEA_foldl_2_search([I_179|Tail], I_and, [B_177,Bins,Dims,Items], _B_) :- 
	rcp_contains_touch_rcc_search(B_177, I_179, Dims, _A_),
	rcp_assert(I_and),
	rcp_assert(_A_),
	rcp_containmentEA_foldl_2_search(Tail, _C_, [B_177,Bins,Dims,Items], _B_).

rcp_containmentEA_foldl_1([], I_or, _, I_or) :- 
	!.
rcp_containmentEA_foldl_1([B_177|Tail], I_or, [Bins,Dims,Items], _B_) :- 
	rcp_containmentEA_foldl_2(Items, 1, [B_177,Bins,Dims,Items], _A_),
	fd_or(I_or, _A_, _C_),
	rcp_containmentEA_foldl_1(Tail, _C_, [Bins,Dims,Items], _B_).

rcp_containmentEA_foldl_1_search([], I_or, _, I_or) :- 
	!.
rcp_containmentEA_foldl_1_search([B_177|Tail], I_or, [Bins,Dims,Items], _B_) :- 
	rcp_containmentEA_foldl_2_search(Items, 1, [B_177,Bins,Dims,Items], _A_),
	(
	rcp_assert(I_or)
	;
	rcp_assert(_A_)
	),
	rcp_containmentEA_foldl_1_search(Tail, _C_, [Bins,Dims,Items], _B_).

rcp_containmentEA(Items, Bins, Dims, _A_) :- 
	rcp_containmentEA_foldl_1(Bins, 0, [Bins,Dims,Items], _A_).

rcp_containmentEA_search(Items, Bins, Dims, _A_) :- 
	rcp_containmentEA_foldl_1_search(Bins, 0, [Bins,Dims,Items], _A_).

rcp_bin_design(Bin, Items, Dims, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_containmentEA(Items, [Bin], Dims, _A_),
	rcp_non_overlapping(Items, Dims, _B_),
	rcp_volume(Bin, _E_),
	minimize(((variables(Items,_D_),rcp_labeling(_D_)),rcp_labeling([_E_])), _E_),
	true.

rcp_bin_design_search(Bin, Items, Dims, _E_) :- 
	rcp_volume(Bin, _D_),
	minimize(((variables(Items,_C_),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_),
	rcp_containmentEA_search(Items, [Bin], Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_search(Items, Dims, _B_),
	rcp_assert(_B_),
	fd_aeq(_E_, 1).

rcp_items_domain_foldl_1([], I_and, _, I_and) :- 
	!.
rcp_items_domain_foldl_1([I_183|Tail], I_and, [Bin,Items], _J_) :- 
	rcp_x(I_183, _A_),
	variables(_A_, _B_),
	rcp_w(Bin, _C_),
	rcp_y(I_183, _D_),
	variables(_D_, _E_),
	rcp_h(Bin, _F_),
	rcp_z(I_183, _G_),
	variables(_G_, _H_),
	rcp_l(Bin, _I_),
	domain(_H_, 0, _I_),
	domain(_B_, 0, _C_),
	domain(_E_, 0, _F_),
	rcp_items_domain_foldl_1(Tail, I_and, [Bin,Items], _J_).

rcp_items_domain_foldl_1_search([], I_and, _, I_and) :- 
	!.
rcp_items_domain_foldl_1_search([I_183|Tail], I_and, [Bin,Items], _J_) :- 
	rcp_x_search(I_183, _A_),
	variables(_A_, _B_),
	rcp_w_search(Bin, _C_),
	rcp_y_search(I_183, _D_),
	variables(_D_, _E_),
	rcp_h_search(Bin, _F_),
	rcp_z_search(I_183, _G_),
	variables(_G_, _H_),
	rcp_l_search(Bin, _I_),
	rcp_assert(I_and),
	rcp_,(domain(_B_,0,_C_), domain(_E_,0,_F_), _K_),
	rcp_,(_K_, domain(_H_,0,_I_), _L_),
	rcp_assert(_L_),
	rcp_items_domain_foldl_1_search(Tail, _M_, [Bin,Items], _J_).

rcp_items_domain(Items, Bin, _A_) :- 
	rcp_items_domain_foldl_1(Items, 1, [Bin,Items], _A_).

rcp_items_domain_search(Items, Bin, _A_) :- 
	rcp_items_domain_foldl_1_search(Items, 1, [Bin,Items], _A_).

solve([O2_4,O2,O2_2,O2_3,O3_4,O3,O3_2,O3_3]) :-
	rcp_var(from(o2,0,1), O2),
	R_185#<=>O2_4#=1,
	R_186#<=>O2_4#=2,
	rcp_var(from(o2,0,2), O2_2),
	R_187#<=>O2_4#=1,
	R_188#<=>O2_4#=2,
	rcp_var(from(o2,0,3), O2_3),
	R_189#<=>O2_4#=1,
	rcp_var(from(o2,0,4), O2_4),
	R_190#<=>O2_4#=2,
	rcp_var(from(o3,0,1), O3),
	R_191#<=>O3_4#=1,
	R_192#<=>O3_4#=2,
	rcp_var(from(o3,0,2), O3_2),
	R_193#<=>O3_4#=1,
	R_194#<=>O3_4#=2,
	rcp_var(from(o3,0,3), O3_3),
	R_195#<=>O3_4#=1,
	rcp_var(from(o3,0,4), O3_4),
	R_196#<=>O3_4#=2,
	S_198 in{6}\/{3},
	element(O2_4, [3,6], S_198),
	S_197 in{6}\/{3},
	element(O3_4, [3,6], S_197),
	domain([O2], 0, 5),
	domain([O2_2], 0, 4),
	domain([O2_3], 0, 4),
	domain([O3], 0, 5),
	domain([O3_2], 0, 4),
	domain([O3_3], 0, 4),
	O2_4 in 1..2,
	O3_4 in 1..2,
	0#=<O2,
	O2+(R_185*4+R_186*5)#=<5,
	0#=<O2_2,
	O2_2+(R_187*5+R_188*4)#=<4,
	0#=<O2_3,
	O2_3+(R_189*2+R_190*2)#=<4,
	0#=<O3,
	O3+(R_191*4+R_192*5)#=<5,
	0#=<O3_2,
	O3_2+(R_193*5+R_194*4)#=<4,
	0#=<O3_3,
	O3_3+(R_195*2+R_196*2)#=<4,
	geost([object(7,S_198,[O2,O2_2,O2_3],[]),object(8,S_197,[O3,O3_2,O3_3],[])], [sbox(3,[0,0,0],[4,5,2]),sbox(6,[0,0,0],[5,4,2])], [non_overlapping(objects([7,8]),[1,2,3])]),
	fd_statistics(backtracks, _),
	labeling([], [O3_4,O3_3,O3,O3_2,O2_4,O2_3,O2,O2_2]),	
	fd_statistics(backtracks, V1),
	format('#backtracks = ~w', [V1]).
