:- use_module(library(clpfd)).
:- use_module('/afs/inria.fr/rocq/home/contraintes/common/src/rules2cp/interpreter/prolog/r2cp.pl').
:- init_interpreter.



rcp_s1(_A_) :- 
	rcp_make_shape_box([1203,235,239], _A_).

rcp_s1_search(_A_) :- 
	rcp_make_shape_box_search([1203,235,239], _A_).

rcp_s2(_A_) :- 
	rcp_make_shape_box([224,224,222], _A_).

rcp_s2_search(_A_) :- 
	rcp_make_shape_box_search([224,224,222], _A_).

rcp_s3(_A_) :- 
	rcp_make_shape_box([224,224,148], _A_).

rcp_s3_search(_A_) :- 
	rcp_make_shape_box_search([224,224,148], _A_).

rcp_s4(_A_) :- 
	rcp_make_shape_box([224,224,111], _A_).

rcp_s4_search(_A_) :- 
	rcp_make_shape_box_search([224,224,111], _A_).

rcp_s5(_A_) :- 
	rcp_make_shape_box([224,224,74], _A_).

rcp_s5_search(_A_) :- 
	rcp_make_shape_box_search([224,224,74], _A_).

rcp_s6(_A_) :- 
	rcp_make_shape_box([155,224,222], _A_).

rcp_s6_search(_A_) :- 
	rcp_make_shape_box_search([155,224,222], _A_).

rcp_s7(_A_) :- 
	rcp_make_shape_box([112,224,148], _A_).

rcp_s7_search(_A_) :- 
	rcp_make_shape_box_search([112,224,148], _A_).

rcp_o1(_B_) :- 
	s1(_A_),
	rcp_make_object_shape(_A_, [0,0,0], _B_).

rcp_o1_search(_B_) :- 
	rcp_s1_search(_A_),
	rcp_make_object_shape_search(_A_, [0,0,0], _B_).

rcp_o2(_B_) :- 
	s4(_A_),
	rcp_var(from(o2,0,1), O2),
	rcp_var(from(o2,0,2), O2_2),
	rcp_var(from(o2,0,3), O2_3),
	rcp_make_object_shape(_A_, [O2,O2_2,O2_3], 413, _B_).

rcp_o2_search(_B_) :- 
	rcp_s4_search(_A_),
	rcp_var(from(o2,0,1), O2),
	rcp_var(from(o2,0,2), O2_2),
	rcp_var(from(o2,0,3), O2_3),
	rcp_make_object_shape_search(_A_, [O2,O2_2,O2_3], 413, _B_).

rcp_o3(_B_) :- 
	s5(_A_),
	rcp_var(from(o3,0,1), O3),
	rcp_var(from(o3,0,2), O3_2),
	rcp_var(from(o3,0,3), O3_3),
	rcp_make_object_shape(_A_, [O3,O3_2,O3_3], 463, _B_).

rcp_o3_search(_B_) :- 
	rcp_s5_search(_A_),
	rcp_var(from(o3,0,1), O3),
	rcp_var(from(o3,0,2), O3_2),
	rcp_var(from(o3,0,3), O3_3),
	rcp_make_object_shape_search(_A_, [O3,O3_2,O3_3], 463, _B_).

rcp_o4(_B_) :- 
	s5(_A_),
	rcp_var(from(o4,0,1), O4),
	rcp_var(from(o4,0,2), O4_2),
	rcp_var(from(o4,0,3), O4_3),
	rcp_make_object_shape(_A_, [O4,O4_2,O4_3], 842, _B_).

rcp_o4_search(_B_) :- 
	rcp_s5_search(_A_),
	rcp_var(from(o4,0,1), O4),
	rcp_var(from(o4,0,2), O4_2),
	rcp_var(from(o4,0,3), O4_3),
	rcp_make_object_shape_search(_A_, [O4,O4_2,O4_3], 842, _B_).

rcp_o5(_B_) :- 
	s3(_A_),
	rcp_var(from(o5,0,1), O5),
	rcp_var(from(o5,0,2), O5_2),
	rcp_var(from(o5,0,3), O5_3),
	rcp_make_object_shape(_A_, [O5,O5_2,O5_3], 422, _B_).

rcp_o5_search(_B_) :- 
	rcp_s3_search(_A_),
	rcp_var(from(o5,0,1), O5),
	rcp_var(from(o5,0,2), O5_2),
	rcp_var(from(o5,0,3), O5_3),
	rcp_make_object_shape_search(_A_, [O5,O5_2,O5_3], 422, _B_).

rcp_o6(_B_) :- 
	s4(_A_),
	rcp_var(from(o6,0,1), O6),
	rcp_var(from(o6,0,2), O6_2),
	rcp_var(from(o6,0,3), O6_3),
	rcp_make_object_shape(_A_, [O6,O6_2,O6_3], 266, _B_).

rcp_o6_search(_B_) :- 
	rcp_s4_search(_A_),
	rcp_var(from(o6,0,1), O6),
	rcp_var(from(o6,0,2), O6_2),
	rcp_var(from(o6,0,3), O6_3),
	rcp_make_object_shape_search(_A_, [O6,O6_2,O6_3], 266, _B_).

rcp_o7(_B_) :- 
	s4(_A_),
	rcp_var(from(o7,0,1), O7),
	rcp_var(from(o7,0,2), O7_2),
	rcp_var(from(o7,0,3), O7_3),
	rcp_make_object_shape(_A_, [O7,O7_2,O7_3], 321, _B_).

rcp_o7_search(_B_) :- 
	rcp_s4_search(_A_),
	rcp_var(from(o7,0,1), O7),
	rcp_var(from(o7,0,2), O7_2),
	rcp_var(from(o7,0,3), O7_3),
	rcp_make_object_shape_search(_A_, [O7,O7_2,O7_3], 321, _B_).

rcp_o8(_B_) :- 
	s2(_A_),
	rcp_var(from(o8,0,1), O8),
	rcp_var(from(o8,0,2), O8_2),
	rcp_var(from(o8,0,3), O8_3),
	rcp_make_object_shape(_A_, [O8,O8_2,O8_3], 670, _B_).

rcp_o8_search(_B_) :- 
	rcp_s2_search(_A_),
	rcp_var(from(o8,0,1), O8),
	rcp_var(from(o8,0,2), O8_2),
	rcp_var(from(o8,0,3), O8_3),
	rcp_make_object_shape_search(_A_, [O8,O8_2,O8_3], 670, _B_).

rcp_o9(_B_) :- 
	s6(_A_),
	rcp_var(from(o9,0,1), O9),
	rcp_var(from(o9,0,2), O9_2),
	rcp_var(from(o9,0,3), O9_3),
	rcp_make_object_shape(_A_, [O9,O9_2,O9_3], 440, _B_).

rcp_o9_search(_B_) :- 
	rcp_s6_search(_A_),
	rcp_var(from(o9,0,1), O9),
	rcp_var(from(o9,0,2), O9_2),
	rcp_var(from(o9,0,3), O9_3),
	rcp_make_object_shape_search(_A_, [O9,O9_2,O9_3], 440, _B_).

rcp_o10(_B_) :- 
	s7(_A_),
	rcp_var(from(o10,0,1), O10),
	rcp_var(from(o10,0,2), O10_2),
	rcp_var(from(o10,0,3), O10_3),
	rcp_make_object_shape(_A_, [O10,O10_2,O10_3], 325, _B_).

rcp_o10_search(_B_) :- 
	rcp_s7_search(_A_),
	rcp_var(from(o10,0,1), O10),
	rcp_var(from(o10,0,2), O10_2),
	rcp_var(from(o10,0,3), O10_3),
	rcp_make_object_shape_search(_A_, [O10,O10_2,O10_3], 325, _B_).

rcp_s11(_A_) :- 
	rcp_var(from(s11,0,1), S11),
	rcp_var(from(s11,0,2), S11_2),
	rcp_var(from(s11,0,3), S11_3),
	rcp_make_shape_box([S11,S11_2,S11_3], _A_).

rcp_s11_search(_A_) :- 
	rcp_var(from(s11,0,1), S11),
	rcp_var(from(s11,0,2), S11_2),
	rcp_var(from(s11,0,3), S11_3),
	rcp_make_shape_box_search([S11,S11_2,S11_3], _A_).

rcp_s41(_A_) :- 
	rcp_make_shape_box([224,111,224], _A_).

rcp_s41_search(_A_) :- 
	rcp_make_shape_box_search([224,111,224], _A_).

rcp_s51(_A_) :- 
	rcp_make_shape_box([224,74,224], _A_).

rcp_s51_search(_A_) :- 
	rcp_make_shape_box_search([224,74,224], _A_).

rcp_o11(_B_) :- 
	s11(_A_),
	rcp_make_object_shape(_A_, [0,0,0], _B_).

rcp_o11_search(_B_) :- 
	rcp_s11_search(_A_),
	rcp_make_object_shape_search(_A_, [0,0,0], _B_).

rcp_o41(_C_) :- 
	s4(_A_),
	s41(_B_),
	rcp_var(from(o41,0,1), O41),
	rcp_var(from(o41,0,2), O41_2),
	rcp_var(from(o41,0,3), O41_3),
	rcp_var(from(o41,0,4), O41_4),
	rcp_rec([shapes=[_A_,_B_],shape_index=O41,origin=[O41_2,O41_3,O41_4],weight=413], _C_).

rcp_o41_search(_C_) :- 
	rcp_s4_search(_A_),
	rcp_s41_search(_B_),
	rcp_var(from(o41,0,1), O41),
	rcp_var(from(o41,0,2), O41_2),
	rcp_var(from(o41,0,3), O41_3),
	rcp_var(from(o41,0,4), O41_4),
	rcp_rec([shapes=[_A_,_B_],shape_index=O41,origin=[O41_2,O41_3,O41_4],weight=413], _C_).

rcp_o51(_C_) :- 
	s5(_A_),
	s51(_B_),
	rcp_var(from(o51,0,1), O51),
	rcp_var(from(o51,0,2), O51_2),
	rcp_var(from(o51,0,3), O51_3),
	rcp_var(from(o51,0,4), O51_4),
	rcp_rec([shapes=[_A_,_B_],shape_index=O51,origin=[O51_2,O51_3,O51_4],weight=463], _C_).

rcp_o51_search(_C_) :- 
	rcp_s5_search(_A_),
	rcp_s51_search(_B_),
	rcp_var(from(o51,0,1), O51),
	rcp_var(from(o51,0,2), O51_2),
	rcp_var(from(o51,0,3), O51_3),
	rcp_var(from(o51,0,4), O51_4),
	rcp_rec([shapes=[_A_,_B_],shape_index=O51,origin=[O51_2,O51_3,O51_4],weight=463], _C_).

rcp_bin(_A_) :- 
	o1(_A_).

rcp_bin_search(_A_) :- 
	rcp_o1_search(_A_).

rcp_items(_J_) :- 
	o2(_A_),
	o3(_B_),
	o4(_C_),
	o5(_D_),
	o6(_E_),
	o7(_F_),
	o8(_G_),
	o9(_H_),
	o10(_I_),
	_J_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_,_H_,_I_].

rcp_items_search(_J_) :- 
	rcp_o2_search(_A_),
	rcp_o3_search(_B_),
	rcp_o4_search(_C_),
	rcp_o5_search(_D_),
	rcp_o6_search(_E_),
	rcp_o7_search(_F_),
	rcp_o8_search(_G_),
	rcp_o9_search(_H_),
	rcp_o10_search(_I_),
	_J_=[_A_,_B_,_C_,_D_,_E_,_F_,_G_,_H_,_I_].

rcp_dimensions(_A_) :- 
	_A_=[1,2,3].

rcp_dimensions_search(_A_) :- 
	_A_=[1,2,3].

rcp_geost_greedyflag(Geost_greedyflag) :- 
	rcp_var(from(geost_greedyflag,0,1), Geost_greedyflag).

rcp_geost_greedyflag_search(Geost_greedyflag) :- 
	rcp_var(from(geost_greedyflag,0,1), Geost_greedyflag).

rcp_sum_foldr_1([], _, 0) :- 
	!.
rcp_sum_foldr_1([X_406|Tail], [L], _B_) :- 
	rcp_sum_foldr_1(Tail, [L], _A_),
	fd_aeq(X_406+_A_, _B_).

rcp_sum_foldr_1_search([], _, 0) :- 
	!.
rcp_sum_foldr_1_search([X_406|Tail], [L], _D_) :- 
	rcp_sum_foldr_1_search(Tail, [L], _C_),
	fd_aeq(X_406+_C_, _D_).

rcp_sum(L, _A_) :- 
	rcp_sum_foldr_1(L, [L], _A_).

rcp_sum_search(L, _A_) :- 
	rcp_sum_foldr_1_search(L, [L], _A_).

rcp_product_foldr_2([], _, 1) :- 
	!.
rcp_product_foldr_2([X_407|Tail], [L], _B_) :- 
	rcp_product_foldr_2(Tail, [L], _A_),
	fd_aeq(X_407*_A_, _B_).

rcp_product_foldr_2_search([], _, 1) :- 
	!.
rcp_product_foldr_2_search([X_407|Tail], [L], _D_) :- 
	rcp_product_foldr_2_search(Tail, [L], _C_),
	fd_aeq(X_407*_C_, _D_).

rcp_product(L, _A_) :- 
	rcp_product_foldr_2(L, [L], _A_).

rcp_product_search(L, _A_) :- 
	rcp_product_foldr_2_search(L, [L], _A_).

rcp_maximum_foldr_3([], _, -268435456) :- 
	!.
rcp_maximum_foldr_3([X_408|Tail], [L], _B_) :- 
	rcp_maximum_foldr_3(Tail, [L], _A_),
	fd_aeq(max(X_408,_A_), _B_).

rcp_maximum_foldr_3_search([], _, -268435456) :- 
	!.
rcp_maximum_foldr_3_search([X_408|Tail], [L], _D_) :- 
	rcp_maximum_foldr_3_search(Tail, [L], _C_),
	fd_aeq(max(X_408,_C_), _D_).

rcp_maximum(L, _A_) :- 
	rcp_maximum_foldr_3(L, [L], _A_).

rcp_maximum_search(L, _A_) :- 
	rcp_maximum_foldr_3_search(L, [L], _A_).

rcp_minimum_foldr_4([], _, 267999999) :- 
	!.
rcp_minimum_foldr_4([X_409|Tail], [L], _B_) :- 
	rcp_minimum_foldr_4(Tail, [L], _A_),
	fd_aeq(min(X_409,_A_), _B_).

rcp_minimum_foldr_4_search([], _, 267999999) :- 
	!.
rcp_minimum_foldr_4_search([X_409|Tail], [L], _D_) :- 
	rcp_minimum_foldr_4_search(Tail, [L], _C_),
	fd_aeq(min(X_409,_C_), _D_).

rcp_minimum(L, _A_) :- 
	rcp_minimum_foldr_4(L, [L], _A_).

rcp_minimum_search(L, _A_) :- 
	rcp_minimum_foldr_4_search(L, [L], _A_).

rcp_geost_constraint_foldr_6([], _, []) :- 
	!.
rcp_geost_constraint_foldr_6([S_412|Tail], [Dims,I_410,Items], [_A_|_B_]) :- 
	rcp_att(uid, S_412, _A_),
	rcp_geost_constraint_foldr_6(Tail, [Dims,I_410,Items], _B_).

rcp_geost_constraint_foldr_6_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_6_search([S_412|Tail], [Dims,I_410,Items], [_C_|_D_]) :- 
	rcp_att(uid, S_412, _C_),
	rcp_geost_constraint_foldr_6_search(Tail, [Dims,I_410,Items], _D_).

rcp_geost_constraint_foldr_5([], _, []) :- 
	!.
rcp_geost_constraint_foldr_5([I_410|Tail], [Dims,Items], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_410, _A_),
	rcp_att(shape_index, I_410, _B_),
	rcp_att(shapes, I_410, _C_),
	rcp_geost_constraint_foldr_6(_C_, [Dims,I_410,Items], _D_),
	rcp_att(origin, I_410, _E_),
	rcp_geost_constraint_foldr_5(Tail, [Dims,Items], _F_).

rcp_geost_constraint_foldr_5_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_5_search([I_410|Tail], [Dims,Items], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_410, _G_),
	rcp_att(shape_index, I_410, _H_),
	rcp_att(shapes, I_410, _I_),
	rcp_geost_constraint_foldr_6_search(_I_, [Dims,I_410,Items], _J_),
	rcp_att(origin, I_410, _K_),
	rcp_geost_constraint_foldr_5_search(Tail, [Dims,Items], _L_).

rcp_geost_constraint_foldr_9([], _, []) :- 
	!.
rcp_geost_constraint_foldr_9([SB_418|Tail], [Dims,I_413,Items,S_416], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_416, _A_),
	rcp_att(offset, SB_418, _B_),
	rcp_att(box, SB_418, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_9(Tail, [Dims,I_413,Items,S_416], _E_).

rcp_geost_constraint_foldr_9_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_9_search([SB_418|Tail], [Dims,I_413,Items,S_416], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_416, _F_),
	rcp_att(offset, SB_418, _G_),
	rcp_att(box, SB_418, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_9_search(Tail, [Dims,I_413,Items,S_416], _J_).

rcp_geost_constraint_foldr_8([], _, []) :- 
	!.
rcp_geost_constraint_foldr_8([S_416|Tail], [Dims,I_413,Items], [_B_|_C_]) :- 
	rcp_att(sboxes, S_416, _A_),
	rcp_geost_constraint_foldr_9(_A_, [Dims,I_413,Items,S_416], _B_),
	rcp_geost_constraint_foldr_8(Tail, [Dims,I_413,Items], _C_).

rcp_geost_constraint_foldr_8_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_8_search([S_416|Tail], [Dims,I_413,Items], [_E_|_F_]) :- 
	rcp_att(sboxes, S_416, _D_),
	rcp_geost_constraint_foldr_9_search(_D_, [Dims,I_413,Items,S_416], _E_),
	rcp_geost_constraint_foldr_8_search(Tail, [Dims,I_413,Items], _F_).

rcp_geost_constraint_foldr_7([], _, []) :- 
	!.
rcp_geost_constraint_foldr_7([I_413|Tail], [Dims,Items], [_B_|_C_]) :- 
	rcp_att(shapes, I_413, _A_),
	rcp_geost_constraint_foldr_8(_A_, [Dims,I_413,Items], _B_),
	rcp_geost_constraint_foldr_7(Tail, [Dims,Items], _C_).

rcp_geost_constraint_foldr_7_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_7_search([I_413|Tail], [Dims,Items], [_E_|_F_]) :- 
	rcp_att(shapes, I_413, _D_),
	rcp_geost_constraint_foldr_8_search(_D_, [Dims,I_413,Items], _E_),
	rcp_geost_constraint_foldr_7_search(Tail, [Dims,Items], _F_).

rcp_non_overlapping(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_5(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_7(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_non_overlapping_search(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_5_search(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_7_search(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_geost_constraint_foldr_11([], _, []) :- 
	!.
rcp_geost_constraint_foldr_11([S_421|Tail], [Dims,F,I_419,Items,Patterns], [_A_|_B_]) :- 
	rcp_att(uid, S_421, _A_),
	rcp_geost_constraint_foldr_11(Tail, [Dims,F,I_419,Items,Patterns], _B_).

rcp_geost_constraint_foldr_11_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_11_search([S_421|Tail], [Dims,F,I_419,Items,Patterns], [_C_|_D_]) :- 
	rcp_att(uid, S_421, _C_),
	rcp_geost_constraint_foldr_11_search(Tail, [Dims,F,I_419,Items,Patterns], _D_).

rcp_geost_constraint_foldr_10([], _, []) :- 
	!.
rcp_geost_constraint_foldr_10([I_419|Tail], [Dims,F,Items,Patterns], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_419, _A_),
	rcp_att(shape_index, I_419, _B_),
	rcp_att(shapes, I_419, _C_),
	rcp_geost_constraint_foldr_11(_C_, [Dims,F,I_419,Items,Patterns], _D_),
	rcp_att(origin, I_419, _E_),
	rcp_geost_constraint_foldr_10(Tail, [Dims,F,Items,Patterns], _F_).

rcp_geost_constraint_foldr_10_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_10_search([I_419|Tail], [Dims,F,Items,Patterns], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_419, _G_),
	rcp_att(shape_index, I_419, _H_),
	rcp_att(shapes, I_419, _I_),
	rcp_geost_constraint_foldr_11_search(_I_, [Dims,F,I_419,Items,Patterns], _J_),
	rcp_att(origin, I_419, _K_),
	rcp_geost_constraint_foldr_10_search(Tail, [Dims,F,Items,Patterns], _L_).

rcp_geost_constraint_foldr_14([], _, []) :- 
	!.
rcp_geost_constraint_foldr_14([SB_427|Tail], [Dims,F,I_422,Items,Patterns,S_425], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_425, _A_),
	rcp_att(offset, SB_427, _B_),
	rcp_att(box, SB_427, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_14(Tail, [Dims,F,I_422,Items,Patterns,S_425], _E_).

rcp_geost_constraint_foldr_14_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_14_search([SB_427|Tail], [Dims,F,I_422,Items,Patterns,S_425], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_425, _F_),
	rcp_att(offset, SB_427, _G_),
	rcp_att(box, SB_427, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_14_search(Tail, [Dims,F,I_422,Items,Patterns,S_425], _J_).

rcp_geost_constraint_foldr_13([], _, []) :- 
	!.
rcp_geost_constraint_foldr_13([S_425|Tail], [Dims,F,I_422,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(sboxes, S_425, _A_),
	rcp_geost_constraint_foldr_14(_A_, [Dims,F,I_422,Items,Patterns,S_425], _B_),
	rcp_geost_constraint_foldr_13(Tail, [Dims,F,I_422,Items,Patterns], _C_).

rcp_geost_constraint_foldr_13_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_13_search([S_425|Tail], [Dims,F,I_422,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(sboxes, S_425, _D_),
	rcp_geost_constraint_foldr_14_search(_D_, [Dims,F,I_422,Items,Patterns,S_425], _E_),
	rcp_geost_constraint_foldr_13_search(Tail, [Dims,F,I_422,Items,Patterns], _F_).

rcp_geost_constraint_foldr_12([], _, []) :- 
	!.
rcp_geost_constraint_foldr_12([I_422|Tail], [Dims,F,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(shapes, I_422, _A_),
	rcp_geost_constraint_foldr_13(_A_, [Dims,F,I_422,Items,Patterns], _B_),
	rcp_geost_constraint_foldr_12(Tail, [Dims,F,Items,Patterns], _C_).

rcp_geost_constraint_foldr_12_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_12_search([I_422|Tail], [Dims,F,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(shapes, I_422, _D_),
	rcp_geost_constraint_foldr_13_search(_D_, [Dims,F,I_422,Items,Patterns], _E_),
	rcp_geost_constraint_foldr_12_search(Tail, [Dims,F,Items,Patterns], _F_).

rcp_non_overlapping(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_10(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_12(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_non_overlapping_search(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_10_search(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_12_search(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall_search(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_precedes(A, B, D, _C_) :- 
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_).

rcp_precedes_search(A, B, D, _C_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	fd_lt(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_meets(A, B, D, _C_) :- 
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_).

rcp_meets_search(A, B, D, _C_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	fd_eq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_overlaps(A, B, D, _K_) :- 
	fd_and(_C_, _J_, _K_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_and(_F_, _I_, _J_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_),
	rcp_origin(B, D, _G_),
	rcp_end(A, D, _H_),
	fd_lt(_G_, _H_, _I_).

rcp_overlaps_search(A, B, D, _G_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	rcp_origin_search(B, D, _E_),
	rcp_end_search(A, D, _F_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_lt(_E_, _F_),
	fd_aeq(_G_, 1).

rcp_contains(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_contains_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_starts(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_starts_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_eq(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_finishes(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_finishes_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_lt(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_equals(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_equals_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_eq(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_started_by(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_started_by_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_eq(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_finished_by(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_gt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_finished_by_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_gt(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_during(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_during_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_overlapped_by(A, B, D, _K_) :- 
	fd_and(_C_, _J_, _K_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_and(_F_, _I_, _J_),
	rcp_origin(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_),
	rcp_end(A, D, _G_),
	rcp_end(B, D, _H_),
	fd_gt(_G_, _H_, _I_).

rcp_overlapped_by_search(A, B, D, _G_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_origin_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	rcp_end_search(A, D, _E_),
	rcp_end_search(B, D, _F_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_gt(_E_, _F_),
	fd_aeq(_G_, 1).

rcp_met_by(A, B, D, _C_) :- 
	rcp_end(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_eq(_A_, _B_, _C_).

rcp_met_by_search(A, B, D, _C_) :- 
	rcp_end_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	fd_eq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_preceded_by(A, B, D, _C_) :- 
	rcp_end(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_).

rcp_preceded_by_search(A, B, D, _C_) :- 
	rcp_end_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	fd_lt(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_contains_touch(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_leq(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_leq(_D_, _E_, _F_).

rcp_contains_touch_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_leq(_A_, _B_),
	fd_leq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_overlaps_sym(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_gt(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_origin(A, D, _E_),
	fd_gt(_D_, _E_, _F_).

rcp_overlaps_sym_search(A, B, D, _E_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_origin_search(A, D, _D_),
	fd_gt(_A_, _B_),
	fd_gt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_disjoint_foldr_15([], _, 0) :- 
	!.
rcp_disjoint_foldr_15([D_428|Tail], [Ds,O1,O2], _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_or(_A_, _B_, _C_),
	rcp_precedes(O1, O2, D_428, _A_),
	rcp_preceded_by(O1, O2, D_428, _B_),
	rcp_disjoint_foldr_15(Tail, [Ds,O1,O2], _D_).

rcp_disjoint_foldr_15_search([], _, 0) :- 
	!.
rcp_disjoint_foldr_15_search([D_428|Tail], [Ds,O1,O2], _) :- 
	(
	(
	rcp_precedes_search(O1, O2, D_428, _F_),
	rcp_assert(_F_)
	;
	rcp_preceded_by_search(O1, O2, D_428, _G_),
	rcp_assert(_G_)
	)
	;
	rcp_disjoint_foldr_15_search(Tail, [Ds,O1,O2], _H_),
	rcp_assert(_H_)
	).

rcp_disjoint(O1, O2, Ds, _A_) :- 
	rcp_disjoint_foldr_15(Ds, [Ds,O1,O2], _A_).

rcp_disjoint_search(O1, O2, Ds, _A_) :- 
	rcp_disjoint_foldr_15_search(Ds, [Ds,O1,O2], _A_).

rcp_meet_foldr_16([], _, 1) :- 
	!.
rcp_meet_foldr_16([D_429|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_and(_B_, _D_, _E_),
	fd_not(_A_, _B_),
	rcp_precedes(O1, O2, D_429, _A_),
	fd_not(_C_, _D_),
	rcp_preceded_by(O1, O2, D_429, _C_),
	rcp_meet_foldr_16(Tail, [Ds,O1,O2], _F_).

rcp_meet_foldr_16_search([], _, 1) :- 
	!.
rcp_meet_foldr_16_search([D_429|Tail], [Ds,O1,O2], _) :- 
	rcp_precedes_search(O1, O2, D_429, _H_),
	fd_not(_H_, _I_),
	rcp_assert(_I_),
	rcp_preceded_by_search(O1, O2, D_429, _J_),
	fd_not(_J_, _K_),
	rcp_assert(_K_),
	rcp_meet_foldr_16_search(Tail, [Ds,O1,O2], _L_),
	rcp_assert(_L_).

rcp_meet_foldr_17([], _, 0) :- 
	!.
rcp_meet_foldr_17([D_430|Tail], [Ds,O1,O2], _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_or(_A_, _B_, _C_),
	rcp_meets(O1, O2, D_430, _A_),
	rcp_met_by(O1, O2, D_430, _B_),
	rcp_meet_foldr_17(Tail, [Ds,O1,O2], _D_).

rcp_meet_foldr_17_search([], _, 0) :- 
	!.
rcp_meet_foldr_17_search([D_430|Tail], [Ds,O1,O2], _) :- 
	(
	(
	rcp_meets_search(O1, O2, D_430, _F_),
	rcp_assert(_F_)
	;
	rcp_met_by_search(O1, O2, D_430, _G_),
	rcp_assert(_G_)
	)
	;
	rcp_meet_foldr_17_search(Tail, [Ds,O1,O2], _H_),
	rcp_assert(_H_)
	).

rcp_meet(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_meet_foldr_16(Ds, [Ds,O1,O2], _A_),
	rcp_meet_foldr_17(Ds, [Ds,O1,O2], _B_).

rcp_meet_search(O1, O2, Ds, _C_) :- 
	rcp_meet_foldr_16_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_meet_foldr_17_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_equal_foldr_18([], _, 1) :- 
	!.
rcp_equal_foldr_18([D_431|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_equals(O1, O2, D_431, _A_),
	rcp_equal_foldr_18(Tail, [Ds,O1,O2], _B_).

rcp_equal_foldr_18_search([], _, 1) :- 
	!.
rcp_equal_foldr_18_search([D_431|Tail], [Ds,O1,O2], _) :- 
	rcp_equals_search(O1, O2, D_431, _D_),
	rcp_assert(_D_),
	rcp_equal_foldr_18_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_equal(O1, O2, Ds, _A_) :- 
	rcp_equal_foldr_18(Ds, [Ds,O1,O2], _A_).

rcp_equal_search(O1, O2, Ds, _A_) :- 
	rcp_equal_foldr_18_search(Ds, [Ds,O1,O2], _A_).

rcp_covers_foldr_19([], _, 1) :- 
	!.
rcp_covers_foldr_19([D_432|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_or(_A_, _D_, _E_),
	rcp_started_by(O1, O2, D_432, _A_),
	fd_or(_B_, _C_, _D_),
	rcp_contains(O1, O2, D_432, _B_),
	rcp_finished_by(O1, O2, D_432, _C_),
	rcp_covers_foldr_19(Tail, [Ds,O1,O2], _F_).

rcp_covers_foldr_19_search([], _, 1) :- 
	!.
rcp_covers_foldr_19_search([D_432|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_started_by_search(O1, O2, D_432, _H_),
	rcp_assert(_H_)
	;
	(
	rcp_contains_search(O1, O2, D_432, _I_),
	rcp_assert(_I_)
	;
	rcp_finished_by_search(O1, O2, D_432, _J_),
	rcp_assert(_J_)
	)
	),
	rcp_covers_foldr_19_search(Tail, [Ds,O1,O2], _K_),
	rcp_assert(_K_).

rcp_covers_foldr_20([], _, 0) :- 
	!.
rcp_covers_foldr_20([D_433|Tail], [Ds,O1,O2], _D_) :- 
	fd_or(_B_, _C_, _D_),
	fd_not(_A_, _B_),
	rcp_contains(O1, O2, D_433, _A_),
	rcp_covers_foldr_20(Tail, [Ds,O1,O2], _C_).

rcp_covers_foldr_20_search([], _, 0) :- 
	!.
rcp_covers_foldr_20_search([D_433|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_contains_search(O1, O2, D_433, _E_),
	fd_not(_E_, _F_),
	rcp_assert(_F_)
	;
	rcp_covers_foldr_20_search(Tail, [Ds,O1,O2], _G_),
	rcp_assert(_G_)
	).

rcp_covers(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_covers_foldr_19(Ds, [Ds,O1,O2], _A_),
	rcp_covers_foldr_20(Ds, [Ds,O1,O2], _B_).

rcp_covers_search(O1, O2, Ds, _C_) :- 
	rcp_covers_foldr_19_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_covers_foldr_20_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_covered_by_foldr_21([], _, 1) :- 
	!.
rcp_covered_by_foldr_21([D_434|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_or(_A_, _D_, _E_),
	rcp_starts(O1, O2, D_434, _A_),
	fd_or(_B_, _C_, _D_),
	rcp_during(O1, O2, D_434, _B_),
	rcp_finishes(O1, O2, D_434, _C_),
	rcp_covered_by_foldr_21(Tail, [Ds,O1,O2], _F_).

rcp_covered_by_foldr_21_search([], _, 1) :- 
	!.
rcp_covered_by_foldr_21_search([D_434|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_starts_search(O1, O2, D_434, _H_),
	rcp_assert(_H_)
	;
	(
	rcp_during_search(O1, O2, D_434, _I_),
	rcp_assert(_I_)
	;
	rcp_finishes_search(O1, O2, D_434, _J_),
	rcp_assert(_J_)
	)
	),
	rcp_covered_by_foldr_21_search(Tail, [Ds,O1,O2], _K_),
	rcp_assert(_K_).

rcp_covered_by_foldr_22([], _, 0) :- 
	!.
rcp_covered_by_foldr_22([D_435|Tail], [Ds,O1,O2], _D_) :- 
	fd_or(_B_, _C_, _D_),
	fd_not(_A_, _B_),
	rcp_during(O1, O2, D_435, _A_),
	rcp_covered_by_foldr_22(Tail, [Ds,O1,O2], _C_).

rcp_covered_by_foldr_22_search([], _, 0) :- 
	!.
rcp_covered_by_foldr_22_search([D_435|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_during_search(O1, O2, D_435, _E_),
	fd_not(_E_, _F_),
	rcp_assert(_F_)
	;
	rcp_covered_by_foldr_22_search(Tail, [Ds,O1,O2], _G_),
	rcp_assert(_G_)
	).

rcp_covered_by(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_covered_by_foldr_21(Ds, [Ds,O1,O2], _A_),
	rcp_covered_by_foldr_22(Ds, [Ds,O1,O2], _B_).

rcp_covered_by_search(O1, O2, Ds, _C_) :- 
	rcp_covered_by_foldr_21_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_covered_by_foldr_22_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_contains_rcc_foldr_23([], _, 1) :- 
	!.
rcp_contains_rcc_foldr_23([D_436|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains(O1, O2, D_436, _A_),
	rcp_contains_rcc_foldr_23(Tail, [Ds,O1,O2], _B_).

rcp_contains_rcc_foldr_23_search([], _, 1) :- 
	!.
rcp_contains_rcc_foldr_23_search([D_436|Tail], [Ds,O1,O2], _) :- 
	rcp_contains_search(O1, O2, D_436, _D_),
	rcp_assert(_D_),
	rcp_contains_rcc_foldr_23_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_contains_rcc(O1, O2, Ds, _A_) :- 
	rcp_contains_rcc_foldr_23(Ds, [Ds,O1,O2], _A_).

rcp_contains_rcc_search(O1, O2, Ds, _A_) :- 
	rcp_contains_rcc_foldr_23_search(Ds, [Ds,O1,O2], _A_).

rcp_inside_foldr_24([], _, 1) :- 
	!.
rcp_inside_foldr_24([D_437|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_during(O1, O2, D_437, _A_),
	rcp_inside_foldr_24(Tail, [Ds,O1,O2], _B_).

rcp_inside_foldr_24_search([], _, 1) :- 
	!.
rcp_inside_foldr_24_search([D_437|Tail], [Ds,O1,O2], _) :- 
	rcp_during_search(O1, O2, D_437, _D_),
	rcp_assert(_D_),
	rcp_inside_foldr_24_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_inside(O1, O2, Ds, _A_) :- 
	rcp_inside_foldr_24(Ds, [Ds,O1,O2], _A_).

rcp_inside_search(O1, O2, Ds, _A_) :- 
	rcp_inside_foldr_24_search(Ds, [Ds,O1,O2], _A_).

rcp_overlap_foldr_25([], _, 1) :- 
	!.
rcp_overlap_foldr_25([D_438|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_overlaps_sym(O1, O2, D_438, _A_),
	rcp_overlap_foldr_25(Tail, [Ds,O1,O2], _B_).

rcp_overlap_foldr_25_search([], _, 1) :- 
	!.
rcp_overlap_foldr_25_search([D_438|Tail], [Ds,O1,O2], _) :- 
	rcp_overlaps_sym_search(O1, O2, D_438, _D_),
	rcp_assert(_D_),
	rcp_overlap_foldr_25_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_overlap(O1, O2, Ds, _A_) :- 
	rcp_overlap_foldr_25(Ds, [Ds,O1,O2], _A_).

rcp_overlap_search(O1, O2, Ds, _A_) :- 
	rcp_overlap_foldr_25_search(Ds, [Ds,O1,O2], _A_).

rcp_contains_touch_rcc_foldr_26([], _, 1) :- 
	!.
rcp_contains_touch_rcc_foldr_26([D_439|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains_touch(O1, O2, D_439, _A_),
	rcp_contains_touch_rcc_foldr_26(Tail, [Ds,O1,O2], _B_).

rcp_contains_touch_rcc_foldr_26_search([], _, 1) :- 
	!.
rcp_contains_touch_rcc_foldr_26_search([D_439|Tail], [Ds,O1,O2], _) :- 
	rcp_contains_touch_search(O1, O2, D_439, _D_),
	rcp_assert(_D_),
	rcp_contains_touch_rcc_foldr_26_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_contains_touch_rcc(O1, O2, Ds, _A_) :- 
	rcp_contains_touch_rcc_foldr_26(Ds, [Ds,O1,O2], _A_).

rcp_contains_touch_rcc_search(O1, O2, Ds, _A_) :- 
	rcp_contains_touch_rcc_foldr_26_search(Ds, [Ds,O1,O2], _A_).

rcp_above(O1, O2, _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_and(_A_, _B_, _C_),
	rcp_overlap(O1, O2, [1,2], _A_),
	rcp_preceded_by(O1, O2, 3, _B_),
	rcp_met_by(O1, O2, 3, _D_).

rcp_above_search(O1, O2, _D_) :- 
	(
	rcp_overlap_search(O1, O2, [1,2], _A_),
	rcp_assert(_A_),
	rcp_preceded_by_search(O1, O2, 3, _B_),
	rcp_assert(_B_)
	;
	rcp_met_by_search(O1, O2, 3, _C_),
	rcp_assert(_C_)
	),
	fd_aeq(_D_, 1).

rcp_on_top(O1, O2, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_overlap(O1, O2, [1,2], _A_),
	rcp_met_by(O1, O2, 3, _B_).

rcp_on_top_search(O1, O2, _C_) :- 
	rcp_overlap_search(O1, O2, [1,2], _A_),
	rcp_assert(_A_),
	rcp_met_by_search(O1, O2, 3, _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_oversize(O1, O2, D, _O_) :- 
	rcp_origin(O1, D, _A_),
	rcp_origin(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_origin(O1, D, _D_),
	rcp_origin(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	rcp_end(O1, D, _H_),
	rcp_end(O2, D, _I_),
	fd_aeq(max(_H_,_I_), _J_),
	rcp_end(O1, D, _K_),
	rcp_end(O2, D, _L_),
	fd_aeq(min(_K_,_L_), _M_),
	fd_aeq(_J_-_M_, _N_),
	fd_aeq(max(_G_,_N_), _O_).

rcp_oversize_search(O1, O2, D, _O_) :- 
	rcp_origin_search(O1, D, _A_),
	rcp_origin_search(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_origin_search(O1, D, _D_),
	rcp_origin_search(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	rcp_end_search(O1, D, _H_),
	rcp_end_search(O2, D, _I_),
	fd_aeq(max(_H_,_I_), _J_),
	rcp_end_search(O1, D, _K_),
	rcp_end_search(O2, D, _L_),
	fd_aeq(min(_K_,_L_), _M_),
	fd_aeq(_J_-_M_, _N_),
	fd_aeq(max(_G_,_N_), _O_).

rcp_stack_oversize_foldr_29([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_29([D_445|Tail], [Items,Length,O1_440,O2_443], _D_) :- 
	fd_and(_B_, _C_, _D_),
	rcp_oversize(O1_440, O2_443, D_445, _A_),
	fd_leq(_A_, Length, _B_),
	rcp_stack_oversize_foldr_29(Tail, [Items,Length,O1_440,O2_443], _C_).

rcp_stack_oversize_foldr_29_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_29_search([D_445|Tail], [Items,Length,O1_440,O2_443], _) :- 
	rcp_oversize_search(O1_440, O2_443, D_445, _E_),
	fd_leq(_E_, Length),
	rcp_stack_oversize_foldr_29_search(Tail, [Items,Length,O1_440,O2_443], _F_),
	rcp_assert(_F_).

rcp_stack_oversize_foldr_28([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_28([O2_443|Tail], [Items,Length,O1_440], _I_) :- 
	fd_and(_G_, _H_, _I_),
	fd_implies(_E_, _F_, _G_),
	fd_and(_A_, _D_, _E_),
	rcp_overlap(O1_440, O2_443, [1,2], _A_),
	rcp_att(uid, O1_440, _B_),
	rcp_att(uid, O2_443, _C_),
	fd_neq(_B_, _C_, _D_),
	rcp_stack_oversize_foldr_29([1,2], [Items,Length,O1_440,O2_443], _F_),
	rcp_stack_oversize_foldr_28(Tail, [Items,Length,O1_440], _H_).

rcp_stack_oversize_foldr_28_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_28_search([O2_443|Tail], [Items,Length,O1_440], _) :- 
	rcp_att(uid, O1_440, _K_),
	rcp_att(uid, O2_443, _L_),
	rcp_att(uid, O1_440, _O_),
	rcp_att(uid, O2_443, _P_),
	(
	rcp_overlap_search(O1_440, O2_443, [1,2], _J_),
	rcp_assert(_J_),
	fd_neq(_K_, _L_),
	rcp_stack_oversize_foldr_29_search([1,2], [Items,Length,O1_440,O2_443], _Q_),
	fd_equiv(_Q_, _R_, 1)
	;
	(
	rcp_overlap_search(O1_440, O2_443, [1,2], _M_),
	fd_not(_M_, _N_),
	rcp_assert(_N_)
	;
	fd_eq(_O_, _P_)
	),
	fd_aeq(_R_, 1)
	),
	rcp_assert(_R_),
	rcp_stack_oversize_foldr_28_search(Tail, [Items,Length,O1_440], _S_),
	rcp_assert(_S_).

rcp_stack_oversize_foldr_27([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_27([O1_440|Tail], [Items,Length], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_stack_oversize_foldr_28(Items, [Items,Length,O1_440], _A_),
	rcp_stack_oversize_foldr_27(Tail, [Items,Length], _B_).

rcp_stack_oversize_foldr_27_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_27_search([O1_440|Tail], [Items,Length], _) :- 
	rcp_stack_oversize_foldr_28_search(Items, [Items,Length,O1_440], _D_),
	rcp_assert(_D_),
	rcp_stack_oversize_foldr_27_search(Tail, [Items,Length], _E_),
	rcp_assert(_E_).

rcp_stack_oversize(Items, Length, _A_) :- 
	rcp_stack_oversize_foldr_27(Items, [Items,Length], _A_).

rcp_stack_oversize_search(Items, Length, _A_) :- 
	rcp_stack_oversize_foldr_27_search(Items, [Items,Length], _A_).

rcp_lighter(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_leq(_A_, _B_, _C_).

rcp_lighter_search(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_leq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_heavier(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_geq(_A_, _B_, _C_).

rcp_heavier_search(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_geq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_gravity_foldr_31([], _, 0) :- 
	!.
rcp_gravity_foldr_31([O2_448|Tail], [Items,O1_446], _G_) :- 
	fd_or(_E_, _F_, _G_),
	fd_and(_C_, _D_, _E_),
	rcp_att(uid, O1_446, _A_),
	rcp_att(uid, O2_448, _B_),
	fd_neq(_A_, _B_, _C_),
	rcp_on_top(O1_446, O2_448, _D_),
	rcp_gravity_foldr_31(Tail, [Items,O1_446], _F_).

rcp_gravity_foldr_31_search([], _, 0) :- 
	!.
rcp_gravity_foldr_31_search([O2_448|Tail], [Items,O1_446], _) :- 
	rcp_att(uid, O1_446, _H_),
	rcp_att(uid, O2_448, _I_),
	(
	fd_neq(_H_, _I_),
	rcp_on_top_search(O1_446, O2_448, _J_),
	rcp_assert(_J_)
	;
	rcp_gravity_foldr_31_search(Tail, [Items,O1_446], _K_),
	rcp_assert(_K_)
	).

rcp_gravity_foldr_30([], _, 1) :- 
	!.
rcp_gravity_foldr_30([O1_446|Tail], [Items], _F_) :- 
	fd_and(_D_, _E_, _F_),
	fd_or(_B_, _C_, _D_),
	rcp_origin(O1_446, 3, _A_),
	fd_eq(_A_, 0, _B_),
	rcp_gravity_foldr_31(Items, [Items,O1_446], _C_),
	rcp_gravity_foldr_30(Tail, [Items], _E_).

rcp_gravity_foldr_30_search([], _, 1) :- 
	!.
rcp_gravity_foldr_30_search([O1_446|Tail], [Items], _) :- 
	rcp_origin_search(O1_446, 3, _G_),
	(
	fd_eq(_G_, 0)
	;
	rcp_gravity_foldr_31_search(Items, [Items,O1_446], _H_),
	rcp_assert(_H_)
	),
	rcp_gravity_foldr_30_search(Tail, [Items], _I_),
	rcp_assert(_I_).

rcp_gravity(Items, _A_) :- 
	rcp_gravity_foldr_30(Items, [Items], _A_).

rcp_gravity_search(Items, _A_) :- 
	rcp_gravity_foldr_30_search(Items, [Items], _A_).

rcp_weight_stacking_foldr_33([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_33([O2_451|Tail], [Items,O1_449], _I_) :- 
	fd_and(_G_, _H_, _I_),
	fd_implies(_E_, _F_, _G_),
	fd_and(_C_, _D_, _E_),
	rcp_att(uid, O1_449, _A_),
	rcp_att(uid, O2_451, _B_),
	fd_neq(_A_, _B_, _C_),
	rcp_above(O1_449, O2_451, _D_),
	rcp_lighter(O1_449, O2_451, _F_),
	rcp_weight_stacking_foldr_33(Tail, [Items,O1_449], _H_).

rcp_weight_stacking_foldr_33_search([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_33_search([O2_451|Tail], [Items,O1_449], _) :- 
	rcp_att(uid, O1_449, _J_),
	rcp_att(uid, O2_451, _K_),
	rcp_att(uid, O1_449, _M_),
	rcp_att(uid, O2_451, _N_),
	(
	fd_neq(_J_, _K_),
	rcp_above_search(O1_449, O2_451, _L_),
	rcp_assert(_L_),
	rcp_lighter_search(O1_449, O2_451, _Q_),
	fd_equiv(_Q_, _R_, 1)
	;
	(
	fd_eq(_M_, _N_)
	;
	rcp_above_search(O1_449, O2_451, _O_),
	fd_not(_O_, _P_),
	rcp_assert(_P_)
	),
	fd_aeq(_R_, 1)
	),
	rcp_assert(_R_),
	rcp_weight_stacking_foldr_33_search(Tail, [Items,O1_449], _S_),
	rcp_assert(_S_).

rcp_weight_stacking_foldr_32([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_32([O1_449|Tail], [Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_weight_stacking_foldr_33(Items, [Items,O1_449], _A_),
	rcp_weight_stacking_foldr_32(Tail, [Items], _B_).

rcp_weight_stacking_foldr_32_search([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_32_search([O1_449|Tail], [Items], _) :- 
	rcp_weight_stacking_foldr_33_search(Items, [Items,O1_449], _D_),
	rcp_assert(_D_),
	rcp_weight_stacking_foldr_32_search(Tail, [Items], _E_),
	rcp_assert(_E_).

rcp_weight_stacking(Items, _A_) :- 
	rcp_weight_stacking_foldr_32(Items, [Items], _A_).

rcp_weight_stacking_search(Items, _A_) :- 
	rcp_weight_stacking_foldr_32_search(Items, [Items], _A_).

rcp_sum_foldr_34([], _, []) :- 
	!.
rcp_sum_foldr_34([Il_452|Tail], [Bin,D,Items,Ratio], [_F_|_G_]) :- 
	rcp_att(weight, Il_452, _A_),
	rcp_end(Il_452, D, _B_),
	rcp_end(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_leq(_B_, _D_, _E_),
	fd_aeq(_A_*_E_, _F_),
	rcp_sum_foldr_34(Tail, [Bin,D,Items,Ratio], _G_).

rcp_sum_foldr_34_search([], _, []) :- 
	!.
rcp_sum_foldr_34_search([Il_452|Tail], [Bin,D,Items,Ratio], [_L_|_M_]) :- 
	rcp_att(weight, Il_452, _H_),
	rcp_end_search(Il_452, D, _I_),
	rcp_end_search(Bin, D, _J_),
	fd_aeq(_J_/2, _K_),
	fd_aeq(_H_*fd_leq(_I_,_K_), _L_),
	rcp_sum_foldr_34_search(Tail, [Bin,D,Items,Ratio], _M_).

rcp_sum_foldr_35([], _, []) :- 
	!.
rcp_sum_foldr_35([Ir_456|Tail], [Bin,D,Items,L_453,Ratio], [_F_|_G_]) :- 
	rcp_att(weight, Ir_456, _A_),
	rcp_origin(Ir_456, D, _B_),
	rcp_end(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_geq(_B_, _D_, _E_),
	fd_aeq(_A_*_E_, _F_),
	rcp_sum_foldr_35(Tail, [Bin,D,Items,L_453,Ratio], _G_).

rcp_sum_foldr_35_search([], _, []) :- 
	!.
rcp_sum_foldr_35_search([Ir_456|Tail], [Bin,D,Items,L_453,Ratio], [_L_|_M_]) :- 
	rcp_att(weight, Ir_456, _H_),
	rcp_origin_search(Ir_456, D, _I_),
	rcp_end_search(Bin, D, _J_),
	fd_aeq(_J_/2, _K_),
	fd_aeq(_H_*fd_geq(_I_,_K_), _L_),
	rcp_sum_foldr_35_search(Tail, [Bin,D,Items,L_453,Ratio], _M_).

rcp_weight_balancing(Items, Bin, D, Ratio, _J_) :- 
	rcp_sum_foldr_34(Items, [Bin,D,Items,Ratio], _A_),
	rcp_sum(_A_, L_453),
	rcp_sum_foldr_35(Items, [Bin,D,Items,L_453,Ratio], _C_),
	rcp_sum(_C_, R_457),
	fd_aeq(max(L_453,R_457), _E_),
	fd_aeq(100*_E_, _F_),
	fd_aeq(100+Ratio, _G_),
	fd_aeq(min(L_453,R_457), _H_),
	fd_aeq(_G_*_H_, _I_),
	fd_leq(_F_, _I_, _J_).

rcp_weight_balancing_search(Items, Bin, D, Ratio, _J_) :- 
	rcp_sum_foldr_34_search(Items, [Bin,D,Items,Ratio], _A_),
	rcp_sum_search(_A_, L_453),
	rcp_sum_foldr_35_search(Items, [Bin,D,Items,L_453,Ratio], _C_),
	rcp_sum_search(_C_, R_457),
	fd_aeq(max(L_453,R_457), _E_),
	fd_aeq(100*_E_, _F_),
	fd_aeq(100+Ratio, _G_),
	fd_aeq(min(L_453,R_457), _H_),
	fd_aeq(_G_*_H_, _I_),
	fd_leq(_F_, _I_),
	fd_aeq(_J_, 1).

rcp_make_box(L, _A_) :- 
	rcp_rec([size=L], _A_).

rcp_make_box_search(L, _A_) :- 
	rcp_rec([size=L], _A_).

rcp_box_volume(B, _B_) :- 
	rcp_att(size, B, _A_),
	rcp_product(_A_, _B_).

rcp_box_volume_search(B, _B_) :- 
	rcp_att(size, B, _A_),
	rcp_product_search(_A_, _B_).

rcp_make_sbox(B, O, _A_) :- 
	rcp_rec([box=B,offset=O], _A_).

rcp_make_sbox_search(B, O, _A_) :- 
	rcp_rec([box=B,offset=O], _A_).

rcp_sbox_size(SB, D, _C_) :- 
	rcp_att(box, SB, _A_),
	rcp_att(size, _A_, _B_),
	nth1(D, _B_, _C_).

rcp_sbox_size_search(SB, D, _C_) :- 
	rcp_att(box, SB, _A_),
	rcp_att(size, _A_, _B_),
	nth1(D, _B_, _C_).

rcp_sbox_offset(SB, D, _B_) :- 
	rcp_att(offset, SB, _A_),
	nth1(D, _A_, _B_).

rcp_sbox_offset_search(SB, D, _B_) :- 
	rcp_att(offset, SB, _A_),
	nth1(D, _A_, _B_).

rcp_sbox_end(SB, D, _C_) :- 
	rcp_sbox_offset(SB, D, _A_),
	rcp_sbox_size(SB, D, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_sbox_end_search(SB, D, _C_) :- 
	rcp_sbox_offset_search(SB, D, _A_),
	rcp_sbox_size_search(SB, D, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_make_shape(SBs, _A_) :- 
	rcp_rec([sboxes=SBs], _A_).

rcp_make_shape_search(SBs, _A_) :- 
	rcp_rec([sboxes=SBs], _A_).

rcp_make_sbox_foldr_36([], _, []) :- 
	!.
rcp_make_sbox_foldr_36([_free_var_458|Tail], [L], [0|_A_]) :- 
	rcp_make_sbox_foldr_36(Tail, [L], _A_).

rcp_make_sbox_foldr_36_search([], _, []) :- 
	!.
rcp_make_sbox_foldr_36_search([_free_var_458|Tail], [L], [0|_B_]) :- 
	rcp_make_sbox_foldr_36_search(Tail, [L], _B_).

rcp_make_shape_box(L, _D_) :- 
	rcp_make_box(L, _A_),
	rcp_make_sbox_foldr_36(L, [L], _B_),
	rcp_make_sbox(_A_, _B_, _C_),
	rcp_make_shape([_C_], _D_).

rcp_make_shape_box_search(L, _D_) :- 
	rcp_make_box_search(L, _A_),
	rcp_make_sbox_foldr_36_search(L, [L], _B_),
	rcp_make_sbox_search(_A_, _B_, _C_),
	rcp_make_shape_search([_C_], _D_).

rcp_sum_foldr_37([], _, []) :- 
	!.
rcp_sum_foldr_37([SB_459|Tail], [S], [_B_|_C_]) :- 
	rcp_att(box, SB_459, _A_),
	rcp_box_volume(_A_, _B_),
	rcp_sum_foldr_37(Tail, [S], _C_).

rcp_sum_foldr_37_search([], _, []) :- 
	!.
rcp_sum_foldr_37_search([SB_459|Tail], [S], [_E_|_F_]) :- 
	rcp_att(box, SB_459, _D_),
	rcp_box_volume_search(_D_, _E_),
	rcp_sum_foldr_37_search(Tail, [S], _F_).

rcp_shape_volume(S, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_sum_foldr_37(_A_, [S], _B_),
	rcp_sum(_B_, _C_).

rcp_shape_volume_search(S, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_sum_foldr_37_search(_A_, [S], _B_),
	rcp_sum_search(_B_, _C_).

rcp_minimum_foldr_38([], _, []) :- 
	!.
rcp_minimum_foldr_38([SB_460|Tail], [D,S], [_A_|_B_]) :- 
	rcp_sbox_offset(SB_460, D, _A_),
	rcp_minimum_foldr_38(Tail, [D,S], _B_).

rcp_minimum_foldr_38_search([], _, []) :- 
	!.
rcp_minimum_foldr_38_search([SB_460|Tail], [D,S], [_C_|_D_]) :- 
	rcp_sbox_offset_search(SB_460, D, _C_),
	rcp_minimum_foldr_38_search(Tail, [D,S], _D_).

rcp_shape_origin(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_minimum_foldr_38(_A_, [D,S], _B_),
	rcp_minimum(_B_, _C_).

rcp_shape_origin_search(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_minimum_foldr_38_search(_A_, [D,S], _B_),
	rcp_minimum_search(_B_, _C_).

rcp_maximum_foldr_39([], _, []) :- 
	!.
rcp_maximum_foldr_39([SB_461|Tail], [D,S], [_A_|_B_]) :- 
	rcp_sbox_end(SB_461, D, _A_),
	rcp_maximum_foldr_39(Tail, [D,S], _B_).

rcp_maximum_foldr_39_search([], _, []) :- 
	!.
rcp_maximum_foldr_39_search([SB_461|Tail], [D,S], [_C_|_D_]) :- 
	rcp_sbox_end_search(SB_461, D, _C_),
	rcp_maximum_foldr_39_search(Tail, [D,S], _D_).

rcp_shape_end(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_maximum_foldr_39(_A_, [D,S], _B_),
	rcp_maximum(_B_, _C_).

rcp_shape_end_search(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_maximum_foldr_39_search(_A_, [D,S], _B_),
	rcp_maximum_search(_B_, _C_).

rcp_shape_size(S, D, _C_) :- 
	rcp_shape_end(S, D, _A_),
	rcp_shape_origin(S, D, _B_),
	fd_aeq(_A_-_B_, _C_).

rcp_shape_size_search(S, D, _C_) :- 
	rcp_shape_end_search(S, D, _A_),
	rcp_shape_origin_search(S, D, _B_),
	fd_aeq(_A_-_B_, _C_).

rcp_make_object(SL, OL, _A_) :- 
	rcp_var(from(make_object(SL,OL),0,0), Make_object_SL_OL),
	rcp_rec([shapes=SL,shape_index=Make_object_SL_OL,origin=OL], _A_).

rcp_make_object_search(SL, OL, _A_) :- 
	rcp_var(from(make_object(SL,OL),0,0), Make_object_SL_OL),
	rcp_rec([shapes=SL,shape_index=Make_object_SL_OL,origin=OL], _A_).

rcp_make_object(SL, OL, S, W, _A_) :- 
	rcp_rec([shapes=SL,shape_index=S,origin=OL,weight=W], _A_).

rcp_make_object_search(SL, OL, S, W, _A_) :- 
	rcp_rec([shapes=SL,shape_index=S,origin=OL,weight=W], _A_).

rcp_make_object_shape(S, L, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L], _A_).

rcp_make_object_shape_search(S, L, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L], _A_).

rcp_make_object_shape(S, L, W, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W], _A_).

rcp_make_object_shape_search(S, L, W, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W], _A_).

rcp_object_shape_domain(O, _E_) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	length(_B_, _C_),
	rcp_range([1.._C_], _D_),
	_A_ in _D_,
	fd_aeq(_E_, 1).

rcp_object_shape_domain_search(O, _E_) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	length(_B_, _C_),
	rcp_range([1.._C_], _D_),
	_A_ in _D_,
	fd_aeq(_E_, 1).

rcp_object_shape_domains_foldr_40([], _, 1) :- 
	!.
rcp_object_shape_domains_foldr_40([I_462|Tail], [Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_object_shape_domain(I_462, _A_),
	rcp_object_shape_domains_foldr_40(Tail, [Items], _B_).

rcp_object_shape_domains_foldr_40_search([], _, 1) :- 
	!.
rcp_object_shape_domains_foldr_40_search([I_462|Tail], [Items], _) :- 
	rcp_object_shape_domain_search(I_462, _D_),
	rcp_assert(_D_),
	rcp_object_shape_domains_foldr_40_search(Tail, [Items], _E_),
	rcp_assert(_E_).

rcp_object_shape_domains(Items, _A_) :- 
	rcp_object_shape_domains_foldr_40(Items, [Items], _A_).

rcp_object_shape_domains_search(Items, _A_) :- 
	rcp_object_shape_domains_foldr_40_search(Items, [Items], _A_).

rcp_origin(O, D, _B_) :- 
	rcp_att(origin, O, _A_),
	nth1(D, _A_, _B_).

rcp_origin_search(O, D, _B_) :- 
	rcp_att(origin, O, _A_),
	nth1(D, _A_, _B_).

rcp_x(O, _A_) :- 
	rcp_origin(O, 1, _A_).

rcp_x_search(O, _A_) :- 
	rcp_origin_search(O, 1, _A_).

rcp_y(O, _A_) :- 
	rcp_origin(O, 2, _A_).

rcp_y_search(O, _A_) :- 
	rcp_origin_search(O, 2, _A_).

rcp_z(O, _A_) :- 
	rcp_origin(O, 3, _A_).

rcp_z_search(O, _A_) :- 
	rcp_origin_search(O, 3, _A_).

rcp_sum_foldr_41([], _, []) :- 
	!.
rcp_sum_foldr_41([S_463|Tail], [D,O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_463),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_end(S_463, D, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_sum_foldr_41(Tail, [D,O], _G_).

rcp_sum_foldr_41_search([], _, []) :- 
	!.
rcp_sum_foldr_41_search([S_463|Tail], [D,O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_463),
	rcp_shape_end_search(S_463, D, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_sum_foldr_41_search(Tail, [D,O], _M_).

rcp_end(O, D, _E_) :- 
	rcp_origin(O, D, _A_),
	rcp_att(shapes, O, _B_),
	rcp_sum_foldr_41(_B_, [D,O], _C_),
	rcp_sum(_C_, _D_),
	fd_aeq(_A_+_D_, _E_).

rcp_end_search(O, D, _E_) :- 
	rcp_origin_search(O, D, _A_),
	rcp_att(shapes, O, _B_),
	rcp_sum_foldr_41_search(_B_, [D,O], _C_),
	rcp_sum_search(_C_, _D_),
	fd_aeq(_A_+_D_, _E_).

rcp_sum_foldr_42([], _, []) :- 
	!.
rcp_sum_foldr_42([S_464|Tail], [D,O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_464),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_size(S_464, D, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_sum_foldr_42(Tail, [D,O], _G_).

rcp_sum_foldr_42_search([], _, []) :- 
	!.
rcp_sum_foldr_42_search([S_464|Tail], [D,O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_464),
	rcp_shape_size_search(S_464, D, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_sum_foldr_42_search(Tail, [D,O], _M_).

rcp_size(O, D, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_sum_foldr_42(_A_, [D,O], _B_),
	rcp_sum(_B_, _C_).

rcp_size_search(O, D, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_sum_foldr_42_search(_A_, [D,O], _B_),
	rcp_sum_search(_B_, _C_).

rcp_sum_foldr_43([], _, []) :- 
	!.
rcp_sum_foldr_43([S_465|Tail], [O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_465),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_volume(S_465, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_sum_foldr_43(Tail, [O], _G_).

rcp_sum_foldr_43_search([], _, []) :- 
	!.
rcp_sum_foldr_43_search([S_465|Tail], [O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_465),
	rcp_shape_volume_search(S_465, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_sum_foldr_43_search(Tail, [O], _M_).

rcp_volume(O, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_sum_foldr_43(_A_, [O], _B_),
	rcp_sum(_B_, _C_).

rcp_volume_search(O, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_sum_foldr_43_search(_A_, [O], _B_),
	rcp_sum_search(_B_, _C_).

rcp_distance(O1, O2, D, _H_) :- 
	rcp_origin(O1, D, _A_),
	rcp_origin(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_end(O1, D, _D_),
	rcp_end(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	fd_aeq(max(0,_G_), _H_).

rcp_distance_search(O1, O2, D, _H_) :- 
	rcp_origin_search(O1, D, _A_),
	rcp_origin_search(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_end_search(O1, D, _D_),
	rcp_end_search(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	fd_aeq(max(0,_G_), _H_).

rcp_non_overlapping_binary_foldr_45([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_45([O2_468|Tail], [Dims,Items,O1_466], _H_) :- 
	fd_and(_F_, _G_, _H_),
	fd_implies(_C_, _E_, _F_),
	rcp_att(uid, O1_466, _A_),
	rcp_att(uid, O2_468, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_not(_D_, _E_),
	rcp_overlap(O1_466, O2_468, Dims, _D_),
	rcp_non_overlapping_binary_foldr_45(Tail, [Dims,Items,O1_466], _G_).

rcp_non_overlapping_binary_foldr_45_search([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_45_search([O2_468|Tail], [Dims,Items,O1_466], _) :- 
	rcp_att(uid, O1_466, _I_),
	rcp_att(uid, O2_468, _J_),
	rcp_att(uid, O1_466, _K_),
	rcp_att(uid, O2_468, _L_),
	(
	fd_lt(_I_, _J_),
	rcp_overlap_search(O1_466, O2_468, Dims, _M_),
	fd_not(_M_, _N_),
	fd_equiv(_N_, _O_, 1)
	;
	fd_geq(_K_, _L_),
	fd_aeq(_O_, 1)
	),
	rcp_assert(_O_),
	rcp_non_overlapping_binary_foldr_45_search(Tail, [Dims,Items,O1_466], _P_),
	rcp_assert(_P_).

rcp_non_overlapping_binary_foldr_44([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_44([O1_466|Tail], [Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_non_overlapping_binary_foldr_45(Items, [Dims,Items,O1_466], _A_),
	rcp_non_overlapping_binary_foldr_44(Tail, [Dims,Items], _B_).

rcp_non_overlapping_binary_foldr_44_search([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_44_search([O1_466|Tail], [Dims,Items], _) :- 
	rcp_non_overlapping_binary_foldr_45_search(Items, [Dims,Items,O1_466], _D_),
	rcp_assert(_D_),
	rcp_non_overlapping_binary_foldr_44_search(Tail, [Dims,Items], _E_),
	rcp_assert(_E_).

rcp_non_overlapping_binary(Items, Dims, _A_) :- 
	rcp_non_overlapping_binary_foldr_44(Items, [Dims,Items], _A_).

rcp_non_overlapping_binary_search(Items, Dims, _A_) :- 
	rcp_non_overlapping_binary_foldr_44_search(Items, [Dims,Items], _A_).

rcp_containmentAE_foldr_47([], _, 0) :- 
	!.
rcp_containmentAE_foldr_47([B_471|Tail], [Bins,Dims,I_469,Items], _C_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_contains_touch_rcc(B_471, I_469, Dims, _A_),
	rcp_containmentAE_foldr_47(Tail, [Bins,Dims,I_469,Items], _B_).

rcp_containmentAE_foldr_47_search([], _, 0) :- 
	!.
rcp_containmentAE_foldr_47_search([B_471|Tail], [Bins,Dims,I_469,Items], _) :- 
	(
	rcp_contains_touch_rcc_search(B_471, I_469, Dims, _D_),
	rcp_assert(_D_)
	;
	rcp_containmentAE_foldr_47_search(Tail, [Bins,Dims,I_469,Items], _E_),
	rcp_assert(_E_)
	).

rcp_containmentAE_foldr_46([], _, 1) :- 
	!.
rcp_containmentAE_foldr_46([I_469|Tail], [Bins,Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_containmentAE_foldr_47(Bins, [Bins,Dims,I_469,Items], _A_),
	rcp_containmentAE_foldr_46(Tail, [Bins,Dims,Items], _B_).

rcp_containmentAE_foldr_46_search([], _, 1) :- 
	!.
rcp_containmentAE_foldr_46_search([I_469|Tail], [Bins,Dims,Items], _) :- 
	rcp_containmentAE_foldr_47_search(Bins, [Bins,Dims,I_469,Items], _D_),
	rcp_assert(_D_),
	rcp_containmentAE_foldr_46_search(Tail, [Bins,Dims,Items], _E_),
	rcp_assert(_E_).

rcp_containmentAE(Items, Bins, Dims, _A_) :- 
	rcp_containmentAE_foldr_46(Items, [Bins,Dims,Items], _A_).

rcp_containmentAE_search(Items, Bins, Dims, _A_) :- 
	rcp_containmentAE_foldr_46_search(Items, [Bins,Dims,Items], _A_).

rcp_bin_packing_binary(Items, Bins, Dims, _D_) :- 
	fd_and(_A_, _B_, _D_),
	rcp_containmentAE(Items, Bins, Dims, _A_),
	rcp_non_overlapping_binary(Items, Dims, _B_),
	variables(Items, _C_),
	rcp_labeling(_C_).

rcp_bin_packing_binary_search(Items, Bins, Dims, _D_) :- 
	variables(Items, _C_),
	rcp_containmentAE_search(Items, Bins, Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_binary_search(Items, Dims, _B_),
	rcp_assert(_B_),
	rcp_labeling(_C_),
	fd_aeq(_D_, 1).

rcp_bin_packing(Items, Bins, Dims, _D_) :- 
	fd_and(_A_, _B_, _D_),
	rcp_containmentAE(Items, Bins, Dims, _A_),
	rcp_non_overlapping(Items, Dims, _B_),
	variables(Items, _C_),
	rcp_labeling(_C_).

rcp_bin_packing_search(Items, Bins, Dims, _D_) :- 
	variables(Items, _C_),
	rcp_containmentAE_search(Items, Bins, Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_search(Items, Dims, _B_),
	rcp_assert(_B_),
	rcp_labeling(_C_),
	fd_aeq(_D_, 1).

rcp_containmentEA_foldr_49([], _, 1) :- 
	!.
rcp_containmentEA_foldr_49([I_474|Tail], [B_472,Bins,Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains_touch_rcc(B_472, I_474, Dims, _A_),
	rcp_containmentEA_foldr_49(Tail, [B_472,Bins,Dims,Items], _B_).

rcp_containmentEA_foldr_49_search([], _, 1) :- 
	!.
rcp_containmentEA_foldr_49_search([I_474|Tail], [B_472,Bins,Dims,Items], _) :- 
	rcp_contains_touch_rcc_search(B_472, I_474, Dims, _D_),
	rcp_assert(_D_),
	rcp_containmentEA_foldr_49_search(Tail, [B_472,Bins,Dims,Items], _E_),
	rcp_assert(_E_).

rcp_containmentEA_foldr_48([], _, 0) :- 
	!.
rcp_containmentEA_foldr_48([B_472|Tail], [Bins,Dims,Items], _C_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_containmentEA_foldr_49(Items, [B_472,Bins,Dims,Items], _A_),
	rcp_containmentEA_foldr_48(Tail, [Bins,Dims,Items], _B_).

rcp_containmentEA_foldr_48_search([], _, 0) :- 
	!.
rcp_containmentEA_foldr_48_search([B_472|Tail], [Bins,Dims,Items], _) :- 
	(
	rcp_containmentEA_foldr_49_search(Items, [B_472,Bins,Dims,Items], _D_),
	rcp_assert(_D_)
	;
	rcp_containmentEA_foldr_48_search(Tail, [Bins,Dims,Items], _E_),
	rcp_assert(_E_)
	).

rcp_containmentEA(Items, Bins, Dims, _A_) :- 
	rcp_containmentEA_foldr_48(Bins, [Bins,Dims,Items], _A_).

rcp_containmentEA_search(Items, Bins, Dims, _A_) :- 
	rcp_containmentEA_foldr_48_search(Bins, [Bins,Dims,Items], _A_).

rcp_bin_design(Bin, Items, Dims, _E_) :- 
	fd_and(_A_, _B_, _E_),
	rcp_containmentEA(Items, [Bin], Dims, _A_),
	rcp_non_overlapping(Items, Dims, _B_),
	rcp_volume(Bin, _D_),
	minimize(((variables(Items,_C_),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_).

rcp_bin_design_search(Bin, Items, Dims, _E_) :- 
	rcp_volume(Bin, _D_),
	rcp_containmentEA_search(Items, [Bin], Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_search(Items, Dims, _B_),
	rcp_assert(_B_),
	minimize(((variables(Items,_C_),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_),
	fd_aeq(_E_, 1).

rcp_w(O, _A_) :- 
	rcp_size(O, 1, _A_).

rcp_w_search(O, _A_) :- 
	rcp_size_search(O, 1, _A_).

rcp_h(O, _A_) :- 
	rcp_size(O, 2, _A_).

rcp_h_search(O, _A_) :- 
	rcp_size_search(O, 2, _A_).

rcp_l(O, _A_) :- 
	rcp_size(O, 3, _A_).

rcp_l_search(O, _A_) :- 
	rcp_size_search(O, 3, _A_).

rcp_items_domain_foldr_50([], _, 1) :- 
	!.
rcp_items_domain_foldr_50([I_475|Tail], [Bin,Items], _Q_) :- 
	fd_and((domain(_G_,0,_J_),domain(_L_,0,_O_)), _P_, _Q_),
	rcp_x(I_475, _A_),
	variables(_A_, _B_),
	rcp_w(Bin, _C_),
	rcp_w(I_475, _D_),
	fd_aeq(_C_-_D_, _E_),
	domain(_B_, 0, _E_),
	rcp_y(I_475, _F_),
	variables(_F_, _G_),
	rcp_h(Bin, _H_),
	rcp_h(I_475, _I_),
	fd_aeq(_H_-_I_, _J_),
	rcp_z(I_475, _K_),
	variables(_K_, _L_),
	rcp_l(Bin, _M_),
	rcp_l(I_475, _N_),
	fd_aeq(_M_-_N_, _O_),
	rcp_items_domain_foldr_50(Tail, [Bin,Items], _P_).

rcp_items_domain_foldr_50_search([], _, 1) :- 
	!.
rcp_items_domain_foldr_50_search([I_475|Tail], [Bin,Items], _) :- 
	rcp_x_search(I_475, _R_),
	variables(_R_, _S_),
	rcp_w_search(Bin, _T_),
	rcp_w_search(I_475, _U_),
	fd_aeq(_T_-_U_, _V_),
	rcp_y_search(I_475, _W_),
	variables(_W_, _X_),
	rcp_h_search(Bin, _Y_),
	rcp_h_search(I_475, _Z_),
	fd_aeq(_Y_-_Z_, _B1_),
	rcp_z_search(I_475, _C1_),
	variables(_C1_, _D1_),
	rcp_l_search(Bin, _E1_),
	rcp_l_search(I_475, _F1_),
	fd_aeq(_E1_-_F1_, _G1_),
	domain(_S_, 0, _V_),
	domain(_X_, 0, _B1_),
	domain(_D1_, 0, _G1_),
	rcp_items_domain_foldr_50_search(Tail, [Bin,Items], _H1_),
	rcp_assert(_H1_).

rcp_items_domain(Items, Bin, _A_) :- 
	rcp_items_domain_foldr_50(Items, [Bin,Items], _A_).

rcp_items_domain_search(Items, Bin, _A_) :- 
	rcp_items_domain_foldr_50_search(Items, [Bin,Items], _A_).

rcp_var_order_criterion(1, Candidate, [], _B_) :- 
	rcp_call(Candidate, _A_),
	rcp_att(weight, _A_, _B_).
rcp_var_order_criterion(2, Candidate, [], _B_) :- 
	rcp_call(Candidate, _A_),
	rcp_volume(_A_, _B_).
rcp_var_order_criterion(3, Candidate, [], _B_) :- 
	rcp_call(Candidate, _A_),
	rcp_z(_A_, _B_).

rcp_val_order_criterion(1, Candidate, [], _B_) :- 
	rcp_call(Candidate, _A_),
	rcp_z(_A_, _B_).
rcp_val_order_criterion(2, Candidate, [], _B_) :- 
	rcp_call(Candidate, _A_),
	rcp_x(_A_, _B_).
rcp_val_order_criterion(3, Candidate, [], _B_) :- 
	rcp_call(Candidate, _A_),
	rcp_y(_A_, _B_).

rcp_psa_bin_packing(Bin, Items, Dims, _I1_) :- 
	fd_and(_A_, _H1_, _I1_),
	rcp_items_domain(Items, Bin, _A_),
	fd_and(_B_, _G1_, _H1_),
	rcp_gravity(Items, _B_),
	fd_and(_C_, _F1_, _G1_),
	rcp_weight_stacking(Items, _C_),
	fd_and(_D_, _E1_, _F1_),
	rcp_weight_balancing(Items, Bin, 1, 20, _D_),
	fd_and(_E_, _D1_, _E1_),
	rcp_stack_oversize(Items, 10, _E_),
	fd_and(_B1_, _C1_, _D1_),
	geost_greedyflag(_F_),
	rcp_min(1, _G_),
	rcp_min(4, _H_),
	rcp_min(3, _I_),
	rcp_min(2, _J_),
	rcp_object(_G_, [_H_,_I_,_J_], _K_),
	rcp_min(1, _L_),
	rcp_max(4, _M_),
	rcp_min(3, _N_),
	rcp_min(2, _O_),
	rcp_object(_L_, [_M_,_N_,_O_], _P_),
	rcp_min(1, _Q_),
	rcp_max(4, _R_),
	rcp_max(3, _S_),
	rcp_min(2, _T_),
	rcp_object(_Q_, [_R_,_S_,_T_], _U_),
	rcp_min(1, _V_),
	rcp_min(4, _W_),
	rcp_max(3, _X_),
	rcp_min(2, _Y_),
	rcp_object(_V_, [_W_,_X_,_Y_], _Z_),
	rcp_non_overlapping(Items, Dims, _F_, [_K_,_P_,_U_,_Z_], _B1_),
	variable_ordering([greatest(rcp_var_order_criterion(1,[])),greatest(rcp_var_order_criterion(2,[])),is(rcp_var_order_criterion(3,[]))]),
	value_ordering([up(rcp_val_order_criterion(1,[])),bisect(rcp_val_order_criterion(2,[])),bisect(rcp_val_order_criterion(3,[]))]),
	rcp_bin_packing(Items, [Bin], Dims, _C1_).

rcp_psa_bin_packing_search(Bin, Items, Dims, _D1_) :- 
	rcp_items_domain_search(Items, Bin, _A_),
	rcp_assert(_A_),
	rcp_gravity_search(Items, _B_),
	rcp_assert(_B_),
	rcp_weight_stacking_search(Items, _C_),
	rcp_assert(_C_),
	rcp_weight_balancing_search(Items, Bin, 1, 20, _D_),
	rcp_assert(_D_),
	rcp_stack_oversize_search(Items, 10, _E_),
	rcp_assert(_E_),
	rcp_geost_greedyflag_search(_F_),
	rcp_min_search(1, _G_),
	rcp_min_search(4, _H_),
	rcp_min_search(3, _I_),
	rcp_min_search(2, _J_),
	rcp_object_search(_G_, [_H_,_I_,_J_], _K_),
	rcp_min_search(1, _L_),
	rcp_max_search(4, _M_),
	rcp_min_search(3, _N_),
	rcp_min_search(2, _O_),
	rcp_object_search(_L_, [_M_,_N_,_O_], _P_),
	rcp_min_search(1, _Q_),
	rcp_max_search(4, _R_),
	rcp_max_search(3, _S_),
	rcp_min_search(2, _T_),
	rcp_object_search(_Q_, [_R_,_S_,_T_], _U_),
	rcp_min_search(1, _V_),
	rcp_min_search(4, _W_),
	rcp_max_search(3, _X_),
	rcp_min_search(2, _Y_),
	rcp_object_search(_V_, [_W_,_X_,_Y_], _Z_),
	rcp_non_overlapping_search(Items, Dims, _F_, [_K_,_P_,_U_,_Z_], _B1_),
	rcp_assert(_B1_),
	variable_ordering([greatest(rcp_var_order_criterion(1,[])),greatest(rcp_var_order_criterion(2,[])),is(rcp_var_order_criterion(3,[]))]),
	value_ordering([up(rcp_val_order_criterion(1,[])),bisect(rcp_val_order_criterion(2,[])),bisect(rcp_val_order_criterion(3,[]))]),
	rcp_bin_packing_search(Items, [Bin], Dims, _C1_),
	rcp_assert(_C1_),
	fd_aeq(_D1_, 1).

solve([Geost_greedyflag,O2,O2_2,O2_3,O3,O3_2,O3_3,O4,O4_2,O4_3,O5,O5_2,O5_3,O6,O6_2,O6_3,O7,O7_2,O7_3,O8,O8_2,O8_3,O9,O9_2,O9_3,O10,O10_2,O10_3]) :- 
	statistics(runtime, [_Runtime_0_|_]),
	fd_statistics(backtracks, _),
	R_476#<=>O2+224#=<601,
	R_477#<=>O3+224#=<601,
	R_478#<=>O4+224#=<601,
	R_479#<=>O5+224#=<601,
	R_480#<=>O6+224#=<601,
	R_481#<=>O7+224#=<601,
	R_482#<=>O8+224#=<601,
	R_483#<=>O9+155#=<601,
	R_484#<=>O10+112#=<601,
	R_485#<=>O2#>=601,
	R_486#<=>O3#>=601,
	R_487#<=>O4#>=601,
	R_488#<=>O5#>=601,
	R_489#<=>O6#>=601,
	R_490#<=>O7#>=601,
	R_491#<=>O8#>=601,
	R_492#<=>O9#>=601,
	R_493#<=>O10#>=601,
	R_494#<=>O2+224#=<601,
	R_495#<=>O3+224#=<601,
	R_496#<=>O4+224#=<601,
	R_497#<=>O5+224#=<601,
	R_498#<=>O6+224#=<601,
	R_499#<=>O7+224#=<601,
	R_500#<=>O8+224#=<601,
	R_501#<=>O9+155#=<601,
	R_502#<=>O10+112#=<601,
	R_503#<=>O2#>=601,
	R_504#<=>O3#>=601,
	R_505#<=>O4#>=601,
	R_506#<=>O5#>=601,
	R_507#<=>O6#>=601,
	R_508#<=>O7#>=601,
	R_509#<=>O8#>=601,
	R_510#<=>O9#>=601,
	R_511#<=>O10#>=601,
	rcp_var(from(geost_greedyflag,0,1), Geost_greedyflag),
	rcp_var(from(o4,0,3), O4_3),
	rcp_var(from(o4,0,1), O4),
	rcp_var(from(o4,0,2), O4_2),
	rcp_var(from(o8,0,3), O8_3),
	rcp_var(from(o8,0,1), O8),
	rcp_var(from(o8,0,2), O8_2),
	rcp_var(from(o3,0,3), O3_3),
	rcp_var(from(o3,0,1), O3),
	rcp_var(from(o3,0,2), O3_2),
	rcp_var(from(o9,0,3), O9_3),
	rcp_var(from(o9,0,1), O9),
	rcp_var(from(o9,0,2), O9_2),
	rcp_var(from(o5,0,3), O5_3),
	rcp_var(from(o5,0,1), O5),
	rcp_var(from(o5,0,2), O5_2),
	rcp_var(from(o2,0,3), O2_3),
	rcp_var(from(o2,0,1), O2),
	rcp_var(from(o2,0,2), O2_2),
	rcp_var(from(o10,0,3), O10_3),
	rcp_var(from(o10,0,1), O10),
	rcp_var(from(o10,0,2), O10_2),
	rcp_var(from(o7,0,3), O7_3),
	rcp_var(from(o7,0,1), O7),
	rcp_var(from(o7,0,2), O7_2),
	rcp_var(from(o6,0,3), O6_3),
	rcp_var(from(o6,0,1), O6),
	rcp_var(from(o6,0,2), O6_2),
	domain([O2], 0, 979),
	domain([O2_2], 0, 11),
	domain([O2_3], 0, 128),
	domain([O3], 0, 979),
	domain([O3_2], 0, 11),
	domain([O3_3], 0, 165),
	domain([O4], 0, 979),
	domain([O4_2], 0, 11),
	domain([O4_3], 0, 165),
	domain([O5], 0, 979),
	domain([O5_2], 0, 11),
	domain([O5_3], 0, 91),
	domain([O6], 0, 979),
	domain([O6_2], 0, 11),
	domain([O6_3], 0, 128),
	domain([O7], 0, 979),
	domain([O7_2], 0, 11),
	domain([O7_3], 0, 128),
	domain([O8], 0, 979),
	domain([O8_2], 0, 11),
	domain([O8_3], 0, 17),
	domain([O9], 0, 1048),
	domain([O9_2], 0, 11),
	domain([O9_3], 0, 17),
	domain([O10], 0, 1091),
	domain([O10_2], 0, 11),
	domain([O10_3], 0, 91),
	O2_3#=0#\/(O2+224#>O3#/\O3+224#>O2#/\(O2_2+224#>O3_2#/\O3_2+224#>O2_2)#/\O3_3+74#=O2_3#\/(O2+224#>O4#/\O4+224#>O2#/\(O2_2+224#>O4_2#/\O4_2+224#>O2_2)#/\O4_3+74#=O2_3#\/(O2+224#>O5#/\O5+224#>O2#/\(O2_2+224#>O5_2#/\O5_2+224#>O2_2)#/\O5_3+148#=O2_3#\/(O2+224#>O6#/\O6+224#>O2#/\(O2_2+224#>O6_2#/\O6_2+224#>O2_2)#/\O6_3+111#=O2_3#\/(O2+224#>O7#/\O7+224#>O2#/\(O2_2+224#>O7_2#/\O7_2+224#>O2_2)#/\O7_3+111#=O2_3#\/(O2+224#>O8#/\O8+224#>O2#/\(O2_2+224#>O8_2#/\O8_2+224#>O2_2)#/\O8_3+222#=O2_3#\/(O2+224#>O9#/\O9+155#>O2#/\(O2_2+224#>O9_2#/\O9_2+224#>O2_2)#/\O9_3+222#=O2_3#\/O2+224#>O10#/\O10+112#>O2#/\(O2_2+224#>O10_2#/\O10_2+224#>O2_2)#/\O10_3+148#=O2_3))))))),
	O3_3#=0#\/(O3+224#>O2#/\O2+224#>O3#/\(O3_2+224#>O2_2#/\O2_2+224#>O3_2)#/\O2_3+111#=O3_3#\/(O3+224#>O4#/\O4+224#>O3#/\(O3_2+224#>O4_2#/\O4_2+224#>O3_2)#/\O4_3+74#=O3_3#\/(O3+224#>O5#/\O5+224#>O3#/\(O3_2+224#>O5_2#/\O5_2+224#>O3_2)#/\O5_3+148#=O3_3#\/(O3+224#>O6#/\O6+224#>O3#/\(O3_2+224#>O6_2#/\O6_2+224#>O3_2)#/\O6_3+111#=O3_3#\/(O3+224#>O7#/\O7+224#>O3#/\(O3_2+224#>O7_2#/\O7_2+224#>O3_2)#/\O7_3+111#=O3_3#\/(O3+224#>O8#/\O8+224#>O3#/\(O3_2+224#>O8_2#/\O8_2+224#>O3_2)#/\O8_3+222#=O3_3#\/(O3+224#>O9#/\O9+155#>O3#/\(O3_2+224#>O9_2#/\O9_2+224#>O3_2)#/\O9_3+222#=O3_3#\/O3+224#>O10#/\O10+112#>O3#/\(O3_2+224#>O10_2#/\O10_2+224#>O3_2)#/\O10_3+148#=O3_3))))))),
	O4_3#=0#\/(O4+224#>O2#/\O2+224#>O4#/\(O4_2+224#>O2_2#/\O2_2+224#>O4_2)#/\O2_3+111#=O4_3#\/(O4+224#>O3#/\O3+224#>O4#/\(O4_2+224#>O3_2#/\O3_2+224#>O4_2)#/\O3_3+74#=O4_3#\/(O4+224#>O5#/\O5+224#>O4#/\(O4_2+224#>O5_2#/\O5_2+224#>O4_2)#/\O5_3+148#=O4_3#\/(O4+224#>O6#/\O6+224#>O4#/\(O4_2+224#>O6_2#/\O6_2+224#>O4_2)#/\O6_3+111#=O4_3#\/(O4+224#>O7#/\O7+224#>O4#/\(O4_2+224#>O7_2#/\O7_2+224#>O4_2)#/\O7_3+111#=O4_3#\/(O4+224#>O8#/\O8+224#>O4#/\(O4_2+224#>O8_2#/\O8_2+224#>O4_2)#/\O8_3+222#=O4_3#\/(O4+224#>O9#/\O9+155#>O4#/\(O4_2+224#>O9_2#/\O9_2+224#>O4_2)#/\O9_3+222#=O4_3#\/O4+224#>O10#/\O10+112#>O4#/\(O4_2+224#>O10_2#/\O10_2+224#>O4_2)#/\O10_3+148#=O4_3))))))),
	O5_3#=0#\/(O5+224#>O2#/\O2+224#>O5#/\(O5_2+224#>O2_2#/\O2_2+224#>O5_2)#/\O2_3+111#=O5_3#\/(O5+224#>O3#/\O3+224#>O5#/\(O5_2+224#>O3_2#/\O3_2+224#>O5_2)#/\O3_3+74#=O5_3#\/(O5+224#>O4#/\O4+224#>O5#/\(O5_2+224#>O4_2#/\O4_2+224#>O5_2)#/\O4_3+74#=O5_3#\/(O5+224#>O6#/\O6+224#>O5#/\(O5_2+224#>O6_2#/\O6_2+224#>O5_2)#/\O6_3+111#=O5_3#\/(O5+224#>O7#/\O7+224#>O5#/\(O5_2+224#>O7_2#/\O7_2+224#>O5_2)#/\O7_3+111#=O5_3#\/(O5+224#>O8#/\O8+224#>O5#/\(O5_2+224#>O8_2#/\O8_2+224#>O5_2)#/\O8_3+222#=O5_3#\/(O5+224#>O9#/\O9+155#>O5#/\(O5_2+224#>O9_2#/\O9_2+224#>O5_2)#/\O9_3+222#=O5_3#\/O5+224#>O10#/\O10+112#>O5#/\(O5_2+224#>O10_2#/\O10_2+224#>O5_2)#/\O10_3+148#=O5_3))))))),
	O6_3#=0#\/(O6+224#>O2#/\O2+224#>O6#/\(O6_2+224#>O2_2#/\O2_2+224#>O6_2)#/\O2_3+111#=O6_3#\/(O6+224#>O3#/\O3+224#>O6#/\(O6_2+224#>O3_2#/\O3_2+224#>O6_2)#/\O3_3+74#=O6_3#\/(O6+224#>O4#/\O4+224#>O6#/\(O6_2+224#>O4_2#/\O4_2+224#>O6_2)#/\O4_3+74#=O6_3#\/(O6+224#>O5#/\O5+224#>O6#/\(O6_2+224#>O5_2#/\O5_2+224#>O6_2)#/\O5_3+148#=O6_3#\/(O6+224#>O7#/\O7+224#>O6#/\(O6_2+224#>O7_2#/\O7_2+224#>O6_2)#/\O7_3+111#=O6_3#\/(O6+224#>O8#/\O8+224#>O6#/\(O6_2+224#>O8_2#/\O8_2+224#>O6_2)#/\O8_3+222#=O6_3#\/(O6+224#>O9#/\O9+155#>O6#/\(O6_2+224#>O9_2#/\O9_2+224#>O6_2)#/\O9_3+222#=O6_3#\/O6+224#>O10#/\O10+112#>O6#/\(O6_2+224#>O10_2#/\O10_2+224#>O6_2)#/\O10_3+148#=O6_3))))))),
	O7_3#=0#\/(O7+224#>O2#/\O2+224#>O7#/\(O7_2+224#>O2_2#/\O2_2+224#>O7_2)#/\O2_3+111#=O7_3#\/(O7+224#>O3#/\O3+224#>O7#/\(O7_2+224#>O3_2#/\O3_2+224#>O7_2)#/\O3_3+74#=O7_3#\/(O7+224#>O4#/\O4+224#>O7#/\(O7_2+224#>O4_2#/\O4_2+224#>O7_2)#/\O4_3+74#=O7_3#\/(O7+224#>O5#/\O5+224#>O7#/\(O7_2+224#>O5_2#/\O5_2+224#>O7_2)#/\O5_3+148#=O7_3#\/(O7+224#>O6#/\O6+224#>O7#/\(O7_2+224#>O6_2#/\O6_2+224#>O7_2)#/\O6_3+111#=O7_3#\/(O7+224#>O8#/\O8+224#>O7#/\(O7_2+224#>O8_2#/\O8_2+224#>O7_2)#/\O8_3+222#=O7_3#\/(O7+224#>O9#/\O9+155#>O7#/\(O7_2+224#>O9_2#/\O9_2+224#>O7_2)#/\O9_3+222#=O7_3#\/O7+224#>O10#/\O10+112#>O7#/\(O7_2+224#>O10_2#/\O10_2+224#>O7_2)#/\O10_3+148#=O7_3))))))),
	O8_3#=0#\/(O8+224#>O2#/\O2+224#>O8#/\(O8_2+224#>O2_2#/\O2_2+224#>O8_2)#/\O2_3+111#=O8_3#\/(O8+224#>O3#/\O3+224#>O8#/\(O8_2+224#>O3_2#/\O3_2+224#>O8_2)#/\O3_3+74#=O8_3#\/(O8+224#>O4#/\O4+224#>O8#/\(O8_2+224#>O4_2#/\O4_2+224#>O8_2)#/\O4_3+74#=O8_3#\/(O8+224#>O5#/\O5+224#>O8#/\(O8_2+224#>O5_2#/\O5_2+224#>O8_2)#/\O5_3+148#=O8_3#\/(O8+224#>O6#/\O6+224#>O8#/\(O8_2+224#>O6_2#/\O6_2+224#>O8_2)#/\O6_3+111#=O8_3#\/(O8+224#>O7#/\O7+224#>O8#/\(O8_2+224#>O7_2#/\O7_2+224#>O8_2)#/\O7_3+111#=O8_3#\/(O8+224#>O9#/\O9+155#>O8#/\(O8_2+224#>O9_2#/\O9_2+224#>O8_2)#/\O9_3+222#=O8_3#\/O8+224#>O10#/\O10+112#>O8#/\(O8_2+224#>O10_2#/\O10_2+224#>O8_2)#/\O10_3+148#=O8_3))))))),
	O9_3#=0#\/(O9+155#>O2#/\O2+224#>O9#/\(O9_2+224#>O2_2#/\O2_2+224#>O9_2)#/\O2_3+111#=O9_3#\/(O9+155#>O3#/\O3+224#>O9#/\(O9_2+224#>O3_2#/\O3_2+224#>O9_2)#/\O3_3+74#=O9_3#\/(O9+155#>O4#/\O4+224#>O9#/\(O9_2+224#>O4_2#/\O4_2+224#>O9_2)#/\O4_3+74#=O9_3#\/(O9+155#>O5#/\O5+224#>O9#/\(O9_2+224#>O5_2#/\O5_2+224#>O9_2)#/\O5_3+148#=O9_3#\/(O9+155#>O6#/\O6+224#>O9#/\(O9_2+224#>O6_2#/\O6_2+224#>O9_2)#/\O6_3+111#=O9_3#\/(O9+155#>O7#/\O7+224#>O9#/\(O9_2+224#>O7_2#/\O7_2+224#>O9_2)#/\O7_3+111#=O9_3#\/(O9+155#>O8#/\O8+224#>O9#/\(O9_2+224#>O8_2#/\O8_2+224#>O9_2)#/\O8_3+222#=O9_3#\/O9+155#>O10#/\O10+112#>O9#/\(O9_2+224#>O10_2#/\O10_2+224#>O9_2)#/\O10_3+148#=O9_3))))))),
	O10_3#=0#\/(O10+112#>O2#/\O2+224#>O10#/\(O10_2+224#>O2_2#/\O2_2+224#>O10_2)#/\O2_3+111#=O10_3#\/(O10+112#>O3#/\O3+224#>O10#/\(O10_2+224#>O3_2#/\O3_2+224#>O10_2)#/\O3_3+74#=O10_3#\/(O10+112#>O4#/\O4+224#>O10#/\(O10_2+224#>O4_2#/\O4_2+224#>O10_2)#/\O4_3+74#=O10_3#\/(O10+112#>O5#/\O5+224#>O10#/\(O10_2+224#>O5_2#/\O5_2+224#>O10_2)#/\O5_3+148#=O10_3#\/(O10+112#>O6#/\O6+224#>O10#/\(O10_2+224#>O6_2#/\O6_2+224#>O10_2)#/\O6_3+111#=O10_3#\/(O10+112#>O7#/\O7+224#>O10#/\(O10_2+224#>O7_2#/\O7_2+224#>O10_2)#/\O7_3+111#=O10_3#\/(O10+112#>O8#/\O8+224#>O10#/\(O10_2+224#>O8_2#/\O8_2+224#>O10_2)#/\O8_3+222#=O10_3#\/O10+112#>O9#/\O9+155#>O10#/\(O10_2+224#>O9_2#/\O9_2+224#>O10_2)#/\O9_3+222#=O10_3))))))),
	O2+224#=<O6#\/O6+224#=<O2#\/(O2_2+224#=<O6_2#\/O6_2+224#=<O2_2)#\/O6_3+111#>=O2_3,
	O6_3+111#\=O2_3,
	O2+224#=<O7#\/O7+224#=<O2#\/(O2_2+224#=<O7_2#\/O7_2+224#=<O2_2)#\/O7_3+111#>=O2_3,
	O7_3+111#\=O2_3,
	O2+224#=<O10#\/O10+112#=<O2#\/(O2_2+224#=<O10_2#\/O10_2+224#=<O2_2)#\/O10_3+148#>=O2_3,
	O10_3+148#\=O2_3,
	O3+224#=<O2#\/O2+224#=<O3#\/(O3_2+224#=<O2_2#\/O2_2+224#=<O3_2)#\/O2_3+111#>=O3_3,
	O2_3+111#\=O3_3,
	O3+224#=<O5#\/O5+224#=<O3#\/(O3_2+224#=<O5_2#\/O5_2+224#=<O3_2)#\/O5_3+148#>=O3_3,
	O5_3+148#\=O3_3,
	O3+224#=<O6#\/O6+224#=<O3#\/(O3_2+224#=<O6_2#\/O6_2+224#=<O3_2)#\/O6_3+111#>=O3_3,
	O6_3+111#\=O3_3,
	O3+224#=<O7#\/O7+224#=<O3#\/(O3_2+224#=<O7_2#\/O7_2+224#=<O3_2)#\/O7_3+111#>=O3_3,
	O7_3+111#\=O3_3,
	O3+224#=<O9#\/O9+155#=<O3#\/(O3_2+224#=<O9_2#\/O9_2+224#=<O3_2)#\/O9_3+222#>=O3_3,
	O9_3+222#\=O3_3,
	O3+224#=<O10#\/O10+112#=<O3#\/(O3_2+224#=<O10_2#\/O10_2+224#=<O3_2)#\/O10_3+148#>=O3_3,
	O10_3+148#\=O3_3,
	O4+224#=<O2#\/O2+224#=<O4#\/(O4_2+224#=<O2_2#\/O2_2+224#=<O4_2)#\/O2_3+111#>=O4_3,
	O2_3+111#\=O4_3,
	O4+224#=<O3#\/O3+224#=<O4#\/(O4_2+224#=<O3_2#\/O3_2+224#=<O4_2)#\/O3_3+74#>=O4_3,
	O3_3+74#\=O4_3,
	O4+224#=<O5#\/O5+224#=<O4#\/(O4_2+224#=<O5_2#\/O5_2+224#=<O4_2)#\/O5_3+148#>=O4_3,
	O5_3+148#\=O4_3,
	O4+224#=<O6#\/O6+224#=<O4#\/(O4_2+224#=<O6_2#\/O6_2+224#=<O4_2)#\/O6_3+111#>=O4_3,
	O6_3+111#\=O4_3,
	O4+224#=<O7#\/O7+224#=<O4#\/(O4_2+224#=<O7_2#\/O7_2+224#=<O4_2)#\/O7_3+111#>=O4_3,
	O7_3+111#\=O4_3,
	O4+224#=<O8#\/O8+224#=<O4#\/(O4_2+224#=<O8_2#\/O8_2+224#=<O4_2)#\/O8_3+222#>=O4_3,
	O8_3+222#\=O4_3,
	O4+224#=<O9#\/O9+155#=<O4#\/(O4_2+224#=<O9_2#\/O9_2+224#=<O4_2)#\/O9_3+222#>=O4_3,
	O9_3+222#\=O4_3,
	O4+224#=<O10#\/O10+112#=<O4#\/(O4_2+224#=<O10_2#\/O10_2+224#=<O4_2)#\/O10_3+148#>=O4_3,
	O10_3+148#\=O4_3,
	O5+224#=<O2#\/O2+224#=<O5#\/(O5_2+224#=<O2_2#\/O2_2+224#=<O5_2)#\/O2_3+111#>=O5_3,
	O2_3+111#\=O5_3,
	O5+224#=<O6#\/O6+224#=<O5#\/(O5_2+224#=<O6_2#\/O6_2+224#=<O5_2)#\/O6_3+111#>=O5_3,
	O6_3+111#\=O5_3,
	O5+224#=<O7#\/O7+224#=<O5#\/(O5_2+224#=<O7_2#\/O7_2+224#=<O5_2)#\/O7_3+111#>=O5_3,
	O7_3+111#\=O5_3,
	O5+224#=<O10#\/O10+112#=<O5#\/(O5_2+224#=<O10_2#\/O10_2+224#=<O5_2)#\/O10_3+148#>=O5_3,
	O10_3+148#\=O5_3,
	O7+224#=<O6#\/O6+224#=<O7#\/(O7_2+224#=<O6_2#\/O6_2+224#=<O7_2)#\/O6_3+111#>=O7_3,
	O6_3+111#\=O7_3,
	O8+224#=<O2#\/O2+224#=<O8#\/(O8_2+224#=<O2_2#\/O2_2+224#=<O8_2)#\/O2_3+111#>=O8_3,
	O2_3+111#\=O8_3,
	O8+224#=<O3#\/O3+224#=<O8#\/(O8_2+224#=<O3_2#\/O3_2+224#=<O8_2)#\/O3_3+74#>=O8_3,
	O3_3+74#\=O8_3,
	O8+224#=<O5#\/O5+224#=<O8#\/(O8_2+224#=<O5_2#\/O5_2+224#=<O8_2)#\/O5_3+148#>=O8_3,
	O5_3+148#\=O8_3,
	O8+224#=<O6#\/O6+224#=<O8#\/(O8_2+224#=<O6_2#\/O6_2+224#=<O8_2)#\/O6_3+111#>=O8_3,
	O6_3+111#\=O8_3,
	O8+224#=<O7#\/O7+224#=<O8#\/(O8_2+224#=<O7_2#\/O7_2+224#=<O8_2)#\/O7_3+111#>=O8_3,
	O7_3+111#\=O8_3,
	O8+224#=<O9#\/O9+155#=<O8#\/(O8_2+224#=<O9_2#\/O9_2+224#=<O8_2)#\/O9_3+222#>=O8_3,
	O9_3+222#\=O8_3,
	O8+224#=<O10#\/O10+112#=<O8#\/(O8_2+224#=<O10_2#\/O10_2+224#=<O8_2)#\/O10_3+148#>=O8_3,
	O10_3+148#\=O8_3,
	O9+155#=<O2#\/O2+224#=<O9#\/(O9_2+224#=<O2_2#\/O2_2+224#=<O9_2)#\/O2_3+111#>=O9_3,
	O2_3+111#\=O9_3,
	O9+155#=<O5#\/O5+224#=<O9#\/(O9_2+224#=<O5_2#\/O5_2+224#=<O9_2)#\/O5_3+148#>=O9_3,
	O5_3+148#\=O9_3,
	O9+155#=<O6#\/O6+224#=<O9#\/(O9_2+224#=<O6_2#\/O6_2+224#=<O9_2)#\/O6_3+111#>=O9_3,
	O6_3+111#\=O9_3,
	O9+155#=<O7#\/O7+224#=<O9#\/(O9_2+224#=<O7_2#\/O7_2+224#=<O9_2)#\/O7_3+111#>=O9_3,
	O7_3+111#\=O9_3,
	O9+155#=<O10#\/O10+112#=<O9#\/(O9_2+224#=<O10_2#\/O10_2+224#=<O9_2)#\/O10_3+148#>=O9_3,
	O10_3+148#\=O9_3,
	O10+112#=<O6#\/O6+224#=<O10#\/(O10_2+224#=<O6_2#\/O6_2+224#=<O10_2)#\/O6_3+111#>=O10_3,
	O6_3+111#\=O10_3,
	O10+112#=<O7#\/O7+224#=<O10#\/(O10_2+224#=<O7_2#\/O7_2+224#=<O10_2)#\/O7_3+111#>=O10_3,
	O7_3+111#\=O10_3,
	100*max(413*R_476+(463*R_477+(842*R_478+(422*R_479+(266*R_480+(321*R_481+(670*R_482+(440*R_483+325*R_484))))))),413*R_485+(463*R_486+(842*R_487+(422*R_488+(266*R_489+(321*R_490+(670*R_491+(440*R_492+325*R_493))))))))#=<120*min(413*R_494+(463*R_495+(842*R_496+(422*R_497+(266*R_498+(321*R_499+(670*R_500+(440*R_501+325*R_502))))))),413*R_503+(463*R_504+(842*R_505+(422*R_506+(266*R_507+(321*R_508+(670*R_509+(440*R_510+325*R_511)))))))),
	O2+224#>O3#/\O3+224#>O2#/\(O2_2+224#>O3_2#/\O3_2+224#>O2_2)#=>max(max(O2,O3)-min(O2,O3),max(O2+224,O3+224)-min(O2+224,O3+224))#=<10#/\max(max(O2_2,O3_2)-min(O2_2,O3_2),max(O2_2+224,O3_2+224)-min(O2_2+224,O3_2+224))#=<10,
	O2+224#>O4#/\O4+224#>O2#/\(O2_2+224#>O4_2#/\O4_2+224#>O2_2)#=>max(max(O2,O4)-min(O2,O4),max(O2+224,O4+224)-min(O2+224,O4+224))#=<10#/\max(max(O2_2,O4_2)-min(O2_2,O4_2),max(O2_2+224,O4_2+224)-min(O2_2+224,O4_2+224))#=<10,
	O2+224#>O5#/\O5+224#>O2#/\(O2_2+224#>O5_2#/\O5_2+224#>O2_2)#=>max(max(O2,O5)-min(O2,O5),max(O2+224,O5+224)-min(O2+224,O5+224))#=<10#/\max(max(O2_2,O5_2)-min(O2_2,O5_2),max(O2_2+224,O5_2+224)-min(O2_2+224,O5_2+224))#=<10,
	O2+224#>O6#/\O6+224#>O2#/\(O2_2+224#>O6_2#/\O6_2+224#>O2_2)#=>max(max(O2,O6)-min(O2,O6),max(O2+224,O6+224)-min(O2+224,O6+224))#=<10#/\max(max(O2_2,O6_2)-min(O2_2,O6_2),max(O2_2+224,O6_2+224)-min(O2_2+224,O6_2+224))#=<10,
	O2+224#>O7#/\O7+224#>O2#/\(O2_2+224#>O7_2#/\O7_2+224#>O2_2)#=>max(max(O2,O7)-min(O2,O7),max(O2+224,O7+224)-min(O2+224,O7+224))#=<10#/\max(max(O2_2,O7_2)-min(O2_2,O7_2),max(O2_2+224,O7_2+224)-min(O2_2+224,O7_2+224))#=<10,
	O2+224#>O8#/\O8+224#>O2#/\(O2_2+224#>O8_2#/\O8_2+224#>O2_2)#=>max(max(O2,O8)-min(O2,O8),max(O2+224,O8+224)-min(O2+224,O8+224))#=<10#/\max(max(O2_2,O8_2)-min(O2_2,O8_2),max(O2_2+224,O8_2+224)-min(O2_2+224,O8_2+224))#=<10,
	O2+224#>O9#/\O9+155#>O2#/\(O2_2+224#>O9_2#/\O9_2+224#>O2_2)#=>max(max(O2,O9)-min(O2,O9),max(O2+224,O9+155)-min(O2+224,O9+155))#=<10#/\max(max(O2_2,O9_2)-min(O2_2,O9_2),max(O2_2+224,O9_2+224)-min(O2_2+224,O9_2+224))#=<10,
	O2+224#>O10#/\O10+112#>O2#/\(O2_2+224#>O10_2#/\O10_2+224#>O2_2)#=>max(max(O2,O10)-min(O2,O10),max(O2+224,O10+112)-min(O2+224,O10+112))#=<10#/\max(max(O2_2,O10_2)-min(O2_2,O10_2),max(O2_2+224,O10_2+224)-min(O2_2+224,O10_2+224))#=<10,
	O3+224#>O2#/\O2+224#>O3#/\(O3_2+224#>O2_2#/\O2_2+224#>O3_2)#=>max(max(O3,O2)-min(O3,O2),max(O3+224,O2+224)-min(O3+224,O2+224))#=<10#/\max(max(O3_2,O2_2)-min(O3_2,O2_2),max(O3_2+224,O2_2+224)-min(O3_2+224,O2_2+224))#=<10,
	O3+224#>O4#/\O4+224#>O3#/\(O3_2+224#>O4_2#/\O4_2+224#>O3_2)#=>max(max(O3,O4)-min(O3,O4),max(O3+224,O4+224)-min(O3+224,O4+224))#=<10#/\max(max(O3_2,O4_2)-min(O3_2,O4_2),max(O3_2+224,O4_2+224)-min(O3_2+224,O4_2+224))#=<10,
	O3+224#>O5#/\O5+224#>O3#/\(O3_2+224#>O5_2#/\O5_2+224#>O3_2)#=>max(max(O3,O5)-min(O3,O5),max(O3+224,O5+224)-min(O3+224,O5+224))#=<10#/\max(max(O3_2,O5_2)-min(O3_2,O5_2),max(O3_2+224,O5_2+224)-min(O3_2+224,O5_2+224))#=<10,
	O3+224#>O6#/\O6+224#>O3#/\(O3_2+224#>O6_2#/\O6_2+224#>O3_2)#=>max(max(O3,O6)-min(O3,O6),max(O3+224,O6+224)-min(O3+224,O6+224))#=<10#/\max(max(O3_2,O6_2)-min(O3_2,O6_2),max(O3_2+224,O6_2+224)-min(O3_2+224,O6_2+224))#=<10,
	O3+224#>O7#/\O7+224#>O3#/\(O3_2+224#>O7_2#/\O7_2+224#>O3_2)#=>max(max(O3,O7)-min(O3,O7),max(O3+224,O7+224)-min(O3+224,O7+224))#=<10#/\max(max(O3_2,O7_2)-min(O3_2,O7_2),max(O3_2+224,O7_2+224)-min(O3_2+224,O7_2+224))#=<10,
	O3+224#>O8#/\O8+224#>O3#/\(O3_2+224#>O8_2#/\O8_2+224#>O3_2)#=>max(max(O3,O8)-min(O3,O8),max(O3+224,O8+224)-min(O3+224,O8+224))#=<10#/\max(max(O3_2,O8_2)-min(O3_2,O8_2),max(O3_2+224,O8_2+224)-min(O3_2+224,O8_2+224))#=<10,
	O3+224#>O9#/\O9+155#>O3#/\(O3_2+224#>O9_2#/\O9_2+224#>O3_2)#=>max(max(O3,O9)-min(O3,O9),max(O3+224,O9+155)-min(O3+224,O9+155))#=<10#/\max(max(O3_2,O9_2)-min(O3_2,O9_2),max(O3_2+224,O9_2+224)-min(O3_2+224,O9_2+224))#=<10,
	O3+224#>O10#/\O10+112#>O3#/\(O3_2+224#>O10_2#/\O10_2+224#>O3_2)#=>max(max(O3,O10)-min(O3,O10),max(O3+224,O10+112)-min(O3+224,O10+112))#=<10#/\max(max(O3_2,O10_2)-min(O3_2,O10_2),max(O3_2+224,O10_2+224)-min(O3_2+224,O10_2+224))#=<10,
	O4+224#>O2#/\O2+224#>O4#/\(O4_2+224#>O2_2#/\O2_2+224#>O4_2)#=>max(max(O4,O2)-min(O4,O2),max(O4+224,O2+224)-min(O4+224,O2+224))#=<10#/\max(max(O4_2,O2_2)-min(O4_2,O2_2),max(O4_2+224,O2_2+224)-min(O4_2+224,O2_2+224))#=<10,
	O4+224#>O3#/\O3+224#>O4#/\(O4_2+224#>O3_2#/\O3_2+224#>O4_2)#=>max(max(O4,O3)-min(O4,O3),max(O4+224,O3+224)-min(O4+224,O3+224))#=<10#/\max(max(O4_2,O3_2)-min(O4_2,O3_2),max(O4_2+224,O3_2+224)-min(O4_2+224,O3_2+224))#=<10,
	O4+224#>O5#/\O5+224#>O4#/\(O4_2+224#>O5_2#/\O5_2+224#>O4_2)#=>max(max(O4,O5)-min(O4,O5),max(O4+224,O5+224)-min(O4+224,O5+224))#=<10#/\max(max(O4_2,O5_2)-min(O4_2,O5_2),max(O4_2+224,O5_2+224)-min(O4_2+224,O5_2+224))#=<10,
	O4+224#>O6#/\O6+224#>O4#/\(O4_2+224#>O6_2#/\O6_2+224#>O4_2)#=>max(max(O4,O6)-min(O4,O6),max(O4+224,O6+224)-min(O4+224,O6+224))#=<10#/\max(max(O4_2,O6_2)-min(O4_2,O6_2),max(O4_2+224,O6_2+224)-min(O4_2+224,O6_2+224))#=<10,
	O4+224#>O7#/\O7+224#>O4#/\(O4_2+224#>O7_2#/\O7_2+224#>O4_2)#=>max(max(O4,O7)-min(O4,O7),max(O4+224,O7+224)-min(O4+224,O7+224))#=<10#/\max(max(O4_2,O7_2)-min(O4_2,O7_2),max(O4_2+224,O7_2+224)-min(O4_2+224,O7_2+224))#=<10,
	O4+224#>O8#/\O8+224#>O4#/\(O4_2+224#>O8_2#/\O8_2+224#>O4_2)#=>max(max(O4,O8)-min(O4,O8),max(O4+224,O8+224)-min(O4+224,O8+224))#=<10#/\max(max(O4_2,O8_2)-min(O4_2,O8_2),max(O4_2+224,O8_2+224)-min(O4_2+224,O8_2+224))#=<10,
	O4+224#>O9#/\O9+155#>O4#/\(O4_2+224#>O9_2#/\O9_2+224#>O4_2)#=>max(max(O4,O9)-min(O4,O9),max(O4+224,O9+155)-min(O4+224,O9+155))#=<10#/\max(max(O4_2,O9_2)-min(O4_2,O9_2),max(O4_2+224,O9_2+224)-min(O4_2+224,O9_2+224))#=<10,
	O4+224#>O10#/\O10+112#>O4#/\(O4_2+224#>O10_2#/\O10_2+224#>O4_2)#=>max(max(O4,O10)-min(O4,O10),max(O4+224,O10+112)-min(O4+224,O10+112))#=<10#/\max(max(O4_2,O10_2)-min(O4_2,O10_2),max(O4_2+224,O10_2+224)-min(O4_2+224,O10_2+224))#=<10,
	O5+224#>O2#/\O2+224#>O5#/\(O5_2+224#>O2_2#/\O2_2+224#>O5_2)#=>max(max(O5,O2)-min(O5,O2),max(O5+224,O2+224)-min(O5+224,O2+224))#=<10#/\max(max(O5_2,O2_2)-min(O5_2,O2_2),max(O5_2+224,O2_2+224)-min(O5_2+224,O2_2+224))#=<10,
	O5+224#>O3#/\O3+224#>O5#/\(O5_2+224#>O3_2#/\O3_2+224#>O5_2)#=>max(max(O5,O3)-min(O5,O3),max(O5+224,O3+224)-min(O5+224,O3+224))#=<10#/\max(max(O5_2,O3_2)-min(O5_2,O3_2),max(O5_2+224,O3_2+224)-min(O5_2+224,O3_2+224))#=<10,
	O5+224#>O4#/\O4+224#>O5#/\(O5_2+224#>O4_2#/\O4_2+224#>O5_2)#=>max(max(O5,O4)-min(O5,O4),max(O5+224,O4+224)-min(O5+224,O4+224))#=<10#/\max(max(O5_2,O4_2)-min(O5_2,O4_2),max(O5_2+224,O4_2+224)-min(O5_2+224,O4_2+224))#=<10,
	O5+224#>O6#/\O6+224#>O5#/\(O5_2+224#>O6_2#/\O6_2+224#>O5_2)#=>max(max(O5,O6)-min(O5,O6),max(O5+224,O6+224)-min(O5+224,O6+224))#=<10#/\max(max(O5_2,O6_2)-min(O5_2,O6_2),max(O5_2+224,O6_2+224)-min(O5_2+224,O6_2+224))#=<10,
	O5+224#>O7#/\O7+224#>O5#/\(O5_2+224#>O7_2#/\O7_2+224#>O5_2)#=>max(max(O5,O7)-min(O5,O7),max(O5+224,O7+224)-min(O5+224,O7+224))#=<10#/\max(max(O5_2,O7_2)-min(O5_2,O7_2),max(O5_2+224,O7_2+224)-min(O5_2+224,O7_2+224))#=<10,
	O5+224#>O8#/\O8+224#>O5#/\(O5_2+224#>O8_2#/\O8_2+224#>O5_2)#=>max(max(O5,O8)-min(O5,O8),max(O5+224,O8+224)-min(O5+224,O8+224))#=<10#/\max(max(O5_2,O8_2)-min(O5_2,O8_2),max(O5_2+224,O8_2+224)-min(O5_2+224,O8_2+224))#=<10,
	O5+224#>O9#/\O9+155#>O5#/\(O5_2+224#>O9_2#/\O9_2+224#>O5_2)#=>max(max(O5,O9)-min(O5,O9),max(O5+224,O9+155)-min(O5+224,O9+155))#=<10#/\max(max(O5_2,O9_2)-min(O5_2,O9_2),max(O5_2+224,O9_2+224)-min(O5_2+224,O9_2+224))#=<10,
	O5+224#>O10#/\O10+112#>O5#/\(O5_2+224#>O10_2#/\O10_2+224#>O5_2)#=>max(max(O5,O10)-min(O5,O10),max(O5+224,O10+112)-min(O5+224,O10+112))#=<10#/\max(max(O5_2,O10_2)-min(O5_2,O10_2),max(O5_2+224,O10_2+224)-min(O5_2+224,O10_2+224))#=<10,
	O6+224#>O2#/\O2+224#>O6#/\(O6_2+224#>O2_2#/\O2_2+224#>O6_2)#=>max(max(O6,O2)-min(O6,O2),max(O6+224,O2+224)-min(O6+224,O2+224))#=<10#/\max(max(O6_2,O2_2)-min(O6_2,O2_2),max(O6_2+224,O2_2+224)-min(O6_2+224,O2_2+224))#=<10,
	O6+224#>O3#/\O3+224#>O6#/\(O6_2+224#>O3_2#/\O3_2+224#>O6_2)#=>max(max(O6,O3)-min(O6,O3),max(O6+224,O3+224)-min(O6+224,O3+224))#=<10#/\max(max(O6_2,O3_2)-min(O6_2,O3_2),max(O6_2+224,O3_2+224)-min(O6_2+224,O3_2+224))#=<10,
	O6+224#>O4#/\O4+224#>O6#/\(O6_2+224#>O4_2#/\O4_2+224#>O6_2)#=>max(max(O6,O4)-min(O6,O4),max(O6+224,O4+224)-min(O6+224,O4+224))#=<10#/\max(max(O6_2,O4_2)-min(O6_2,O4_2),max(O6_2+224,O4_2+224)-min(O6_2+224,O4_2+224))#=<10,
	O6+224#>O5#/\O5+224#>O6#/\(O6_2+224#>O5_2#/\O5_2+224#>O6_2)#=>max(max(O6,O5)-min(O6,O5),max(O6+224,O5+224)-min(O6+224,O5+224))#=<10#/\max(max(O6_2,O5_2)-min(O6_2,O5_2),max(O6_2+224,O5_2+224)-min(O6_2+224,O5_2+224))#=<10,
	O6+224#>O7#/\O7+224#>O6#/\(O6_2+224#>O7_2#/\O7_2+224#>O6_2)#=>max(max(O6,O7)-min(O6,O7),max(O6+224,O7+224)-min(O6+224,O7+224))#=<10#/\max(max(O6_2,O7_2)-min(O6_2,O7_2),max(O6_2+224,O7_2+224)-min(O6_2+224,O7_2+224))#=<10,
	O6+224#>O8#/\O8+224#>O6#/\(O6_2+224#>O8_2#/\O8_2+224#>O6_2)#=>max(max(O6,O8)-min(O6,O8),max(O6+224,O8+224)-min(O6+224,O8+224))#=<10#/\max(max(O6_2,O8_2)-min(O6_2,O8_2),max(O6_2+224,O8_2+224)-min(O6_2+224,O8_2+224))#=<10,
	O6+224#>O9#/\O9+155#>O6#/\(O6_2+224#>O9_2#/\O9_2+224#>O6_2)#=>max(max(O6,O9)-min(O6,O9),max(O6+224,O9+155)-min(O6+224,O9+155))#=<10#/\max(max(O6_2,O9_2)-min(O6_2,O9_2),max(O6_2+224,O9_2+224)-min(O6_2+224,O9_2+224))#=<10,
	O6+224#>O10#/\O10+112#>O6#/\(O6_2+224#>O10_2#/\O10_2+224#>O6_2)#=>max(max(O6,O10)-min(O6,O10),max(O6+224,O10+112)-min(O6+224,O10+112))#=<10#/\max(max(O6_2,O10_2)-min(O6_2,O10_2),max(O6_2+224,O10_2+224)-min(O6_2+224,O10_2+224))#=<10,
	O7+224#>O2#/\O2+224#>O7#/\(O7_2+224#>O2_2#/\O2_2+224#>O7_2)#=>max(max(O7,O2)-min(O7,O2),max(O7+224,O2+224)-min(O7+224,O2+224))#=<10#/\max(max(O7_2,O2_2)-min(O7_2,O2_2),max(O7_2+224,O2_2+224)-min(O7_2+224,O2_2+224))#=<10,
	O7+224#>O3#/\O3+224#>O7#/\(O7_2+224#>O3_2#/\O3_2+224#>O7_2)#=>max(max(O7,O3)-min(O7,O3),max(O7+224,O3+224)-min(O7+224,O3+224))#=<10#/\max(max(O7_2,O3_2)-min(O7_2,O3_2),max(O7_2+224,O3_2+224)-min(O7_2+224,O3_2+224))#=<10,
	O7+224#>O4#/\O4+224#>O7#/\(O7_2+224#>O4_2#/\O4_2+224#>O7_2)#=>max(max(O7,O4)-min(O7,O4),max(O7+224,O4+224)-min(O7+224,O4+224))#=<10#/\max(max(O7_2,O4_2)-min(O7_2,O4_2),max(O7_2+224,O4_2+224)-min(O7_2+224,O4_2+224))#=<10,
	O7+224#>O5#/\O5+224#>O7#/\(O7_2+224#>O5_2#/\O5_2+224#>O7_2)#=>max(max(O7,O5)-min(O7,O5),max(O7+224,O5+224)-min(O7+224,O5+224))#=<10#/\max(max(O7_2,O5_2)-min(O7_2,O5_2),max(O7_2+224,O5_2+224)-min(O7_2+224,O5_2+224))#=<10,
	O7+224#>O6#/\O6+224#>O7#/\(O7_2+224#>O6_2#/\O6_2+224#>O7_2)#=>max(max(O7,O6)-min(O7,O6),max(O7+224,O6+224)-min(O7+224,O6+224))#=<10#/\max(max(O7_2,O6_2)-min(O7_2,O6_2),max(O7_2+224,O6_2+224)-min(O7_2+224,O6_2+224))#=<10,
	O7+224#>O8#/\O8+224#>O7#/\(O7_2+224#>O8_2#/\O8_2+224#>O7_2)#=>max(max(O7,O8)-min(O7,O8),max(O7+224,O8+224)-min(O7+224,O8+224))#=<10#/\max(max(O7_2,O8_2)-min(O7_2,O8_2),max(O7_2+224,O8_2+224)-min(O7_2+224,O8_2+224))#=<10,
	O7+224#>O9#/\O9+155#>O7#/\(O7_2+224#>O9_2#/\O9_2+224#>O7_2)#=>max(max(O7,O9)-min(O7,O9),max(O7+224,O9+155)-min(O7+224,O9+155))#=<10#/\max(max(O7_2,O9_2)-min(O7_2,O9_2),max(O7_2+224,O9_2+224)-min(O7_2+224,O9_2+224))#=<10,
	O7+224#>O10#/\O10+112#>O7#/\(O7_2+224#>O10_2#/\O10_2+224#>O7_2)#=>max(max(O7,O10)-min(O7,O10),max(O7+224,O10+112)-min(O7+224,O10+112))#=<10#/\max(max(O7_2,O10_2)-min(O7_2,O10_2),max(O7_2+224,O10_2+224)-min(O7_2+224,O10_2+224))#=<10,
	O8+224#>O2#/\O2+224#>O8#/\(O8_2+224#>O2_2#/\O2_2+224#>O8_2)#=>max(max(O8,O2)-min(O8,O2),max(O8+224,O2+224)-min(O8+224,O2+224))#=<10#/\max(max(O8_2,O2_2)-min(O8_2,O2_2),max(O8_2+224,O2_2+224)-min(O8_2+224,O2_2+224))#=<10,
	O8+224#>O3#/\O3+224#>O8#/\(O8_2+224#>O3_2#/\O3_2+224#>O8_2)#=>max(max(O8,O3)-min(O8,O3),max(O8+224,O3+224)-min(O8+224,O3+224))#=<10#/\max(max(O8_2,O3_2)-min(O8_2,O3_2),max(O8_2+224,O3_2+224)-min(O8_2+224,O3_2+224))#=<10,
	O8+224#>O4#/\O4+224#>O8#/\(O8_2+224#>O4_2#/\O4_2+224#>O8_2)#=>max(max(O8,O4)-min(O8,O4),max(O8+224,O4+224)-min(O8+224,O4+224))#=<10#/\max(max(O8_2,O4_2)-min(O8_2,O4_2),max(O8_2+224,O4_2+224)-min(O8_2+224,O4_2+224))#=<10,
	O8+224#>O5#/\O5+224#>O8#/\(O8_2+224#>O5_2#/\O5_2+224#>O8_2)#=>max(max(O8,O5)-min(O8,O5),max(O8+224,O5+224)-min(O8+224,O5+224))#=<10#/\max(max(O8_2,O5_2)-min(O8_2,O5_2),max(O8_2+224,O5_2+224)-min(O8_2+224,O5_2+224))#=<10,
	O8+224#>O6#/\O6+224#>O8#/\(O8_2+224#>O6_2#/\O6_2+224#>O8_2)#=>max(max(O8,O6)-min(O8,O6),max(O8+224,O6+224)-min(O8+224,O6+224))#=<10#/\max(max(O8_2,O6_2)-min(O8_2,O6_2),max(O8_2+224,O6_2+224)-min(O8_2+224,O6_2+224))#=<10,
	O8+224#>O7#/\O7+224#>O8#/\(O8_2+224#>O7_2#/\O7_2+224#>O8_2)#=>max(max(O8,O7)-min(O8,O7),max(O8+224,O7+224)-min(O8+224,O7+224))#=<10#/\max(max(O8_2,O7_2)-min(O8_2,O7_2),max(O8_2+224,O7_2+224)-min(O8_2+224,O7_2+224))#=<10,
	O8+224#>O9#/\O9+155#>O8#/\(O8_2+224#>O9_2#/\O9_2+224#>O8_2)#=>max(max(O8,O9)-min(O8,O9),max(O8+224,O9+155)-min(O8+224,O9+155))#=<10#/\max(max(O8_2,O9_2)-min(O8_2,O9_2),max(O8_2+224,O9_2+224)-min(O8_2+224,O9_2+224))#=<10,
	O8+224#>O10#/\O10+112#>O8#/\(O8_2+224#>O10_2#/\O10_2+224#>O8_2)#=>max(max(O8,O10)-min(O8,O10),max(O8+224,O10+112)-min(O8+224,O10+112))#=<10#/\max(max(O8_2,O10_2)-min(O8_2,O10_2),max(O8_2+224,O10_2+224)-min(O8_2+224,O10_2+224))#=<10,
	O9+155#>O2#/\O2+224#>O9#/\(O9_2+224#>O2_2#/\O2_2+224#>O9_2)#=>max(max(O9,O2)-min(O9,O2),max(O9+155,O2+224)-min(O9+155,O2+224))#=<10#/\max(max(O9_2,O2_2)-min(O9_2,O2_2),max(O9_2+224,O2_2+224)-min(O9_2+224,O2_2+224))#=<10,
	O9+155#>O3#/\O3+224#>O9#/\(O9_2+224#>O3_2#/\O3_2+224#>O9_2)#=>max(max(O9,O3)-min(O9,O3),max(O9+155,O3+224)-min(O9+155,O3+224))#=<10#/\max(max(O9_2,O3_2)-min(O9_2,O3_2),max(O9_2+224,O3_2+224)-min(O9_2+224,O3_2+224))#=<10,
	O9+155#>O4#/\O4+224#>O9#/\(O9_2+224#>O4_2#/\O4_2+224#>O9_2)#=>max(max(O9,O4)-min(O9,O4),max(O9+155,O4+224)-min(O9+155,O4+224))#=<10#/\max(max(O9_2,O4_2)-min(O9_2,O4_2),max(O9_2+224,O4_2+224)-min(O9_2+224,O4_2+224))#=<10,
	O9+155#>O5#/\O5+224#>O9#/\(O9_2+224#>O5_2#/\O5_2+224#>O9_2)#=>max(max(O9,O5)-min(O9,O5),max(O9+155,O5+224)-min(O9+155,O5+224))#=<10#/\max(max(O9_2,O5_2)-min(O9_2,O5_2),max(O9_2+224,O5_2+224)-min(O9_2+224,O5_2+224))#=<10,
	O9+155#>O6#/\O6+224#>O9#/\(O9_2+224#>O6_2#/\O6_2+224#>O9_2)#=>max(max(O9,O6)-min(O9,O6),max(O9+155,O6+224)-min(O9+155,O6+224))#=<10#/\max(max(O9_2,O6_2)-min(O9_2,O6_2),max(O9_2+224,O6_2+224)-min(O9_2+224,O6_2+224))#=<10,
	O9+155#>O7#/\O7+224#>O9#/\(O9_2+224#>O7_2#/\O7_2+224#>O9_2)#=>max(max(O9,O7)-min(O9,O7),max(O9+155,O7+224)-min(O9+155,O7+224))#=<10#/\max(max(O9_2,O7_2)-min(O9_2,O7_2),max(O9_2+224,O7_2+224)-min(O9_2+224,O7_2+224))#=<10,
	O9+155#>O8#/\O8+224#>O9#/\(O9_2+224#>O8_2#/\O8_2+224#>O9_2)#=>max(max(O9,O8)-min(O9,O8),max(O9+155,O8+224)-min(O9+155,O8+224))#=<10#/\max(max(O9_2,O8_2)-min(O9_2,O8_2),max(O9_2+224,O8_2+224)-min(O9_2+224,O8_2+224))#=<10,
	O9+155#>O10#/\O10+112#>O9#/\(O9_2+224#>O10_2#/\O10_2+224#>O9_2)#=>max(max(O9,O10)-min(O9,O10),max(O9+155,O10+112)-min(O9+155,O10+112))#=<10#/\max(max(O9_2,O10_2)-min(O9_2,O10_2),max(O9_2+224,O10_2+224)-min(O9_2+224,O10_2+224))#=<10,
	O10+112#>O2#/\O2+224#>O10#/\(O10_2+224#>O2_2#/\O2_2+224#>O10_2)#=>max(max(O10,O2)-min(O10,O2),max(O10+112,O2+224)-min(O10+112,O2+224))#=<10#/\max(max(O10_2,O2_2)-min(O10_2,O2_2),max(O10_2+224,O2_2+224)-min(O10_2+224,O2_2+224))#=<10,
	O10+112#>O3#/\O3+224#>O10#/\(O10_2+224#>O3_2#/\O3_2+224#>O10_2)#=>max(max(O10,O3)-min(O10,O3),max(O10+112,O3+224)-min(O10+112,O3+224))#=<10#/\max(max(O10_2,O3_2)-min(O10_2,O3_2),max(O10_2+224,O3_2+224)-min(O10_2+224,O3_2+224))#=<10,
	O10+112#>O4#/\O4+224#>O10#/\(O10_2+224#>O4_2#/\O4_2+224#>O10_2)#=>max(max(O10,O4)-min(O10,O4),max(O10+112,O4+224)-min(O10+112,O4+224))#=<10#/\max(max(O10_2,O4_2)-min(O10_2,O4_2),max(O10_2+224,O4_2+224)-min(O10_2+224,O4_2+224))#=<10,
	O10+112#>O5#/\O5+224#>O10#/\(O10_2+224#>O5_2#/\O5_2+224#>O10_2)#=>max(max(O10,O5)-min(O10,O5),max(O10+112,O5+224)-min(O10+112,O5+224))#=<10#/\max(max(O10_2,O5_2)-min(O10_2,O5_2),max(O10_2+224,O5_2+224)-min(O10_2+224,O5_2+224))#=<10,
	O10+112#>O6#/\O6+224#>O10#/\(O10_2+224#>O6_2#/\O6_2+224#>O10_2)#=>max(max(O10,O6)-min(O10,O6),max(O10+112,O6+224)-min(O10+112,O6+224))#=<10#/\max(max(O10_2,O6_2)-min(O10_2,O6_2),max(O10_2+224,O6_2+224)-min(O10_2+224,O6_2+224))#=<10,
	O10+112#>O7#/\O7+224#>O10#/\(O10_2+224#>O7_2#/\O7_2+224#>O10_2)#=>max(max(O10,O7)-min(O10,O7),max(O10+112,O7+224)-min(O10+112,O7+224))#=<10#/\max(max(O10_2,O7_2)-min(O10_2,O7_2),max(O10_2+224,O7_2+224)-min(O10_2+224,O7_2+224))#=<10,
	O10+112#>O8#/\O8+224#>O10#/\(O10_2+224#>O8_2#/\O8_2+224#>O10_2)#=>max(max(O10,O8)-min(O10,O8),max(O10+112,O8+224)-min(O10+112,O8+224))#=<10#/\max(max(O10_2,O8_2)-min(O10_2,O8_2),max(O10_2+224,O8_2+224)-min(O10_2+224,O8_2+224))#=<10,
	O10+112#>O9#/\O9+155#>O10#/\(O10_2+224#>O9_2#/\O9_2+224#>O10_2)#=>max(max(O10,O9)-min(O10,O9),max(O10+112,O9+155)-min(O10+112,O9+155))#=<10#/\max(max(O10_2,O9_2)-min(O10_2,O9_2),max(O10_2+224,O9_2+224)-min(O10_2+224,O9_2+224))#=<10,
	rcp_geost([object(8,7,[O2,O2_2,O2_3],[]),object(12,11,[O3,O3_2,O3_3],[]),object(13,11,[O4,O4_2,O4_3],[]),object(17,16,[O5,O5_2,O5_3],[]),object(18,7,[O6,O6_2,O6_3],[]),object(19,7,[O7,O7_2,O7_3],[]),object(23,22,[O8,O8_2,O8_3],[]),object(27,26,[O9,O9_2,O9_3],[]),object(31,30,[O10,O10_2,O10_3],[])], [sbox(7,[0,0,0],[224,224,111]),sbox(11,[0,0,0],[224,224,74]),sbox(16,[0,0,0],[224,224,148]),sbox(22,[0,0,0],[224,224,222]),sbox(26,[0,0,0],[155,224,222]),sbox(30,[0,0,0],[112,224,148])], [fixall(Geost_greedyflag,[object(_,min(1),[min(4),min(3),min(2)]),object(_,min(1),[max(4),min(3),min(2)]),object(_,min(1),[max(4),max(3),min(2)]),object(_,min(1),[min(4),max(3),min(2)])])], [non_overlapping(objects([8,12,13,17,18,19,23,27,31]),[1,2,3])]),
	0#=<O2,
	O2+224#=<1203,
	0#=<O2_2,
	O2_2+224#=<235,
	0#=<O2_3,
	O2_3+111#=<239,
	0#=<O3,
	O3+224#=<1203,
	0#=<O3_2,
	O3_2+224#=<235,
	0#=<O3_3,
	O3_3+74#=<239,
	0#=<O4,
	O4+224#=<1203,
	0#=<O4_2,
	O4_2+224#=<235,
	0#=<O4_3,
	O4_3+74#=<239,
	0#=<O5,
	O5+224#=<1203,
	0#=<O5_2,
	O5_2+224#=<235,
	0#=<O5_3,
	O5_3+148#=<239,
	0#=<O6,
	O6+224#=<1203,
	0#=<O6_2,
	O6_2+224#=<235,
	0#=<O6_3,
	O6_3+111#=<239,
	0#=<O7,
	O7+224#=<1203,
	0#=<O7_2,
	O7_2+224#=<235,
	0#=<O7_3,
	O7_3+111#=<239,
	0#=<O8,
	O8+224#=<1203,
	0#=<O8_2,
	O8_2+224#=<235,
	0#=<O8_3,
	O8_3+222#=<239,
	0#=<O9,
	O9+155#=<1203,
	0#=<O9_2,
	O9_2+224#=<235,
	0#=<O9_3,
	O9_3+222#=<239,
	0#=<O10,
	O10+112#=<1203,
	0#=<O10_2,
	O10_2+224#=<235,
	0#=<O10_3,
	O10_3+148#=<239,
	rcp_geost([object(8,7,[O2,O2_2,O2_3],[]),object(12,11,[O3,O3_2,O3_3],[]),object(13,11,[O4,O4_2,O4_3],[]),object(17,16,[O5,O5_2,O5_3],[]),object(18,7,[O6,O6_2,O6_3],[]),object(19,7,[O7,O7_2,O7_3],[]),object(23,22,[O8,O8_2,O8_3],[]),object(27,26,[O9,O9_2,O9_3],[]),object(31,30,[O10,O10_2,O10_3],[])], [sbox(7,[0,0,0],[224,224,111]),sbox(11,[0,0,0],[224,224,74]),sbox(16,[0,0,0],[224,224,148]),sbox(22,[0,0,0],[224,224,222]),sbox(26,[0,0,0],[155,224,222]),sbox(30,[0,0,0],[112,224,148])], [non_overlapping(objects([8,12,13,17,18,19,23,27,31]),[1,2,3])]),
	labeling([up], [O4_3]),
	labeling([bisect], [O4,O4_2]),
	labeling([up], [O8_3]),
	labeling([bisect], [O8,O8_2]),
	labeling([up], [O3_3]),
	labeling([bisect], [O3,O3_2]),
	labeling([up], [O9_3]),
	labeling([bisect], [O9,O9_2]),
	labeling([up], [O5_3]),
	labeling([bisect], [O5,O5_2]),
	labeling([up], [O2_3]),
	labeling([bisect], [O2,O2_2]),
	labeling([up], [O10_3]),
	labeling([bisect], [O10,O10_2]),
	labeling([up], [O7_3]),
	labeling([bisect], [O7,O7_2]),
	labeling([up], [O6_3]),
	labeling([bisect], [O6,O6_2]),
	statistics(runtime, [_Runtime_1_|_]),
	fd_statistics(backtracks, _Backtracks_),
	_Runtime_ is _Runtime_1_-_Runtime_0_,
	format('~3d seconds\n', [_Runtime_]),
	format('~w bactracks\n\n', [_Backtracks_]).
