:- use_module(library(clpfd)).
:- use_module('/afs/inria.fr/rocq/home/contraintes/common/src/rules2cp/interpreter/prolog/r2cp.pl').
:- init_interpreter.



rcp_psa_bin_packing_foldr_1([], _, 0) :- 
	!.
rcp_psa_bin_packing_foldr_1([J_86|Tail], [], _M_) :- 
	fd_or(_K_, _L_, _M_),
	fd_and(_C_, _J_, _K_),
	rcp_x(J_86, _A_),
	fd_size(_A_, _B_),
	fd_gt(_B_, 1, _C_),
	fd_and(_F_, _I_, _J_),
	rcp_y(J_86, _D_),
	fd_size(_D_, _E_),
	fd_gt(_E_, 1, _F_),
	rcp_z(J_86, _G_),
	fd_size(_G_, _H_),
	fd_gt(_H_, 1, _I_),
	rcp_psa_bin_packing_foldr_1(Tail, [], _L_).

rcp_psa_bin_packing_foldr_1_search([], _, 0) :- 
	!.
rcp_psa_bin_packing_foldr_1_search([J_86|Tail], [], _) :- 
	rcp_x_search(J_86, _N_),
	fd_size(_N_, _O_),
	rcp_y_search(J_86, _P_),
	fd_size(_P_, _Q_),
	rcp_z_search(J_86, _R_),
	fd_size(_R_, _S_),
	(
	fd_gt(_O_, 1),
	fd_gt(_Q_, 1),
	fd_gt(_S_, 1)
	;
	rcp_psa_bin_packing_foldr_1_search(Tail, [], _T_),
	rcp_assert(_T_)
	).

rcp_psa_bin_packing_foldr_2([], _, 0) :- 
	!.
rcp_psa_bin_packing_foldr_2([K_87|Tail], [], _T_) :- 
	fd_or(_R_, _S_, _T_),
	fd_and(_C_, _Q_, _R_),
	rcp_x(K_87, _A_),
	fd_size(_A_, _B_),
	fd_gt(_B_, 1, _C_),
	fd_and(_G_, _P_, _Q_),
	rcp_x(K_87, _D_),
	rcp_x(K_87, _E_),
	fd_min(_E_, _F_),
	fd_eq(_D_, _F_, _G_),
	fd_and(_K_, _O_, _P_),
	rcp_y(K_87, _H_),
	rcp_y(K_87, _I_),
	fd_min(_I_, _J_),
	fd_eq(_H_, _J_, _K_),
	rcp_z(K_87, _L_),
	rcp_z(K_87, _M_),
	fd_min(_M_, _N_),
	fd_eq(_L_, _N_, _O_),
	rcp_psa_bin_packing_foldr_2(Tail, [], _S_).

rcp_psa_bin_packing_foldr_2_search([], _, 0) :- 
	!.
rcp_psa_bin_packing_foldr_2_search([K_87|Tail], [], _) :- 
	rcp_x_search(K_87, _U_),
	fd_size(_U_, _V_),
	rcp_x_search(K_87, _W_),
	rcp_x_search(K_87, _X_),
	fd_min(_X_, _Y_),
	rcp_y_search(K_87, _Z_),
	rcp_y_search(K_87, _B1_),
	fd_min(_B1_, _C1_),
	rcp_z_search(K_87, _D1_),
	rcp_z_search(K_87, _E1_),
	fd_min(_E1_, _F1_),
	(
	fd_gt(_V_, 1),
	fd_eq(_W_, _Y_),
	fd_eq(_Z_, _C1_),
	fd_eq(_D1_, _F1_)
	;
	rcp_psa_bin_packing_foldr_2_search(Tail, [], _G1_),
	rcp_assert(_G1_)
	).

rcp_c11_dim(_A_) :- 
	_A_=[600,400,200].

rcp_c11_dim_search(_A_) :- 
	_A_=[600,400,200].

rcp_cont(_A_) :- 
	rcp_make_shape_box([2240,2240,992], _A_).

rcp_cont_search(_A_) :- 
	rcp_make_shape_box_search([2240,2240,992], _A_).

rcp_obj_cont(_B_) :- 
	rcp_cont(_A_),
	rcp_make_object_shape(_A_, [0,0,0], _B_).

rcp_obj_cont_search(_B_) :- 
	rcp_cont_search(_A_),
	rcp_make_object_shape_search(_A_, [0,0,0], _B_).

rcp_items(_A_) :- 
	rcp_objL(2, _A_).

rcp_items_search(_A_) :- 
	rcp_objL_search(2, _A_).

rcp_bin(_A_) :- 
	rcp_obj_cont(_A_).

rcp_bin_search(_A_) :- 
	rcp_obj_cont_search(_A_).

rcp_dimensions(_A_) :- 
	_A_=[1,2,3].

rcp_dimensions_search(_A_) :- 
	_A_=[1,2,3].

rcp_sum_foldr_3([], _, 0) :- 
	!.
rcp_sum_foldr_3([X_88|Tail], [L], _B_) :- 
	rcp_sum_foldr_3(Tail, [L], _A_),
	fd_aeq(X_88+_A_, _B_).

rcp_sum_foldr_3_search([], _, 0) :- 
	!.
rcp_sum_foldr_3_search([X_88|Tail], [L], _D_) :- 
	rcp_sum_foldr_3_search(Tail, [L], _C_),
	fd_aeq(X_88+_C_, _D_).

rcp_sum(L, _A_) :- 
	rcp_sum_foldr_3(L, [L], _A_).

rcp_sum_search(L, _A_) :- 
	rcp_sum_foldr_3_search(L, [L], _A_).

rcp_product_foldr_4([], _, 1) :- 
	!.
rcp_product_foldr_4([X_89|Tail], [L], _B_) :- 
	rcp_product_foldr_4(Tail, [L], _A_),
	fd_aeq(X_89*_A_, _B_).

rcp_product_foldr_4_search([], _, 1) :- 
	!.
rcp_product_foldr_4_search([X_89|Tail], [L], _D_) :- 
	rcp_product_foldr_4_search(Tail, [L], _C_),
	fd_aeq(X_89*_C_, _D_).

rcp_product(L, _A_) :- 
	rcp_product_foldr_4(L, [L], _A_).

rcp_product_search(L, _A_) :- 
	rcp_product_foldr_4_search(L, [L], _A_).

rcp_maximum_foldr_5([], _, -268435456) :- 
	!.
rcp_maximum_foldr_5([X_90|Tail], [L], _B_) :- 
	rcp_maximum_foldr_5(Tail, [L], _A_),
	fd_aeq(max(X_90,_A_), _B_).

rcp_maximum_foldr_5_search([], _, -268435456) :- 
	!.
rcp_maximum_foldr_5_search([X_90|Tail], [L], _D_) :- 
	rcp_maximum_foldr_5_search(Tail, [L], _C_),
	fd_aeq(max(X_90,_C_), _D_).

rcp_maximum(L, _A_) :- 
	rcp_maximum_foldr_5(L, [L], _A_).

rcp_maximum_search(L, _A_) :- 
	rcp_maximum_foldr_5_search(L, [L], _A_).

rcp_minimum_foldr_6([], _, 267999999) :- 
	!.
rcp_minimum_foldr_6([X_91|Tail], [L], _B_) :- 
	rcp_minimum_foldr_6(Tail, [L], _A_),
	fd_aeq(min(X_91,_A_), _B_).

rcp_minimum_foldr_6_search([], _, 267999999) :- 
	!.
rcp_minimum_foldr_6_search([X_91|Tail], [L], _D_) :- 
	rcp_minimum_foldr_6_search(Tail, [L], _C_),
	fd_aeq(min(X_91,_C_), _D_).

rcp_minimum(L, _A_) :- 
	rcp_minimum_foldr_6(L, [L], _A_).

rcp_minimum_search(L, _A_) :- 
	rcp_minimum_foldr_6_search(L, [L], _A_).

rcp_oversize(O1, O2, D, _O_) :- 
	rcp_origin(O1, D, _A_),
	rcp_origin(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_origin(O1, D, _D_),
	rcp_origin(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	rcp_end(O1, D, _H_),
	rcp_end(O2, D, _I_),
	fd_aeq(max(_H_,_I_), _J_),
	rcp_end(O1, D, _K_),
	rcp_end(O2, D, _L_),
	fd_aeq(min(_K_,_L_), _M_),
	fd_aeq(_J_-_M_, _N_),
	fd_aeq(max(_G_,_N_), _O_).

rcp_oversize_search(O1, O2, D, _O_) :- 
	rcp_origin_search(O1, D, _A_),
	rcp_origin_search(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_origin_search(O1, D, _D_),
	rcp_origin_search(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	rcp_end_search(O1, D, _H_),
	rcp_end_search(O2, D, _I_),
	fd_aeq(max(_H_,_I_), _J_),
	rcp_end_search(O1, D, _K_),
	rcp_end_search(O2, D, _L_),
	fd_aeq(min(_K_,_L_), _M_),
	fd_aeq(_J_-_M_, _N_),
	fd_aeq(max(_G_,_N_), _O_).

rcp_make_box(L, _A_) :- 
	rcp_rec([size=L], _A_).

rcp_make_box_search(L, _A_) :- 
	rcp_rec([size=L], _A_).

rcp_box_volume(B, _B_) :- 
	rcp_att(size, B, _A_),
	rcp_product(_A_, _B_).

rcp_box_volume_search(B, _B_) :- 
	rcp_att(size, B, _A_),
	rcp_product_search(_A_, _B_).

rcp_make_sbox(B, O, _A_) :- 
	rcp_rec([box=B,offset=O], _A_).

rcp_make_sbox_search(B, O, _A_) :- 
	rcp_rec([box=B,offset=O], _A_).

rcp_sbox_size(SB, D, _C_) :- 
	rcp_att(box, SB, _A_),
	rcp_att(size, _A_, _B_),
	nth1(D, _B_, _C_).

rcp_sbox_size_search(SB, D, _C_) :- 
	rcp_att(box, SB, _A_),
	rcp_att(size, _A_, _B_),
	nth1(D, _B_, _C_).

rcp_sbox_offset(SB, D, _B_) :- 
	rcp_att(offset, SB, _A_),
	nth1(D, _A_, _B_).

rcp_sbox_offset_search(SB, D, _B_) :- 
	rcp_att(offset, SB, _A_),
	nth1(D, _A_, _B_).

rcp_sbox_end(SB, D, _C_) :- 
	rcp_sbox_offset(SB, D, _A_),
	rcp_sbox_size(SB, D, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_sbox_end_search(SB, D, _C_) :- 
	rcp_sbox_offset_search(SB, D, _A_),
	rcp_sbox_size_search(SB, D, _B_),
	fd_aeq(_A_+_B_, _C_).

rcp_make_shape(SBs, _A_) :- 
	rcp_rec([sboxes=SBs], _A_).

rcp_make_shape_search(SBs, _A_) :- 
	rcp_rec([sboxes=SBs], _A_).

rcp_make_shape_box_foldr_7([], _, []) :- 
	!.
rcp_make_shape_box_foldr_7([_free_var_92|Tail], [L], [0|_A_]) :- 
	rcp_make_shape_box_foldr_7(Tail, [L], _A_).

rcp_make_shape_box_foldr_7_search([], _, []) :- 
	!.
rcp_make_shape_box_foldr_7_search([_free_var_92|Tail], [L], [0|_B_]) :- 
	rcp_make_shape_box_foldr_7_search(Tail, [L], _B_).

rcp_make_shape_box(L, _D_) :- 
	rcp_make_box(L, _A_),
	rcp_make_shape_box_foldr_7(L, [L], _B_),
	rcp_make_sbox(_A_, _B_, _C_),
	rcp_make_shape([_C_], _D_).

rcp_make_shape_box_search(L, _D_) :- 
	rcp_make_box_search(L, _A_),
	rcp_make_shape_box_foldr_7_search(L, [L], _B_),
	rcp_make_sbox_search(_A_, _B_, _C_),
	rcp_make_shape_search([_C_], _D_).

rcp_shape_volume_foldr_8([], _, []) :- 
	!.
rcp_shape_volume_foldr_8([SB_93|Tail], [S], [_B_|_C_]) :- 
	rcp_att(box, SB_93, _A_),
	rcp_box_volume(_A_, _B_),
	rcp_shape_volume_foldr_8(Tail, [S], _C_).

rcp_shape_volume_foldr_8_search([], _, []) :- 
	!.
rcp_shape_volume_foldr_8_search([SB_93|Tail], [S], [_E_|_F_]) :- 
	rcp_att(box, SB_93, _D_),
	rcp_box_volume_search(_D_, _E_),
	rcp_shape_volume_foldr_8_search(Tail, [S], _F_).

rcp_shape_volume(S, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_volume_foldr_8(_A_, [S], _B_),
	rcp_sum(_B_, _C_).

rcp_shape_volume_search(S, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_volume_foldr_8_search(_A_, [S], _B_),
	rcp_sum_search(_B_, _C_).

rcp_shape_origin_foldr_9([], _, []) :- 
	!.
rcp_shape_origin_foldr_9([SB_94|Tail], [D,S], [_A_|_B_]) :- 
	rcp_sbox_offset(SB_94, D, _A_),
	rcp_shape_origin_foldr_9(Tail, [D,S], _B_).

rcp_shape_origin_foldr_9_search([], _, []) :- 
	!.
rcp_shape_origin_foldr_9_search([SB_94|Tail], [D,S], [_C_|_D_]) :- 
	rcp_sbox_offset_search(SB_94, D, _C_),
	rcp_shape_origin_foldr_9_search(Tail, [D,S], _D_).

rcp_shape_origin(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_origin_foldr_9(_A_, [D,S], _B_),
	rcp_minimum(_B_, _C_).

rcp_shape_origin_search(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_origin_foldr_9_search(_A_, [D,S], _B_),
	rcp_minimum_search(_B_, _C_).

rcp_shape_end_foldr_10([], _, []) :- 
	!.
rcp_shape_end_foldr_10([SB_95|Tail], [D,S], [_A_|_B_]) :- 
	rcp_sbox_end(SB_95, D, _A_),
	rcp_shape_end_foldr_10(Tail, [D,S], _B_).

rcp_shape_end_foldr_10_search([], _, []) :- 
	!.
rcp_shape_end_foldr_10_search([SB_95|Tail], [D,S], [_C_|_D_]) :- 
	rcp_sbox_end_search(SB_95, D, _C_),
	rcp_shape_end_foldr_10_search(Tail, [D,S], _D_).

rcp_shape_end(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_end_foldr_10(_A_, [D,S], _B_),
	rcp_maximum(_B_, _C_).

rcp_shape_end_search(S, D, _C_) :- 
	rcp_att(sboxes, S, _A_),
	rcp_shape_end_foldr_10_search(_A_, [D,S], _B_),
	rcp_maximum_search(_B_, _C_).

rcp_shape_size(S, D, _C_) :- 
	rcp_shape_end(S, D, _A_),
	rcp_shape_origin(S, D, _B_),
	fd_aeq(_A_-_B_, _C_).

rcp_shape_size_search(S, D, _C_) :- 
	rcp_shape_end_search(S, D, _A_),
	rcp_shape_origin_search(S, D, _B_),
	fd_aeq(_A_-_B_, _C_).

rcp_make_object(SL, OL, _A_) :- 
	rcp_var(from(make_object(SL,OL),0,0), Make_object_SL_OL),
	rcp_rec([shapes=SL,shape_index=Make_object_SL_OL,origin=OL], _A_).

rcp_make_object_search(SL, OL, _A_) :- 
	rcp_var(from(make_object(SL,OL),0,0), Make_object_SL_OL),
	rcp_rec([shapes=SL,shape_index=Make_object_SL_OL,origin=OL], _A_).

rcp_make_object(SL, OL, S, W, _A_) :- 
	rcp_rec([shapes=SL,shape_index=S,origin=OL,weight=W], _A_).

rcp_make_object_search(SL, OL, S, W, _A_) :- 
	rcp_rec([shapes=SL,shape_index=S,origin=OL,weight=W], _A_).

rcp_make_object_shape(S, L, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L], _A_).

rcp_make_object_shape_search(S, L, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L], _A_).

rcp_make_object_shape(S, L, W, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W], _A_).

rcp_make_object_shape_search(S, L, W, _A_) :- 
	rcp_rec([shapes=[S],shape_index=1,origin=L,weight=W], _A_).

rcp_origin(O, D, _B_) :- 
	rcp_att(origin, O, _A_),
	nth1(D, _A_, _B_).

rcp_origin_search(O, D, _B_) :- 
	rcp_att(origin, O, _A_),
	nth1(D, _A_, _B_).

rcp_x(O, _A_) :- 
	rcp_origin(O, 1, _A_).

rcp_x_search(O, _A_) :- 
	rcp_origin_search(O, 1, _A_).

rcp_y(O, _A_) :- 
	rcp_origin(O, 2, _A_).

rcp_y_search(O, _A_) :- 
	rcp_origin_search(O, 2, _A_).

rcp_z(O, _A_) :- 
	rcp_origin(O, 3, _A_).

rcp_z_search(O, _A_) :- 
	rcp_origin_search(O, 3, _A_).

rcp_end_foldr_11([], _, []) :- 
	!.
rcp_end_foldr_11([S_96|Tail], [D,O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_96),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_end(S_96, D, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_end_foldr_11(Tail, [D,O], _G_).

rcp_end_foldr_11_search([], _, []) :- 
	!.
rcp_end_foldr_11_search([S_96|Tail], [D,O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_96),
	rcp_shape_end_search(S_96, D, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_end_foldr_11_search(Tail, [D,O], _M_).

rcp_end(O, D, _E_) :- 
	rcp_origin(O, D, _A_),
	rcp_att(shapes, O, _B_),
	rcp_end_foldr_11(_B_, [D,O], _C_),
	rcp_sum(_C_, _D_),
	fd_aeq(_A_+_D_, _E_).

rcp_end_search(O, D, _E_) :- 
	rcp_origin_search(O, D, _A_),
	rcp_att(shapes, O, _B_),
	rcp_end_foldr_11_search(_B_, [D,O], _C_),
	rcp_sum_search(_C_, _D_),
	fd_aeq(_A_+_D_, _E_).

rcp_size_foldr_12([], _, []) :- 
	!.
rcp_size_foldr_12([S_97|Tail], [D,O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_97),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_size(S_97, D, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_size_foldr_12(Tail, [D,O], _G_).

rcp_size_foldr_12_search([], _, []) :- 
	!.
rcp_size_foldr_12_search([S_97|Tail], [D,O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_97),
	rcp_shape_size_search(S_97, D, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_size_foldr_12_search(Tail, [D,O], _M_).

rcp_size(O, D, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_size_foldr_12(_A_, [D,O], _B_),
	rcp_sum(_B_, _C_).

rcp_size_search(O, D, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_size_foldr_12_search(_A_, [D,O], _B_),
	rcp_sum_search(_B_, _C_).

rcp_volume_foldr_13([], _, []) :- 
	!.
rcp_volume_foldr_13([S_98|Tail], [O], [_F_|_G_]) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	nth1(_C_, _B_, S_98),
	fd_eq(_A_, _C_, _D_),
	rcp_shape_volume(S_98, _E_),
	fd_aeq(_D_*_E_, _F_),
	rcp_volume_foldr_13(Tail, [O], _G_).

rcp_volume_foldr_13_search([], _, []) :- 
	!.
rcp_volume_foldr_13_search([S_98|Tail], [O], [_L_|_M_]) :- 
	rcp_att(shape_index, O, _H_),
	rcp_att(shapes, O, _I_),
	nth1(_J_, _I_, S_98),
	rcp_shape_volume_search(S_98, _K_),
	fd_aeq(fd_eq(_H_,_J_)*_K_, _L_),
	rcp_volume_foldr_13_search(Tail, [O], _M_).

rcp_volume(O, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_volume_foldr_13(_A_, [O], _B_),
	rcp_sum(_B_, _C_).

rcp_volume_search(O, _C_) :- 
	rcp_att(shapes, O, _A_),
	rcp_volume_foldr_13_search(_A_, [O], _B_),
	rcp_sum_search(_B_, _C_).

rcp_distance(O1, O2, D, _H_) :- 
	rcp_origin(O1, D, _A_),
	rcp_origin(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_end(O1, D, _D_),
	rcp_end(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	fd_aeq(max(0,_G_), _H_).

rcp_distance_search(O1, O2, D, _H_) :- 
	rcp_origin_search(O1, D, _A_),
	rcp_origin_search(O2, D, _B_),
	fd_aeq(max(_A_,_B_), _C_),
	rcp_end_search(O1, D, _D_),
	rcp_end_search(O2, D, _E_),
	fd_aeq(min(_D_,_E_), _F_),
	fd_aeq(_C_-_F_, _G_),
	fd_aeq(max(0,_G_), _H_).

rcp_box_orient(W, H, L, _G_) :- 
	rcp_c11_dim(_A_),
	nth1(W, _A_, _B_),
	rcp_c11_dim(_C_),
	nth1(H, _C_, _D_),
	rcp_c11_dim(_E_),
	nth1(L, _E_, _F_),
	_G_=[_B_,_D_,_F_].

rcp_box_orient_search(W, H, L, _G_) :- 
	rcp_c11_dim_search(_A_),
	nth1(W, _A_, _B_),
	rcp_c11_dim_search(_C_),
	nth1(H, _C_, _D_),
	rcp_c11_dim_search(_E_),
	nth1(L, _E_, _F_),
	_G_=[_B_,_D_,_F_].

rcp_objL_foldr_14([], _, []) :- 
	!.
rcp_objL_foldr_14([I_99|Tail], [N], [_A_|_B_]) :- 
	rcp_obj(I_99, _A_),
	rcp_objL_foldr_14(Tail, [N], _B_).

rcp_objL_foldr_14_search([], _, []) :- 
	!.
rcp_objL_foldr_14_search([I_99|Tail], [N], [_C_|_D_]) :- 
	rcp_obj_search(I_99, _C_),
	rcp_objL_foldr_14_search(Tail, [N], _D_).

rcp_objL(N, _B_) :- 
	rcp_range([1..N], _A_),
	rcp_objL_foldr_14(_A_, [N], _B_).

rcp_objL_search(N, _B_) :- 
	rcp_range([1..N], _A_),
	rcp_objL_foldr_14_search(_A_, [N], _B_).

rcp_obj(O, _C_) :- 
	rcp_box_orient(1, 2, 3, _A_),
	rcp_make_shape_box(_A_, _B_),
	rcp_var(from(obj(O),0,1), Obj_O),
	rcp_var(from(obj(O),0,2), Obj_O_2),
	rcp_var(from(obj(O),0,3), Obj_O_3),
	rcp_make_object_shape(_B_, [Obj_O,Obj_O_2,Obj_O_3], 11, _C_).

rcp_obj_search(O, _C_) :- 
	rcp_box_orient_search(1, 2, 3, _A_),
	rcp_make_shape_box_search(_A_, _B_),
	rcp_var(from(obj(O),0,1), Obj_O),
	rcp_var(from(obj(O),0,2), Obj_O_2),
	rcp_var(from(obj(O),0,3), Obj_O_3),
	rcp_make_object_shape_search(_B_, [Obj_O,Obj_O_2,Obj_O_3], 11, _C_).

rcp_w(O, _A_) :- 
	rcp_size(O, 1, _A_).

rcp_w_search(O, _A_) :- 
	rcp_size_search(O, 1, _A_).

rcp_h(O, _A_) :- 
	rcp_size(O, 2, _A_).

rcp_h_search(O, _A_) :- 
	rcp_size_search(O, 2, _A_).

rcp_l(O, _A_) :- 
	rcp_size(O, 3, _A_).

rcp_l_search(O, _A_) :- 
	rcp_size_search(O, 3, _A_).

rcp_geost_constraint_foldr_16([], _, []) :- 
	!.
rcp_geost_constraint_foldr_16([S_102|Tail], [Dims,I_100,Items], [_A_|_B_]) :- 
	rcp_att(uid, S_102, _A_),
	rcp_geost_constraint_foldr_16(Tail, [Dims,I_100,Items], _B_).

rcp_geost_constraint_foldr_16_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_16_search([S_102|Tail], [Dims,I_100,Items], [_C_|_D_]) :- 
	rcp_att(uid, S_102, _C_),
	rcp_geost_constraint_foldr_16_search(Tail, [Dims,I_100,Items], _D_).

rcp_geost_constraint_foldr_15([], _, []) :- 
	!.
rcp_geost_constraint_foldr_15([I_100|Tail], [Dims,Items], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_100, _A_),
	rcp_att(shape_index, I_100, _B_),
	rcp_att(shapes, I_100, _C_),
	rcp_geost_constraint_foldr_16(_C_, [Dims,I_100,Items], _D_),
	rcp_att(origin, I_100, _E_),
	rcp_geost_constraint_foldr_15(Tail, [Dims,Items], _F_).

rcp_geost_constraint_foldr_15_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_15_search([I_100|Tail], [Dims,Items], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_100, _G_),
	rcp_att(shape_index, I_100, _H_),
	rcp_att(shapes, I_100, _I_),
	rcp_geost_constraint_foldr_16_search(_I_, [Dims,I_100,Items], _J_),
	rcp_att(origin, I_100, _K_),
	rcp_geost_constraint_foldr_15_search(Tail, [Dims,Items], _L_).

rcp_geost_constraint_foldr_19([], _, []) :- 
	!.
rcp_geost_constraint_foldr_19([SB_108|Tail], [Dims,I_103,Items,S_106], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_106, _A_),
	rcp_att(offset, SB_108, _B_),
	rcp_att(box, SB_108, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_19(Tail, [Dims,I_103,Items,S_106], _E_).

rcp_geost_constraint_foldr_19_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_19_search([SB_108|Tail], [Dims,I_103,Items,S_106], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_106, _F_),
	rcp_att(offset, SB_108, _G_),
	rcp_att(box, SB_108, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_19_search(Tail, [Dims,I_103,Items,S_106], _J_).

rcp_geost_constraint_foldr_18([], _, []) :- 
	!.
rcp_geost_constraint_foldr_18([S_106|Tail], [Dims,I_103,Items], [_B_|_C_]) :- 
	rcp_att(sboxes, S_106, _A_),
	rcp_geost_constraint_foldr_19(_A_, [Dims,I_103,Items,S_106], _B_),
	rcp_geost_constraint_foldr_18(Tail, [Dims,I_103,Items], _C_).

rcp_geost_constraint_foldr_18_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_18_search([S_106|Tail], [Dims,I_103,Items], [_E_|_F_]) :- 
	rcp_att(sboxes, S_106, _D_),
	rcp_geost_constraint_foldr_19_search(_D_, [Dims,I_103,Items,S_106], _E_),
	rcp_geost_constraint_foldr_18_search(Tail, [Dims,I_103,Items], _F_).

rcp_geost_constraint_foldr_17([], _, []) :- 
	!.
rcp_geost_constraint_foldr_17([I_103|Tail], [Dims,Items], [_B_|_C_]) :- 
	rcp_att(shapes, I_103, _A_),
	rcp_geost_constraint_foldr_18(_A_, [Dims,I_103,Items], _B_),
	rcp_geost_constraint_foldr_17(Tail, [Dims,Items], _C_).

rcp_geost_constraint_foldr_17_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_17_search([I_103|Tail], [Dims,Items], [_E_|_F_]) :- 
	rcp_att(shapes, I_103, _D_),
	rcp_geost_constraint_foldr_18_search(_D_, [Dims,I_103,Items], _E_),
	rcp_geost_constraint_foldr_17_search(Tail, [Dims,Items], _F_).

rcp_non_overlapping(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_15(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_17(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_non_overlapping_search(Items, Dims, _D_) :- 
	rcp_geost_constraint_foldr_15_search(Items, [Dims,Items], _A_),
	rcp_geost_constraint_foldr_17_search(Items, [Dims,Items], _B_),
	length(Dims, _C_),
	rcp_geost_constraint(_A_, _B_, _C_, _D_).

rcp_geost_constraint_foldr_21([], _, []) :- 
	!.
rcp_geost_constraint_foldr_21([S_111|Tail], [Dims,F,I_109,Items,Patterns], [_A_|_B_]) :- 
	rcp_att(uid, S_111, _A_),
	rcp_geost_constraint_foldr_21(Tail, [Dims,F,I_109,Items,Patterns], _B_).

rcp_geost_constraint_foldr_21_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_21_search([S_111|Tail], [Dims,F,I_109,Items,Patterns], [_C_|_D_]) :- 
	rcp_att(uid, S_111, _C_),
	rcp_geost_constraint_foldr_21_search(Tail, [Dims,F,I_109,Items,Patterns], _D_).

rcp_geost_constraint_foldr_20([], _, []) :- 
	!.
rcp_geost_constraint_foldr_20([I_109|Tail], [Dims,F,Items,Patterns], [[_A_,_B_,_D_,_E_]|_F_]) :- 
	rcp_att(uid, I_109, _A_),
	rcp_att(shape_index, I_109, _B_),
	rcp_att(shapes, I_109, _C_),
	rcp_geost_constraint_foldr_21(_C_, [Dims,F,I_109,Items,Patterns], _D_),
	rcp_att(origin, I_109, _E_),
	rcp_geost_constraint_foldr_20(Tail, [Dims,F,Items,Patterns], _F_).

rcp_geost_constraint_foldr_20_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_20_search([I_109|Tail], [Dims,F,Items,Patterns], [[_G_,_H_,_J_,_K_]|_L_]) :- 
	rcp_att(uid, I_109, _G_),
	rcp_att(shape_index, I_109, _H_),
	rcp_att(shapes, I_109, _I_),
	rcp_geost_constraint_foldr_21_search(_I_, [Dims,F,I_109,Items,Patterns], _J_),
	rcp_att(origin, I_109, _K_),
	rcp_geost_constraint_foldr_20_search(Tail, [Dims,F,Items,Patterns], _L_).

rcp_geost_constraint_foldr_24([], _, []) :- 
	!.
rcp_geost_constraint_foldr_24([SB_117|Tail], [Dims,F,I_112,Items,Patterns,S_115], [[_A_,_B_,_D_]|_E_]) :- 
	rcp_att(uid, S_115, _A_),
	rcp_att(offset, SB_117, _B_),
	rcp_att(box, SB_117, _C_),
	rcp_att(size, _C_, _D_),
	rcp_geost_constraint_foldr_24(Tail, [Dims,F,I_112,Items,Patterns,S_115], _E_).

rcp_geost_constraint_foldr_24_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_24_search([SB_117|Tail], [Dims,F,I_112,Items,Patterns,S_115], [[_F_,_G_,_I_]|_J_]) :- 
	rcp_att(uid, S_115, _F_),
	rcp_att(offset, SB_117, _G_),
	rcp_att(box, SB_117, _H_),
	rcp_att(size, _H_, _I_),
	rcp_geost_constraint_foldr_24_search(Tail, [Dims,F,I_112,Items,Patterns,S_115], _J_).

rcp_geost_constraint_foldr_23([], _, []) :- 
	!.
rcp_geost_constraint_foldr_23([S_115|Tail], [Dims,F,I_112,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(sboxes, S_115, _A_),
	rcp_geost_constraint_foldr_24(_A_, [Dims,F,I_112,Items,Patterns,S_115], _B_),
	rcp_geost_constraint_foldr_23(Tail, [Dims,F,I_112,Items,Patterns], _C_).

rcp_geost_constraint_foldr_23_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_23_search([S_115|Tail], [Dims,F,I_112,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(sboxes, S_115, _D_),
	rcp_geost_constraint_foldr_24_search(_D_, [Dims,F,I_112,Items,Patterns,S_115], _E_),
	rcp_geost_constraint_foldr_23_search(Tail, [Dims,F,I_112,Items,Patterns], _F_).

rcp_geost_constraint_foldr_22([], _, []) :- 
	!.
rcp_geost_constraint_foldr_22([I_112|Tail], [Dims,F,Items,Patterns], [_B_|_C_]) :- 
	rcp_att(shapes, I_112, _A_),
	rcp_geost_constraint_foldr_23(_A_, [Dims,F,I_112,Items,Patterns], _B_),
	rcp_geost_constraint_foldr_22(Tail, [Dims,F,Items,Patterns], _C_).

rcp_geost_constraint_foldr_22_search([], _, []) :- 
	!.
rcp_geost_constraint_foldr_22_search([I_112|Tail], [Dims,F,Items,Patterns], [_E_|_F_]) :- 
	rcp_att(shapes, I_112, _D_),
	rcp_geost_constraint_foldr_23_search(_D_, [Dims,F,I_112,Items,Patterns], _E_),
	rcp_geost_constraint_foldr_22_search(Tail, [Dims,F,Items,Patterns], _F_).

rcp_non_overlapping(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_20(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_22(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_non_overlapping_search(Items, Dims, F, Patterns, _E_) :- 
	rcp_geost_constraint_foldr_20_search(Items, [Dims,F,Items,Patterns], _A_),
	rcp_geost_constraint_foldr_22_search(Items, [Dims,F,Items,Patterns], _B_),
	length(Dims, _C_),
	rcp_fixall_search(F, Patterns, _D_),
	rcp_geost_constraint(_A_, _B_, _C_, [_D_], _E_).

rcp_precedes(A, B, D, _C_) :- 
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_).

rcp_precedes_search(A, B, D, _C_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	fd_lt(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_meets(A, B, D, _C_) :- 
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_).

rcp_meets_search(A, B, D, _C_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	fd_eq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_overlaps(A, B, D, _K_) :- 
	fd_and(_C_, _J_, _K_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_and(_F_, _I_, _J_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_),
	rcp_origin(B, D, _G_),
	rcp_end(A, D, _H_),
	fd_lt(_G_, _H_, _I_).

rcp_overlaps_search(A, B, D, _G_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	rcp_origin_search(B, D, _E_),
	rcp_end_search(A, D, _F_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_lt(_E_, _F_),
	fd_aeq(_G_, 1).

rcp_contains(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_contains_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_starts(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_starts_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_eq(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_finishes(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_finishes_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_lt(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_equals(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_equals_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_eq(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_started_by(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_eq(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_started_by_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_eq(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_finished_by(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_gt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_eq(_D_, _E_, _F_).

rcp_finished_by_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_gt(_A_, _B_),
	fd_eq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_during(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	rcp_end(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_).

rcp_during_search(A, B, D, _E_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_end_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_overlapped_by(A, B, D, _K_) :- 
	fd_and(_C_, _J_, _K_),
	rcp_origin(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_and(_F_, _I_, _J_),
	rcp_origin(A, D, _D_),
	rcp_end(B, D, _E_),
	fd_lt(_D_, _E_, _F_),
	rcp_end(A, D, _G_),
	rcp_end(B, D, _H_),
	fd_gt(_G_, _H_, _I_).

rcp_overlapped_by_search(A, B, D, _G_) :- 
	rcp_origin_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	rcp_origin_search(A, D, _C_),
	rcp_end_search(B, D, _D_),
	rcp_end_search(A, D, _E_),
	rcp_end_search(B, D, _F_),
	fd_lt(_A_, _B_),
	fd_lt(_C_, _D_),
	fd_gt(_E_, _F_),
	fd_aeq(_G_, 1).

rcp_met_by(A, B, D, _C_) :- 
	rcp_end(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_eq(_A_, _B_, _C_).

rcp_met_by_search(A, B, D, _C_) :- 
	rcp_end_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	fd_eq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_preceded_by(A, B, D, _C_) :- 
	rcp_end(B, D, _A_),
	rcp_origin(A, D, _B_),
	fd_lt(_A_, _B_, _C_).

rcp_preceded_by_search(A, B, D, _C_) :- 
	rcp_end_search(B, D, _A_),
	rcp_origin_search(A, D, _B_),
	fd_lt(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_contains_touch(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_origin(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_leq(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_end(A, D, _E_),
	fd_leq(_D_, _E_, _F_).

rcp_contains_touch_search(A, B, D, _E_) :- 
	rcp_origin_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_end_search(A, D, _D_),
	fd_leq(_A_, _B_),
	fd_leq(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_overlaps_sym(A, B, D, _G_) :- 
	fd_and(_C_, _F_, _G_),
	rcp_end(A, D, _A_),
	rcp_origin(B, D, _B_),
	fd_gt(_A_, _B_, _C_),
	rcp_end(B, D, _D_),
	rcp_origin(A, D, _E_),
	fd_gt(_D_, _E_, _F_).

rcp_overlaps_sym_search(A, B, D, _E_) :- 
	rcp_end_search(A, D, _A_),
	rcp_origin_search(B, D, _B_),
	rcp_end_search(B, D, _C_),
	rcp_origin_search(A, D, _D_),
	fd_gt(_A_, _B_),
	fd_gt(_C_, _D_),
	fd_aeq(_E_, 1).

rcp_disjoint_foldr_25([], _, 0) :- 
	!.
rcp_disjoint_foldr_25([D_118|Tail], [Ds,O1,O2], _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_or(_A_, _B_, _C_),
	rcp_precedes(O1, O2, D_118, _A_),
	rcp_preceded_by(O1, O2, D_118, _B_),
	rcp_disjoint_foldr_25(Tail, [Ds,O1,O2], _D_).

rcp_disjoint_foldr_25_search([], _, 0) :- 
	!.
rcp_disjoint_foldr_25_search([D_118|Tail], [Ds,O1,O2], _) :- 
	(
	(
	rcp_precedes_search(O1, O2, D_118, _F_),
	rcp_assert(_F_)
	;
	rcp_preceded_by_search(O1, O2, D_118, _G_),
	rcp_assert(_G_)
	)
	;
	rcp_disjoint_foldr_25_search(Tail, [Ds,O1,O2], _H_),
	rcp_assert(_H_)
	).

rcp_disjoint(O1, O2, Ds, _A_) :- 
	rcp_disjoint_foldr_25(Ds, [Ds,O1,O2], _A_).

rcp_disjoint_search(O1, O2, Ds, _A_) :- 
	rcp_disjoint_foldr_25_search(Ds, [Ds,O1,O2], _A_).

rcp_meet_foldr_26([], _, 1) :- 
	!.
rcp_meet_foldr_26([D_119|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_and(_B_, _D_, _E_),
	fd_not(_A_, _B_),
	rcp_precedes(O1, O2, D_119, _A_),
	fd_not(_C_, _D_),
	rcp_preceded_by(O1, O2, D_119, _C_),
	rcp_meet_foldr_26(Tail, [Ds,O1,O2], _F_).

rcp_meet_foldr_26_search([], _, 1) :- 
	!.
rcp_meet_foldr_26_search([D_119|Tail], [Ds,O1,O2], _) :- 
	rcp_precedes_search(O1, O2, D_119, _H_),
	fd_not(_H_, _I_),
	rcp_assert(_I_),
	rcp_preceded_by_search(O1, O2, D_119, _J_),
	fd_not(_J_, _K_),
	rcp_assert(_K_),
	rcp_meet_foldr_26_search(Tail, [Ds,O1,O2], _L_),
	rcp_assert(_L_).

rcp_meet_foldr_27([], _, 0) :- 
	!.
rcp_meet_foldr_27([D_120|Tail], [Ds,O1,O2], _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_or(_A_, _B_, _C_),
	rcp_meets(O1, O2, D_120, _A_),
	rcp_met_by(O1, O2, D_120, _B_),
	rcp_meet_foldr_27(Tail, [Ds,O1,O2], _D_).

rcp_meet_foldr_27_search([], _, 0) :- 
	!.
rcp_meet_foldr_27_search([D_120|Tail], [Ds,O1,O2], _) :- 
	(
	(
	rcp_meets_search(O1, O2, D_120, _F_),
	rcp_assert(_F_)
	;
	rcp_met_by_search(O1, O2, D_120, _G_),
	rcp_assert(_G_)
	)
	;
	rcp_meet_foldr_27_search(Tail, [Ds,O1,O2], _H_),
	rcp_assert(_H_)
	).

rcp_meet(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_meet_foldr_26(Ds, [Ds,O1,O2], _A_),
	rcp_meet_foldr_27(Ds, [Ds,O1,O2], _B_).

rcp_meet_search(O1, O2, Ds, _C_) :- 
	rcp_meet_foldr_26_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_meet_foldr_27_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_equal_foldr_28([], _, 1) :- 
	!.
rcp_equal_foldr_28([D_121|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_equals(O1, O2, D_121, _A_),
	rcp_equal_foldr_28(Tail, [Ds,O1,O2], _B_).

rcp_equal_foldr_28_search([], _, 1) :- 
	!.
rcp_equal_foldr_28_search([D_121|Tail], [Ds,O1,O2], _) :- 
	rcp_equals_search(O1, O2, D_121, _D_),
	rcp_assert(_D_),
	rcp_equal_foldr_28_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_equal(O1, O2, Ds, _A_) :- 
	rcp_equal_foldr_28(Ds, [Ds,O1,O2], _A_).

rcp_equal_search(O1, O2, Ds, _A_) :- 
	rcp_equal_foldr_28_search(Ds, [Ds,O1,O2], _A_).

rcp_covers_foldr_29([], _, 1) :- 
	!.
rcp_covers_foldr_29([D_122|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_or(_A_, _D_, _E_),
	rcp_started_by(O1, O2, D_122, _A_),
	fd_or(_B_, _C_, _D_),
	rcp_contains(O1, O2, D_122, _B_),
	rcp_finished_by(O1, O2, D_122, _C_),
	rcp_covers_foldr_29(Tail, [Ds,O1,O2], _F_).

rcp_covers_foldr_29_search([], _, 1) :- 
	!.
rcp_covers_foldr_29_search([D_122|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_started_by_search(O1, O2, D_122, _H_),
	rcp_assert(_H_)
	;
	(
	rcp_contains_search(O1, O2, D_122, _I_),
	rcp_assert(_I_)
	;
	rcp_finished_by_search(O1, O2, D_122, _J_),
	rcp_assert(_J_)
	)
	),
	rcp_covers_foldr_29_search(Tail, [Ds,O1,O2], _K_),
	rcp_assert(_K_).

rcp_covers_foldr_30([], _, 0) :- 
	!.
rcp_covers_foldr_30([D_123|Tail], [Ds,O1,O2], _D_) :- 
	fd_or(_B_, _C_, _D_),
	fd_not(_A_, _B_),
	rcp_contains(O1, O2, D_123, _A_),
	rcp_covers_foldr_30(Tail, [Ds,O1,O2], _C_).

rcp_covers_foldr_30_search([], _, 0) :- 
	!.
rcp_covers_foldr_30_search([D_123|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_contains_search(O1, O2, D_123, _E_),
	fd_not(_E_, _F_),
	rcp_assert(_F_)
	;
	rcp_covers_foldr_30_search(Tail, [Ds,O1,O2], _G_),
	rcp_assert(_G_)
	).

rcp_covers(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_covers_foldr_29(Ds, [Ds,O1,O2], _A_),
	rcp_covers_foldr_30(Ds, [Ds,O1,O2], _B_).

rcp_covers_search(O1, O2, Ds, _C_) :- 
	rcp_covers_foldr_29_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_covers_foldr_30_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_covered_by_foldr_31([], _, 1) :- 
	!.
rcp_covered_by_foldr_31([D_124|Tail], [Ds,O1,O2], _G_) :- 
	fd_and(_E_, _F_, _G_),
	fd_or(_A_, _D_, _E_),
	rcp_starts(O1, O2, D_124, _A_),
	fd_or(_B_, _C_, _D_),
	rcp_during(O1, O2, D_124, _B_),
	rcp_finishes(O1, O2, D_124, _C_),
	rcp_covered_by_foldr_31(Tail, [Ds,O1,O2], _F_).

rcp_covered_by_foldr_31_search([], _, 1) :- 
	!.
rcp_covered_by_foldr_31_search([D_124|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_starts_search(O1, O2, D_124, _H_),
	rcp_assert(_H_)
	;
	(
	rcp_during_search(O1, O2, D_124, _I_),
	rcp_assert(_I_)
	;
	rcp_finishes_search(O1, O2, D_124, _J_),
	rcp_assert(_J_)
	)
	),
	rcp_covered_by_foldr_31_search(Tail, [Ds,O1,O2], _K_),
	rcp_assert(_K_).

rcp_covered_by_foldr_32([], _, 0) :- 
	!.
rcp_covered_by_foldr_32([D_125|Tail], [Ds,O1,O2], _D_) :- 
	fd_or(_B_, _C_, _D_),
	fd_not(_A_, _B_),
	rcp_during(O1, O2, D_125, _A_),
	rcp_covered_by_foldr_32(Tail, [Ds,O1,O2], _C_).

rcp_covered_by_foldr_32_search([], _, 0) :- 
	!.
rcp_covered_by_foldr_32_search([D_125|Tail], [Ds,O1,O2], _) :- 
	(
	rcp_during_search(O1, O2, D_125, _E_),
	fd_not(_E_, _F_),
	rcp_assert(_F_)
	;
	rcp_covered_by_foldr_32_search(Tail, [Ds,O1,O2], _G_),
	rcp_assert(_G_)
	).

rcp_covered_by(O1, O2, Ds, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_covered_by_foldr_31(Ds, [Ds,O1,O2], _A_),
	rcp_covered_by_foldr_32(Ds, [Ds,O1,O2], _B_).

rcp_covered_by_search(O1, O2, Ds, _C_) :- 
	rcp_covered_by_foldr_31_search(Ds, [Ds,O1,O2], _A_),
	rcp_assert(_A_),
	rcp_covered_by_foldr_32_search(Ds, [Ds,O1,O2], _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_contains_rcc_foldr_33([], _, 1) :- 
	!.
rcp_contains_rcc_foldr_33([D_126|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains(O1, O2, D_126, _A_),
	rcp_contains_rcc_foldr_33(Tail, [Ds,O1,O2], _B_).

rcp_contains_rcc_foldr_33_search([], _, 1) :- 
	!.
rcp_contains_rcc_foldr_33_search([D_126|Tail], [Ds,O1,O2], _) :- 
	rcp_contains_search(O1, O2, D_126, _D_),
	rcp_assert(_D_),
	rcp_contains_rcc_foldr_33_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_contains_rcc(O1, O2, Ds, _A_) :- 
	rcp_contains_rcc_foldr_33(Ds, [Ds,O1,O2], _A_).

rcp_contains_rcc_search(O1, O2, Ds, _A_) :- 
	rcp_contains_rcc_foldr_33_search(Ds, [Ds,O1,O2], _A_).

rcp_inside_foldr_34([], _, 1) :- 
	!.
rcp_inside_foldr_34([D_127|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_during(O1, O2, D_127, _A_),
	rcp_inside_foldr_34(Tail, [Ds,O1,O2], _B_).

rcp_inside_foldr_34_search([], _, 1) :- 
	!.
rcp_inside_foldr_34_search([D_127|Tail], [Ds,O1,O2], _) :- 
	rcp_during_search(O1, O2, D_127, _D_),
	rcp_assert(_D_),
	rcp_inside_foldr_34_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_inside(O1, O2, Ds, _A_) :- 
	rcp_inside_foldr_34(Ds, [Ds,O1,O2], _A_).

rcp_inside_search(O1, O2, Ds, _A_) :- 
	rcp_inside_foldr_34_search(Ds, [Ds,O1,O2], _A_).

rcp_overlap_foldr_35([], _, 1) :- 
	!.
rcp_overlap_foldr_35([D_128|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_overlaps_sym(O1, O2, D_128, _A_),
	rcp_overlap_foldr_35(Tail, [Ds,O1,O2], _B_).

rcp_overlap_foldr_35_search([], _, 1) :- 
	!.
rcp_overlap_foldr_35_search([D_128|Tail], [Ds,O1,O2], _) :- 
	rcp_overlaps_sym_search(O1, O2, D_128, _D_),
	rcp_assert(_D_),
	rcp_overlap_foldr_35_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_overlap(O1, O2, Ds, _A_) :- 
	rcp_overlap_foldr_35(Ds, [Ds,O1,O2], _A_).

rcp_overlap_search(O1, O2, Ds, _A_) :- 
	rcp_overlap_foldr_35_search(Ds, [Ds,O1,O2], _A_).

rcp_contains_touch_rcc_foldr_36([], _, 1) :- 
	!.
rcp_contains_touch_rcc_foldr_36([D_129|Tail], [Ds,O1,O2], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains_touch(O1, O2, D_129, _A_),
	rcp_contains_touch_rcc_foldr_36(Tail, [Ds,O1,O2], _B_).

rcp_contains_touch_rcc_foldr_36_search([], _, 1) :- 
	!.
rcp_contains_touch_rcc_foldr_36_search([D_129|Tail], [Ds,O1,O2], _) :- 
	rcp_contains_touch_search(O1, O2, D_129, _D_),
	rcp_assert(_D_),
	rcp_contains_touch_rcc_foldr_36_search(Tail, [Ds,O1,O2], _E_),
	rcp_assert(_E_).

rcp_contains_touch_rcc(O1, O2, Ds, _A_) :- 
	rcp_contains_touch_rcc_foldr_36(Ds, [Ds,O1,O2], _A_).

rcp_contains_touch_rcc_search(O1, O2, Ds, _A_) :- 
	rcp_contains_touch_rcc_foldr_36_search(Ds, [Ds,O1,O2], _A_).

rcp_above(O1, O2, _E_) :- 
	fd_or(_C_, _D_, _E_),
	fd_and(_A_, _B_, _C_),
	rcp_overlap(O1, O2, [1,2], _A_),
	rcp_preceded_by(O1, O2, 3, _B_),
	rcp_met_by(O1, O2, 3, _D_).

rcp_above_search(O1, O2, _D_) :- 
	(
	rcp_overlap_search(O1, O2, [1,2], _A_),
	rcp_assert(_A_),
	rcp_preceded_by_search(O1, O2, 3, _B_),
	rcp_assert(_B_)
	;
	rcp_met_by_search(O1, O2, 3, _C_),
	rcp_assert(_C_)
	),
	fd_aeq(_D_, 1).

rcp_on_top(O1, O2, _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_overlap(O1, O2, [1,2], _A_),
	rcp_met_by(O1, O2, 3, _B_).

rcp_on_top_search(O1, O2, _C_) :- 
	rcp_overlap_search(O1, O2, [1,2], _A_),
	rcp_assert(_A_),
	rcp_met_by_search(O1, O2, 3, _B_),
	rcp_assert(_B_),
	fd_aeq(_C_, 1).

rcp_stack_oversize_foldr_39([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_39([D_135|Tail], [Items,Length,O1_130,O2_133], _D_) :- 
	fd_and(_B_, _C_, _D_),
	rcp_oversize(O1_130, O2_133, D_135, _A_),
	fd_leq(_A_, Length, _B_),
	rcp_stack_oversize_foldr_39(Tail, [Items,Length,O1_130,O2_133], _C_).

rcp_stack_oversize_foldr_39_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_39_search([D_135|Tail], [Items,Length,O1_130,O2_133], _) :- 
	rcp_oversize_search(O1_130, O2_133, D_135, _E_),
	fd_leq(_E_, Length),
	rcp_stack_oversize_foldr_39_search(Tail, [Items,Length,O1_130,O2_133], _F_),
	rcp_assert(_F_).

rcp_stack_oversize_foldr_38([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_38([O2_133|Tail], [Items,Length,O1_130], _I_) :- 
	fd_and(_G_, _H_, _I_),
	fd_implies(_E_, _F_, _G_),
	fd_and(_A_, _D_, _E_),
	rcp_overlap(O1_130, O2_133, [1,2], _A_),
	rcp_att(uid, O1_130, _B_),
	rcp_att(uid, O2_133, _C_),
	fd_neq(_B_, _C_, _D_),
	rcp_stack_oversize_foldr_39([1,2], [Items,Length,O1_130,O2_133], _F_),
	rcp_stack_oversize_foldr_38(Tail, [Items,Length,O1_130], _H_).

rcp_stack_oversize_foldr_38_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_38_search([O2_133|Tail], [Items,Length,O1_130], _) :- 
	rcp_att(uid, O1_130, _K_),
	rcp_att(uid, O2_133, _L_),
	rcp_att(uid, O1_130, _O_),
	rcp_att(uid, O2_133, _P_),
	(
	rcp_overlap_search(O1_130, O2_133, [1,2], _J_),
	rcp_assert(_J_),
	fd_neq(_K_, _L_),
	rcp_stack_oversize_foldr_39_search([1,2], [Items,Length,O1_130,O2_133], _Q_),
	fd_equiv(_Q_, _R_, 1)
	;
	(
	rcp_overlap_search(O1_130, O2_133, [1,2], _M_),
	fd_not(_M_, _N_),
	rcp_assert(_N_)
	;
	fd_eq(_O_, _P_)
	),
	fd_aeq(_R_, 1)
	),
	rcp_assert(_R_),
	rcp_stack_oversize_foldr_38_search(Tail, [Items,Length,O1_130], _S_),
	rcp_assert(_S_).

rcp_stack_oversize_foldr_37([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_37([O1_130|Tail], [Items,Length], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_stack_oversize_foldr_38(Items, [Items,Length,O1_130], _A_),
	rcp_stack_oversize_foldr_37(Tail, [Items,Length], _B_).

rcp_stack_oversize_foldr_37_search([], _, 1) :- 
	!.
rcp_stack_oversize_foldr_37_search([O1_130|Tail], [Items,Length], _) :- 
	rcp_stack_oversize_foldr_38_search(Items, [Items,Length,O1_130], _D_),
	rcp_assert(_D_),
	rcp_stack_oversize_foldr_37_search(Tail, [Items,Length], _E_),
	rcp_assert(_E_).

rcp_stack_oversize(Items, Length, _A_) :- 
	rcp_stack_oversize_foldr_37(Items, [Items,Length], _A_).

rcp_stack_oversize_search(Items, Length, _A_) :- 
	rcp_stack_oversize_foldr_37_search(Items, [Items,Length], _A_).

rcp_lighter(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_leq(_A_, _B_, _C_).

rcp_lighter_search(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_leq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_heavier(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_geq(_A_, _B_, _C_).

rcp_heavier_search(O1, O2, _C_) :- 
	rcp_att(weight, O1, _A_),
	rcp_att(weight, O2, _B_),
	fd_geq(_A_, _B_),
	fd_aeq(_C_, 1).

rcp_gravity_foldr_41([], _, 0) :- 
	!.
rcp_gravity_foldr_41([O2_138|Tail], [Items,O1_136], _G_) :- 
	fd_or(_E_, _F_, _G_),
	fd_and(_C_, _D_, _E_),
	rcp_att(uid, O1_136, _A_),
	rcp_att(uid, O2_138, _B_),
	fd_neq(_A_, _B_, _C_),
	rcp_on_top(O1_136, O2_138, _D_),
	rcp_gravity_foldr_41(Tail, [Items,O1_136], _F_).

rcp_gravity_foldr_41_search([], _, 0) :- 
	!.
rcp_gravity_foldr_41_search([O2_138|Tail], [Items,O1_136], _) :- 
	rcp_att(uid, O1_136, _H_),
	rcp_att(uid, O2_138, _I_),
	(
	fd_neq(_H_, _I_),
	rcp_on_top_search(O1_136, O2_138, _J_),
	rcp_assert(_J_)
	;
	rcp_gravity_foldr_41_search(Tail, [Items,O1_136], _K_),
	rcp_assert(_K_)
	).

rcp_gravity_foldr_40([], _, 1) :- 
	!.
rcp_gravity_foldr_40([O1_136|Tail], [Items], _F_) :- 
	fd_and(_D_, _E_, _F_),
	fd_or(_B_, _C_, _D_),
	rcp_origin(O1_136, 3, _A_),
	fd_eq(_A_, 0, _B_),
	rcp_gravity_foldr_41(Items, [Items,O1_136], _C_),
	rcp_gravity_foldr_40(Tail, [Items], _E_).

rcp_gravity_foldr_40_search([], _, 1) :- 
	!.
rcp_gravity_foldr_40_search([O1_136|Tail], [Items], _) :- 
	rcp_origin_search(O1_136, 3, _G_),
	(
	fd_eq(_G_, 0)
	;
	rcp_gravity_foldr_41_search(Items, [Items,O1_136], _H_),
	rcp_assert(_H_)
	),
	rcp_gravity_foldr_40_search(Tail, [Items], _I_),
	rcp_assert(_I_).

rcp_gravity(Items, _A_) :- 
	rcp_gravity_foldr_40(Items, [Items], _A_).

rcp_gravity_search(Items, _A_) :- 
	rcp_gravity_foldr_40_search(Items, [Items], _A_).

rcp_weight_stacking_foldr_43([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_43([O2_141|Tail], [Items,O1_139], _I_) :- 
	fd_and(_G_, _H_, _I_),
	fd_implies(_E_, _F_, _G_),
	fd_and(_C_, _D_, _E_),
	rcp_att(uid, O1_139, _A_),
	rcp_att(uid, O2_141, _B_),
	fd_neq(_A_, _B_, _C_),
	rcp_above(O1_139, O2_141, _D_),
	rcp_lighter(O1_139, O2_141, _F_),
	rcp_weight_stacking_foldr_43(Tail, [Items,O1_139], _H_).

rcp_weight_stacking_foldr_43_search([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_43_search([O2_141|Tail], [Items,O1_139], _) :- 
	rcp_att(uid, O1_139, _J_),
	rcp_att(uid, O2_141, _K_),
	rcp_att(uid, O1_139, _M_),
	rcp_att(uid, O2_141, _N_),
	(
	fd_neq(_J_, _K_),
	rcp_above_search(O1_139, O2_141, _L_),
	rcp_assert(_L_),
	rcp_lighter_search(O1_139, O2_141, _Q_),
	fd_equiv(_Q_, _R_, 1)
	;
	(
	fd_eq(_M_, _N_)
	;
	rcp_above_search(O1_139, O2_141, _O_),
	fd_not(_O_, _P_),
	rcp_assert(_P_)
	),
	fd_aeq(_R_, 1)
	),
	rcp_assert(_R_),
	rcp_weight_stacking_foldr_43_search(Tail, [Items,O1_139], _S_),
	rcp_assert(_S_).

rcp_weight_stacking_foldr_42([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_42([O1_139|Tail], [Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_weight_stacking_foldr_43(Items, [Items,O1_139], _A_),
	rcp_weight_stacking_foldr_42(Tail, [Items], _B_).

rcp_weight_stacking_foldr_42_search([], _, 1) :- 
	!.
rcp_weight_stacking_foldr_42_search([O1_139|Tail], [Items], _) :- 
	rcp_weight_stacking_foldr_43_search(Items, [Items,O1_139], _D_),
	rcp_assert(_D_),
	rcp_weight_stacking_foldr_42_search(Tail, [Items], _E_),
	rcp_assert(_E_).

rcp_weight_stacking(Items, _A_) :- 
	rcp_weight_stacking_foldr_42(Items, [Items], _A_).

rcp_weight_stacking_search(Items, _A_) :- 
	rcp_weight_stacking_foldr_42_search(Items, [Items], _A_).

rcp_weight_balancing_foldr_44([], _, []) :- 
	!.
rcp_weight_balancing_foldr_44([Il_142|Tail], [Bin,D,Items,Ratio], [_F_|_G_]) :- 
	rcp_att(weight, Il_142, _A_),
	rcp_end(Il_142, D, _B_),
	rcp_end(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_leq(_B_, _D_, _E_),
	fd_aeq(_A_*_E_, _F_),
	rcp_weight_balancing_foldr_44(Tail, [Bin,D,Items,Ratio], _G_).

rcp_weight_balancing_foldr_44_search([], _, []) :- 
	!.
rcp_weight_balancing_foldr_44_search([Il_142|Tail], [Bin,D,Items,Ratio], [_L_|_M_]) :- 
	rcp_att(weight, Il_142, _H_),
	rcp_end_search(Il_142, D, _I_),
	rcp_end_search(Bin, D, _J_),
	fd_aeq(_J_/2, _K_),
	fd_aeq(_H_*fd_leq(_I_,_K_), _L_),
	rcp_weight_balancing_foldr_44_search(Tail, [Bin,D,Items,Ratio], _M_).

rcp_weight_balancing_foldr_45([], _, []) :- 
	!.
rcp_weight_balancing_foldr_45([Ir_146|Tail], [Bin,D,Items,L_143,Ratio], [_F_|_G_]) :- 
	rcp_att(weight, Ir_146, _A_),
	rcp_origin(Ir_146, D, _B_),
	rcp_end(Bin, D, _C_),
	fd_aeq(_C_/2, _D_),
	fd_geq(_B_, _D_, _E_),
	fd_aeq(_A_*_E_, _F_),
	rcp_weight_balancing_foldr_45(Tail, [Bin,D,Items,L_143,Ratio], _G_).

rcp_weight_balancing_foldr_45_search([], _, []) :- 
	!.
rcp_weight_balancing_foldr_45_search([Ir_146|Tail], [Bin,D,Items,L_143,Ratio], [_L_|_M_]) :- 
	rcp_att(weight, Ir_146, _H_),
	rcp_origin_search(Ir_146, D, _I_),
	rcp_end_search(Bin, D, _J_),
	fd_aeq(_J_/2, _K_),
	fd_aeq(_H_*fd_geq(_I_,_K_), _L_),
	rcp_weight_balancing_foldr_45_search(Tail, [Bin,D,Items,L_143,Ratio], _M_).

rcp_weight_balancing(Items, Bin, D, Ratio, _J_) :- 
	rcp_weight_balancing_foldr_44(Items, [Bin,D,Items,Ratio], _A_),
	rcp_sum(_A_, L_143),
	rcp_weight_balancing_foldr_45(Items, [Bin,D,Items,L_143,Ratio], _C_),
	rcp_sum(_C_, R_147),
	fd_aeq(max(L_143,R_147), _E_),
	fd_aeq(100*_E_, _F_),
	fd_aeq(100+Ratio, _G_),
	fd_aeq(min(L_143,R_147), _H_),
	fd_aeq(_G_*_H_, _I_),
	fd_leq(_F_, _I_, _J_).

rcp_weight_balancing_search(Items, Bin, D, Ratio, _J_) :- 
	rcp_weight_balancing_foldr_44_search(Items, [Bin,D,Items,Ratio], _A_),
	rcp_sum_search(_A_, L_143),
	rcp_weight_balancing_foldr_45_search(Items, [Bin,D,Items,L_143,Ratio], _C_),
	rcp_sum_search(_C_, R_147),
	fd_aeq(max(L_143,R_147), _E_),
	fd_aeq(100*_E_, _F_),
	fd_aeq(100+Ratio, _G_),
	fd_aeq(min(L_143,R_147), _H_),
	fd_aeq(_G_*_H_, _I_),
	fd_leq(_F_, _I_),
	fd_aeq(_J_, 1).

rcp_object_shape_domain(O, _E_) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	length(_B_, _C_),
	rcp_range([1.._C_], _D_),
	_A_ in _D_,
	fd_aeq(_E_, 1).

rcp_object_shape_domain_search(O, _E_) :- 
	rcp_att(shape_index, O, _A_),
	rcp_att(shapes, O, _B_),
	length(_B_, _C_),
	rcp_range([1.._C_], _D_),
	_A_ in _D_,
	fd_aeq(_E_, 1).

rcp_object_shape_domains_foldr_46([], _, 1) :- 
	!.
rcp_object_shape_domains_foldr_46([I_148|Tail], [Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_object_shape_domain(I_148, _A_),
	rcp_object_shape_domains_foldr_46(Tail, [Items], _B_).

rcp_object_shape_domains_foldr_46_search([], _, 1) :- 
	!.
rcp_object_shape_domains_foldr_46_search([I_148|Tail], [Items], _) :- 
	rcp_object_shape_domain_search(I_148, _D_),
	rcp_assert(_D_),
	rcp_object_shape_domains_foldr_46_search(Tail, [Items], _E_),
	rcp_assert(_E_).

rcp_object_shape_domains(Items, _A_) :- 
	rcp_object_shape_domains_foldr_46(Items, [Items], _A_).

rcp_object_shape_domains_search(Items, _A_) :- 
	rcp_object_shape_domains_foldr_46_search(Items, [Items], _A_).

rcp_non_overlapping_binary_foldr_48([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_48([O2_151|Tail], [Dims,Items,O1_149], _H_) :- 
	fd_and(_F_, _G_, _H_),
	fd_implies(_C_, _E_, _F_),
	rcp_att(uid, O1_149, _A_),
	rcp_att(uid, O2_151, _B_),
	fd_lt(_A_, _B_, _C_),
	fd_not(_D_, _E_),
	rcp_overlap(O1_149, O2_151, Dims, _D_),
	rcp_non_overlapping_binary_foldr_48(Tail, [Dims,Items,O1_149], _G_).

rcp_non_overlapping_binary_foldr_48_search([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_48_search([O2_151|Tail], [Dims,Items,O1_149], _) :- 
	rcp_att(uid, O1_149, _I_),
	rcp_att(uid, O2_151, _J_),
	rcp_att(uid, O1_149, _K_),
	rcp_att(uid, O2_151, _L_),
	(
	fd_lt(_I_, _J_),
	rcp_overlap_search(O1_149, O2_151, Dims, _M_),
	fd_not(_M_, _N_),
	fd_equiv(_N_, _O_, 1)
	;
	fd_geq(_K_, _L_),
	fd_aeq(_O_, 1)
	),
	rcp_assert(_O_),
	rcp_non_overlapping_binary_foldr_48_search(Tail, [Dims,Items,O1_149], _P_),
	rcp_assert(_P_).

rcp_non_overlapping_binary_foldr_47([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_47([O1_149|Tail], [Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_non_overlapping_binary_foldr_48(Items, [Dims,Items,O1_149], _A_),
	rcp_non_overlapping_binary_foldr_47(Tail, [Dims,Items], _B_).

rcp_non_overlapping_binary_foldr_47_search([], _, 1) :- 
	!.
rcp_non_overlapping_binary_foldr_47_search([O1_149|Tail], [Dims,Items], _) :- 
	rcp_non_overlapping_binary_foldr_48_search(Items, [Dims,Items,O1_149], _D_),
	rcp_assert(_D_),
	rcp_non_overlapping_binary_foldr_47_search(Tail, [Dims,Items], _E_),
	rcp_assert(_E_).

rcp_non_overlapping_binary(Items, Dims, _A_) :- 
	rcp_non_overlapping_binary_foldr_47(Items, [Dims,Items], _A_).

rcp_non_overlapping_binary_search(Items, Dims, _A_) :- 
	rcp_non_overlapping_binary_foldr_47_search(Items, [Dims,Items], _A_).

rcp_containmentAE_foldr_50([], _, 0) :- 
	!.
rcp_containmentAE_foldr_50([B_154|Tail], [Bins,Dims,I_152,Items], _C_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_contains_touch_rcc(B_154, I_152, Dims, _A_),
	rcp_containmentAE_foldr_50(Tail, [Bins,Dims,I_152,Items], _B_).

rcp_containmentAE_foldr_50_search([], _, 0) :- 
	!.
rcp_containmentAE_foldr_50_search([B_154|Tail], [Bins,Dims,I_152,Items], _) :- 
	(
	rcp_contains_touch_rcc_search(B_154, I_152, Dims, _D_),
	rcp_assert(_D_)
	;
	rcp_containmentAE_foldr_50_search(Tail, [Bins,Dims,I_152,Items], _E_),
	rcp_assert(_E_)
	).

rcp_containmentAE_foldr_49([], _, 1) :- 
	!.
rcp_containmentAE_foldr_49([I_152|Tail], [Bins,Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_containmentAE_foldr_50(Bins, [Bins,Dims,I_152,Items], _A_),
	rcp_containmentAE_foldr_49(Tail, [Bins,Dims,Items], _B_).

rcp_containmentAE_foldr_49_search([], _, 1) :- 
	!.
rcp_containmentAE_foldr_49_search([I_152|Tail], [Bins,Dims,Items], _) :- 
	rcp_containmentAE_foldr_50_search(Bins, [Bins,Dims,I_152,Items], _D_),
	rcp_assert(_D_),
	rcp_containmentAE_foldr_49_search(Tail, [Bins,Dims,Items], _E_),
	rcp_assert(_E_).

rcp_containmentAE(Items, Bins, Dims, _A_) :- 
	rcp_containmentAE_foldr_49(Items, [Bins,Dims,Items], _A_).

rcp_containmentAE_search(Items, Bins, Dims, _A_) :- 
	rcp_containmentAE_foldr_49_search(Items, [Bins,Dims,Items], _A_).

rcp_bin_packing_binary(Items, Bins, Dims, _D_) :- 
	fd_and(_A_, _B_, _D_),
	rcp_containmentAE(Items, Bins, Dims, _A_),
	rcp_non_overlapping_binary(Items, Dims, _B_),
	variables(Items, _C_),
	rcp_labeling(_C_).

rcp_bin_packing_binary_search(Items, Bins, Dims, _D_) :- 
	variables(Items, _C_),
	rcp_containmentAE_search(Items, Bins, Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_binary_search(Items, Dims, _B_),
	rcp_assert(_B_),
	rcp_labeling(_C_),
	fd_aeq(_D_, 1).

rcp_bin_packing(Items, Bins, Dims, _D_) :- 
	fd_and(_A_, _B_, _D_),
	rcp_containmentAE(Items, Bins, Dims, _A_),
	rcp_non_overlapping(Items, Dims, _B_),
	variables(Items, _C_),
	rcp_labeling(_C_).

rcp_bin_packing_search(Items, Bins, Dims, _D_) :- 
	variables(Items, _C_),
	rcp_containmentAE_search(Items, Bins, Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_search(Items, Dims, _B_),
	rcp_assert(_B_),
	rcp_labeling(_C_),
	fd_aeq(_D_, 1).

rcp_containmentEA_foldr_52([], _, 1) :- 
	!.
rcp_containmentEA_foldr_52([I_157|Tail], [B_155,Bins,Dims,Items], _C_) :- 
	fd_and(_A_, _B_, _C_),
	rcp_contains_touch_rcc(B_155, I_157, Dims, _A_),
	rcp_containmentEA_foldr_52(Tail, [B_155,Bins,Dims,Items], _B_).

rcp_containmentEA_foldr_52_search([], _, 1) :- 
	!.
rcp_containmentEA_foldr_52_search([I_157|Tail], [B_155,Bins,Dims,Items], _) :- 
	rcp_contains_touch_rcc_search(B_155, I_157, Dims, _D_),
	rcp_assert(_D_),
	rcp_containmentEA_foldr_52_search(Tail, [B_155,Bins,Dims,Items], _E_),
	rcp_assert(_E_).

rcp_containmentEA_foldr_51([], _, 0) :- 
	!.
rcp_containmentEA_foldr_51([B_155|Tail], [Bins,Dims,Items], _C_) :- 
	fd_or(_A_, _B_, _C_),
	rcp_containmentEA_foldr_52(Items, [B_155,Bins,Dims,Items], _A_),
	rcp_containmentEA_foldr_51(Tail, [Bins,Dims,Items], _B_).

rcp_containmentEA_foldr_51_search([], _, 0) :- 
	!.
rcp_containmentEA_foldr_51_search([B_155|Tail], [Bins,Dims,Items], _) :- 
	(
	rcp_containmentEA_foldr_52_search(Items, [B_155,Bins,Dims,Items], _D_),
	rcp_assert(_D_)
	;
	rcp_containmentEA_foldr_51_search(Tail, [Bins,Dims,Items], _E_),
	rcp_assert(_E_)
	).

rcp_containmentEA(Items, Bins, Dims, _A_) :- 
	rcp_containmentEA_foldr_51(Bins, [Bins,Dims,Items], _A_).

rcp_containmentEA_search(Items, Bins, Dims, _A_) :- 
	rcp_containmentEA_foldr_51_search(Bins, [Bins,Dims,Items], _A_).

rcp_bin_design(Bin, Items, Dims, _E_) :- 
	fd_and(_A_, _B_, _E_),
	rcp_containmentEA(Items, [Bin], Dims, _A_),
	rcp_non_overlapping(Items, Dims, _B_),
	rcp_volume(Bin, _D_),
	minimize(((variables(Items,_C_),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_).

rcp_bin_design_search(Bin, Items, Dims, _E_) :- 
	rcp_volume(Bin, _D_),
	rcp_containmentEA_search(Items, [Bin], Dims, _A_),
	rcp_assert(_A_),
	rcp_non_overlapping_search(Items, Dims, _B_),
	rcp_assert(_B_),
	minimize(((variables(Items,_C_),rcp_labeling(_C_)),rcp_labeling([_D_])), _D_),
	fd_aeq(_E_, 1).

rcp_items_domain_foldr_54([], _, []) :- 
	!.
rcp_items_domain_foldr_54([S_165|Tail], [Bin,I_158,Items], [_E_|_F_]) :- 
	rcp_att(sboxes, S_165, _A_),
	nth1(1, _A_, P_167),
	rcp_att(box, P_167, _C_),
	rcp_att(size, _C_, _D_),
	nth1(1, _D_, _E_),
	rcp_items_domain_foldr_54(Tail, [Bin,I_158,Items], _F_).

rcp_items_domain_foldr_54_search([], _, []) :- 
	!.
rcp_items_domain_foldr_54_search([S_165|Tail], [Bin,I_158,Items], [_K_|_L_]) :- 
	rcp_att(sboxes, S_165, _G_),
	nth1(1, _G_, P_167),
	rcp_att(box, P_167, _I_),
	rcp_att(size, _I_, _J_),
	nth1(1, _J_, _K_),
	rcp_items_domain_foldr_54_search(Tail, [Bin,I_158,Items], _L_).

rcp_items_domain_foldr_55([], _, []) :- 
	!.
rcp_items_domain_foldr_55([S_168|Tail], [Bin,I_158,Items], [_E_|_F_]) :- 
	rcp_att(sboxes, S_168, _A_),
	nth1(1, _A_, P_170),
	rcp_att(box, P_170, _C_),
	rcp_att(size, _C_, _D_),
	nth1(2, _D_, _E_),
	rcp_items_domain_foldr_55(Tail, [Bin,I_158,Items], _F_).

rcp_items_domain_foldr_55_search([], _, []) :- 
	!.
rcp_items_domain_foldr_55_search([S_168|Tail], [Bin,I_158,Items], [_K_|_L_]) :- 
	rcp_att(sboxes, S_168, _G_),
	nth1(1, _G_, P_170),
	rcp_att(box, P_170, _I_),
	rcp_att(size, _I_, _J_),
	nth1(2, _J_, _K_),
	rcp_items_domain_foldr_55_search(Tail, [Bin,I_158,Items], _L_).

rcp_items_domain_foldr_56([], _, []) :- 
	!.
rcp_items_domain_foldr_56([S_171|Tail], [Bin,I_158,Items], [_E_|_F_]) :- 
	rcp_att(sboxes, S_171, _A_),
	nth1(1, _A_, P_173),
	rcp_att(box, P_173, _C_),
	rcp_att(size, _C_, _D_),
	nth1(3, _D_, _E_),
	rcp_items_domain_foldr_56(Tail, [Bin,I_158,Items], _F_).

rcp_items_domain_foldr_56_search([], _, []) :- 
	!.
rcp_items_domain_foldr_56_search([S_171|Tail], [Bin,I_158,Items], [_K_|_L_]) :- 
	rcp_att(sboxes, S_171, _G_),
	nth1(1, _G_, P_173),
	rcp_att(box, P_173, _I_),
	rcp_att(size, _I_, _J_),
	nth1(3, _J_, _K_),
	rcp_items_domain_foldr_56_search(Tail, [Bin,I_158,Items], _L_).

rcp_items_domain_foldr_53([], _, 1) :- 
	!.
rcp_items_domain_foldr_53([I_158|Tail], [Bin,Items], _W_) :- 
	fd_and((domain(_I_,0,_N_),domain(_P_,0,_U_)), _V_, _W_),
	rcp_x(I_158, _A_),
	variables(_A_, _B_),
	rcp_w(Bin, _C_),
	rcp_att(shapes, I_158, _D_),
	rcp_items_domain_foldr_54(_D_, [Bin,I_158,Items], _E_),
	rcp_minimum(_E_, _F_),
	fd_aeq(_C_-_F_, _G_),
	domain(_B_, 0, _G_),
	rcp_y(I_158, _H_),
	variables(_H_, _I_),
	rcp_h(Bin, _J_),
	rcp_att(shapes, I_158, _K_),
	rcp_items_domain_foldr_55(_K_, [Bin,I_158,Items], _L_),
	rcp_minimum(_L_, _M_),
	fd_aeq(_J_-_M_, _N_),
	rcp_z(I_158, _O_),
	variables(_O_, _P_),
	rcp_l(Bin, _Q_),
	rcp_att(shapes, I_158, _R_),
	rcp_items_domain_foldr_56(_R_, [Bin,I_158,Items], _S_),
	rcp_minimum(_S_, _T_),
	fd_aeq(_Q_-_T_, _U_),
	rcp_items_domain_foldr_53(Tail, [Bin,Items], _V_).

rcp_items_domain_foldr_53_search([], _, 1) :- 
	!.
rcp_items_domain_foldr_53_search([I_158|Tail], [Bin,Items], _) :- 
	rcp_x_search(I_158, _X_),
	variables(_X_, _Y_),
	rcp_w_search(Bin, _Z_),
	rcp_att(shapes, I_158, _B1_),
	rcp_items_domain_foldr_54_search(_B1_, [Bin,I_158,Items], _C1_),
	rcp_minimum_search(_C1_, _D1_),
	fd_aeq(_Z_-_D1_, _E1_),
	rcp_y_search(I_158, _F1_),
	variables(_F1_, _G1_),
	rcp_h_search(Bin, _H1_),
	rcp_att(shapes, I_158, _I1_),
	rcp_items_domain_foldr_55_search(_I1_, [Bin,I_158,Items], _J1_),
	rcp_minimum_search(_J1_, _K1_),
	fd_aeq(_H1_-_K1_, _L1_),
	rcp_z_search(I_158, _M1_),
	variables(_M1_, _N1_),
	rcp_l_search(Bin, _O1_),
	rcp_att(shapes, I_158, _P1_),
	rcp_items_domain_foldr_56_search(_P1_, [Bin,I_158,Items], _Q1_),
	rcp_minimum_search(_Q1_, _R1_),
	fd_aeq(_O1_-_R1_, _S1_),
	domain(_Y_, 0, _E1_),
	domain(_G1_, 0, _L1_),
	domain(_N1_, 0, _S1_),
	rcp_items_domain_foldr_53_search(Tail, [Bin,Items], _T1_),
	rcp_assert(_T1_).

rcp_items_domain(Items, Bin, _A_) :- 
	rcp_items_domain_foldr_53(Items, [Bin,Items], _A_).

rcp_items_domain_search(Items, Bin, _A_) :- 
	rcp_items_domain_foldr_53_search(Items, [Bin,Items], _A_).

rcp_psa_bin_packing_foldr_58([], _, 0) :- 
	!.
rcp_psa_bin_packing_foldr_58([J_177|Tail], [Bin,Dims,Items,X_174], _M_) :- 
	fd_or(_K_, _L_, _M_),
	fd_and(_C_, _J_, _K_),
	rcp_x(J_177, _A_),
	fd_size(_A_, _B_),
	fd_gt(_B_, 1, _C_),
	fd_and(_F_, _I_, _J_),
	rcp_y(J_177, _D_),
	fd_size(_D_, _E_),
	fd_gt(_E_, 1, _F_),
	rcp_z(J_177, _G_),
	fd_size(_G_, _H_),
	fd_gt(_H_, 1, _I_),
	rcp_psa_bin_packing_foldr_58(Tail, [Bin,Dims,Items,X_174], _L_).

rcp_psa_bin_packing_foldr_58_search([], _, 0) :- 
	!.
rcp_psa_bin_packing_foldr_58_search([J_177|Tail], [Bin,Dims,Items,X_174], _) :- 
	rcp_x_search(J_177, _N_),
	fd_size(_N_, _O_),
	rcp_y_search(J_177, _P_),
	fd_size(_P_, _Q_),
	rcp_z_search(J_177, _R_),
	fd_size(_R_, _S_),
	(
	fd_gt(_O_, 1),
	fd_gt(_Q_, 1),
	fd_gt(_S_, 1)
	;
	rcp_psa_bin_packing_foldr_58_search(Tail, [Bin,Dims,Items,X_174], _T_),
	rcp_assert(_T_)
	).

rcp_psa_bin_packing_foldr_59([], _, 0) :- 
	!.
rcp_psa_bin_packing_foldr_59([K_178|Tail], [Bin,Dims,Items,X_174], _T_) :- 
	fd_or(_R_, _S_, _T_),
	fd_and(_C_, _Q_, _R_),
	rcp_x(K_178, _A_),
	fd_size(_A_, _B_),
	fd_gt(_B_, 1, _C_),
	fd_and(_G_, _P_, _Q_),
	rcp_x(K_178, _D_),
	rcp_x(K_178, _E_),
	fd_min(_E_, _F_),
	fd_eq(_D_, _F_, _G_),
	fd_and(_K_, _O_, _P_),
	rcp_y(K_178, _H_),
	rcp_y(K_178, _I_),
	fd_min(_I_, _J_),
	fd_eq(_H_, _J_, _K_),
	rcp_z(K_178, _L_),
	rcp_z(K_178, _M_),
	fd_min(_M_, _N_),
	fd_eq(_L_, _N_, _O_),
	rcp_psa_bin_packing_foldr_59(Tail, [Bin,Dims,Items,X_174], _S_).

rcp_psa_bin_packing_foldr_59_search([], _, 0) :- 
	!.
rcp_psa_bin_packing_foldr_59_search([K_178|Tail], [Bin,Dims,Items,X_174], _) :- 
	rcp_x_search(K_178, _U_),
	fd_size(_U_, _V_),
	rcp_x_search(K_178, _W_),
	rcp_x_search(K_178, _X_),
	fd_min(_X_, _Y_),
	rcp_y_search(K_178, _Z_),
	rcp_y_search(K_178, _B1_),
	fd_min(_B1_, _C1_),
	rcp_z_search(K_178, _D1_),
	rcp_z_search(K_178, _E1_),
	fd_min(_E1_, _F1_),
	(
	fd_gt(_V_, 1),
	fd_eq(_W_, _Y_),
	fd_eq(_Z_, _C1_),
	fd_eq(_D1_, _F1_)
	;
	rcp_psa_bin_packing_foldr_59_search(Tail, [Bin,Dims,Items,X_174], _G1_),
	rcp_assert(_G1_)
	).

rcp_psa_bin_packing_foldr_57([], _, 1) :- 
	!.
rcp_psa_bin_packing_foldr_57([X_174|Tail], [Bin,Dims,Items], _E_) :- 
	fd_and(_C_, _D_, _E_),
	fd_implies(_A_, _B_, _C_),
	rcp_psa_bin_packing_foldr_58(Items, [Bin,Dims,Items,X_174], _A_),
	rcp_psa_bin_packing_foldr_59_search(Items, [Bin,Dims,Items,X_174], _B_),
	rcp_psa_bin_packing_foldr_57(Tail, [Bin,Dims,Items], _D_).

rcp_psa_bin_packing_foldr_57_search([], _, 1) :- 
	!.
rcp_psa_bin_packing_foldr_57_search([X_174|Tail], [Bin,Dims,Items], _) :- 
	rcp_psa_bin_packing_foldr_58_search(Items, [Bin,Dims,Items,X_174], _F_),
	rcp_psa_bin_packing_foldr_58_search(Items, [Bin,Dims,Items,X_174], _G_),
	fd_not(_G_, _H_),
	(
	_F_,
	rcp_psa_bin_packing_foldr_59_search(Items, [Bin,Dims,Items,X_174], _I_),
	fd_equiv(_I_, _J_, 1)
	;
	_H_,
	fd_aeq(_J_, 1)
	),
	rcp_assert(_J_),
	rcp_psa_bin_packing_foldr_57(Tail, [Bin,Dims,Items], _K_),
	rcp_assert(_K_).

rcp_psa_bin_packing(Items, Bin, Dims, _G_) :- 
	fd_and(_A_, _F_, _G_),
	rcp_items_domain(Items, Bin, _A_),
	fd_and(_B_, _E_, _F_),
	rcp_containmentAE(Items, [Bin], Dims, _B_),
	fd_and(_C_, _D_, _E_),
	rcp_non_overlapping(Items, Dims, _C_),
	rcp_psa_bin_packing_foldr_57(Items, [Bin,Dims,Items], _D_).

rcp_psa_bin_packing_search(Items, Bin, Dims, _E_) :- 
	rcp_items_domain_search(Items, Bin, _A_),
	rcp_assert(_A_),
	rcp_containmentAE_search(Items, [Bin], Dims, _B_),
	rcp_assert(_B_),
	rcp_non_overlapping_search(Items, Dims, _C_),
	rcp_assert(_C_),
	rcp_psa_bin_packing_foldr_57_search(Items, [Bin,Dims,Items], _D_),
	rcp_assert(_D_),
	fd_aeq(_E_, 1).

solve([Obj_1,Obj_1_2,Obj_1_3,Obj_2,Obj_2_2,Obj_2_3]) :- 
	statistics(runtime, [_Runtime_0_|_]),
	fd_statistics(backtracks, _),
	rcp_var(from(obj(1),0,1), Obj_1),
	rcp_var(from(obj(1),0,2), Obj_1_2),
	rcp_var(from(obj(1),0,3), Obj_1_3),
	rcp_var(from(obj(2),0,1), Obj_2),
	rcp_var(from(obj(2),0,2), Obj_2_2),
	rcp_var(from(obj(2),0,3), Obj_2_3),
	domain([Obj_1], 0, 1640),
	domain([Obj_1_2], 0, 1840),
	domain([Obj_1_3], 0, 792),
	domain([Obj_2], 0, 1640),
	domain([Obj_2_2], 0, 1840),
	domain([Obj_2_3], 0, 792),
	0#=<Obj_1,
	Obj_1+600#=<2240,
	0#=<Obj_1_2,
	Obj_1_2+400#=<2240,
	0#=<Obj_1_3,
	Obj_1_3+200#=<992,
	0#=<Obj_2,
	Obj_2+600#=<2240,
	0#=<Obj_2_2,
	Obj_2_2+400#=<2240,
	0#=<Obj_2_3,
	Obj_2_3+200#=<992,
	rcp_geost([object(4,3,[Obj_1,Obj_1_2,Obj_1_3],[]),object(5,3,[Obj_2,Obj_2_2,Obj_2_3],[])], [sbox(3,[0,0,0],[600,400,200])], [non_overlapping(objects([4,5]),[1,2,3])]),
	fd_implies(_I_, _R_, _S_),
	rcp_rec([size=[600,400,200],uid=1], _A_),
	rcp_rec([box=_A_,offset=[0,0,0],uid=2], _B_),
	rcp_rec([sboxes=[_B_],uid=3], _C_),
	rcp_var(from(obj(1),0,1), Obj_1),
	rcp_var(from(obj(1),0,2), Obj_1_2),
	rcp_var(from(obj(1),0,3), Obj_1_3),
	rcp_rec([shapes=[_C_],shape_index=1,origin=[Obj_1,Obj_1_2,Obj_1_3],weight=11,uid=4], _D_),
	rcp_rec([size=[600,400,200],uid=1], _E_),
	rcp_rec([box=_E_,offset=[0,0,0],uid=2], _F_),
	rcp_rec([sboxes=[_F_],uid=3], _G_),
	rcp_var(from(obj(2),0,1), Obj_2),
	rcp_var(from(obj(2),0,2), Obj_2_2),
	rcp_var(from(obj(2),0,3), Obj_2_3),
	rcp_rec([shapes=[_G_],shape_index=1,origin=[Obj_2,Obj_2_2,Obj_2_3],weight=11,uid=5], _H_),
	rcp_psa_bin_packing_foldr_1([_D_,_H_], [], _I_),
	rcp_rec([size=[600,400,200],uid=1], _J_),
	rcp_rec([box=_J_,offset=[0,0,0],uid=2], _K_),
	rcp_rec([sboxes=[_K_],uid=3], _L_),
	rcp_var(from(obj(1),0,1), Obj_1),
	rcp_var(from(obj(1),0,2), Obj_1_2),
	rcp_var(from(obj(1),0,3), Obj_1_3),
	rcp_rec([shapes=[_L_],shape_index=1,origin=[Obj_1,Obj_1_2,Obj_1_3],weight=11,uid=4], _M_),
	rcp_rec([size=[600,400,200],uid=1], _N_),
	rcp_rec([box=_N_,offset=[0,0,0],uid=2], _O_),
	rcp_rec([sboxes=[_O_],uid=3], _P_),
	rcp_var(from(obj(2),0,1), Obj_2),
	rcp_var(from(obj(2),0,2), Obj_2_2),
	rcp_var(from(obj(2),0,3), Obj_2_3),
	rcp_rec([shapes=[_P_],shape_index=1,origin=[Obj_2,Obj_2_2,Obj_2_3],weight=11,uid=5], _Q_),
	rcp_psa_bin_packing_foldr_2_search([_M_,_Q_], [], _R_),
	rcp_assert(_S_),
	fd_implies(_C1_, _L1_, _M1_),
	rcp_rec([size=[600,400,200],uid=1], _T_),
	rcp_rec([box=_T_,offset=[0,0,0],uid=2], _U_),
	rcp_rec([sboxes=[_U_],uid=3], _V_),
	rcp_var(from(obj(1),0,1), Obj_1),
	rcp_var(from(obj(1),0,2), Obj_1_2),
	rcp_var(from(obj(1),0,3), Obj_1_3),
	rcp_rec([shapes=[_V_],shape_index=1,origin=[Obj_1,Obj_1_2,Obj_1_3],weight=11,uid=4], _W_),
	rcp_rec([size=[600,400,200],uid=1], _X_),
	rcp_rec([box=_X_,offset=[0,0,0],uid=2], _Y_),
	rcp_rec([sboxes=[_Y_],uid=3], _Z_),
	rcp_var(from(obj(2),0,1), Obj_2),
	rcp_var(from(obj(2),0,2), Obj_2_2),
	rcp_var(from(obj(2),0,3), Obj_2_3),
	rcp_rec([shapes=[_Z_],shape_index=1,origin=[Obj_2,Obj_2_2,Obj_2_3],weight=11,uid=5], _B1_),
	rcp_psa_bin_packing_foldr_1([_W_,_B1_], [], _C1_),
	rcp_rec([size=[600,400,200],uid=1], _D1_),
	rcp_rec([box=_D1_,offset=[0,0,0],uid=2], _E1_),
	rcp_rec([sboxes=[_E1_],uid=3], _F1_),
	rcp_var(from(obj(1),0,1), Obj_1),
	rcp_var(from(obj(1),0,2), Obj_1_2),
	rcp_var(from(obj(1),0,3), Obj_1_3),
	rcp_rec([shapes=[_F1_],shape_index=1,origin=[Obj_1,Obj_1_2,Obj_1_3],weight=11,uid=4], _G1_),
	rcp_rec([size=[600,400,200],uid=1], _H1_),
	rcp_rec([box=_H1_,offset=[0,0,0],uid=2], _I1_),
	rcp_rec([sboxes=[_I1_],uid=3], _J1_),
	rcp_var(from(obj(2),0,1), Obj_2),
	rcp_var(from(obj(2),0,2), Obj_2_2),
	rcp_var(from(obj(2),0,3), Obj_2_3),
	rcp_rec([shapes=[_J1_],shape_index=1,origin=[Obj_2,Obj_2_2,Obj_2_3],weight=11,uid=5], _K1_),
	rcp_psa_bin_packing_foldr_2_search([_G1_,_K1_], [], _L1_),
	rcp_assert(_M1_),
	statistics(runtime, [_Runtime_1_|_]),
	fd_statistics(backtracks, _Backtracks_),
	_Runtime_ is _Runtime_1_-_Runtime_0_,
	format('~3d seconds\n', [_Runtime_]),
	format('~w bactracks\n\n', [_Backtracks_]).
