% Three non-overlapping 2D objects:

?- X3 in 0..1,
   Y3 in 0..1,
   Obj1 = object(1,1,[0,2]),
   Obj2 = object(2,1,[2,1]),
   Obj3 = object(3,2,[X3,Y3]),
   Sbox1 = sbox(1,[0,0],[1,1]),
   Sbox2 = sbox(2,[0,0],[2,2]),
   Sboxes  = [Sbox1,Sbox2],
   Rules   = [(origin(O1,S1,D) ---> O1^x(D)+S1^t(D)),
	      (end(O1,S1,D) ---> O1^x(D)+S1^t(D)+S1^l(D)),
	      (soverlap(O1,O2,S1,S2,D) --->
                  end(O1,S1,D) #> origin(O2,S2,D) #/\
	          end(O2,S2,D) #> origin(O1,S1,D)),
	      (non_overlap(O1,O2,Ss) --->
		  forall(S1,Ss,
			 S1^sid#=O1^sid #=>
			 forall(S2,Ss,
				S2^sid#=O2^sid #=>
			        #\ soverlap(O1,O2,S1,S2,0) #\/
			        #\ soverlap(O1,O2,S1,S2,1)))),
	      non_overlap(Obj1,Obj2,Sboxes),
	      non_overlap(Obj1,Obj3,Sboxes),
	      non_overlap(Obj2,Obj3,Sboxes)],
   geost(2,[Obj1,Obj2,Obj3],Sboxes,Rules).

?- X3 in 0..1,
   Y3 in 0..1,
   Obj1 = object(1,1,[0,2]),
   Obj2 = object(2,1,[2,1]),
   Obj3 = object(3,2,[X3,Y3]),
   Sbox1 = sbox(1,[0,0],[1,1]),
   Sbox2 = sbox(2,[0,0],[2,2]),
   Sboxes  = [Sbox1,Sbox2],
   Rules   = [(origin(O1,S1,D) ---> O1^x(D)+S1^t(D)),
	      (end(O1,S1,D) ---> O1^x(D)+S1^t(D)+S1^l(D)),
	      (soverlap(O1,O2,S1,S2,D) --->
                  end(O1,S1,D) #> origin(O2,S2,D) #/\
	          end(O2,S2,D) #> origin(O1,S1,D)),
	      (#\ soverlap(Obj1,Obj2,Sbox1,Sbox1,0) #\/
	       #\ soverlap(Obj1,Obj2,Sbox1,Sbox1,1)),
	      (#\ soverlap(Obj1,Obj3,Sbox1,Sbox2,0) #\/
	       #\ soverlap(Obj1,Obj3,Sbox1,Sbox2,1)),
	      (#\ soverlap(Obj2,Obj3,Sbox1,Sbox2,0) #\/
	       #\ soverlap(Obj2,Obj3,Sbox1,Sbox2,1))],
   geost(2,[Obj1,Obj2,Obj3],Sboxes,Rules).

?- X3 in 0..1,
   Y3 in 0..1,
   Obj1 = object(1,1,[0,2]),
   Obj2 = object(2,1,[2,1]),
   Obj3 = object(3,2,[X3,Y3]),
   Sbox1 = sbox(1,[0,0],[1,1]),
   Sbox2 = sbox(2,[0,0],[2,2]),
   Sboxes  = [Sbox1,Sbox2],
   Rules   = [(origin(O1,S1,D) ---> O1^x(D)+S1^t(D)),
	      (end(O1,S1,D) ---> O1^x(D)+S1^t(D)+S1^l(D)),
	      (#\ (end(Obj1,Sbox1,0) #> origin(Obj2,Sbox1,0) #/\ end(Obj2,Sbox1,0) #> origin(Obj1,Sbox1,0)) #\/
	       #\ (end(Obj1,Sbox1,1) #> origin(Obj2,Sbox1,1) #/\ end(Obj2,Sbox1,1) #> origin(Obj1,Sbox1,1))),
	      (#\ (end(Obj1,Sbox1,0) #> origin(Obj3,Sbox2,0) #/\ end(Obj3,Sbox2,0) #> origin(Obj1,Sbox1,0)) #\/
	       #\ (end(Obj1,Sbox1,1) #> origin(Obj3,Sbox2,1) #/\ end(Obj3,Sbox2,1) #> origin(Obj1,Sbox1,1))),
	      (#\ (end(Obj2,Sbox1,0) #> origin(Obj3,Sbox2,0) #/\ end(Obj3,Sbox2,0) #> origin(Obj2,Sbox1,0)) #\/
	       #\ (end(Obj2,Sbox1,1) #> origin(Obj3,Sbox2,1) #/\ end(Obj3,Sbox2,1) #> origin(Obj2,Sbox1,1)))],
   geost(2,[Obj1,Obj2,Obj3],Sboxes,Rules).

?- X3 in 0..1,
   Y3 in 0..1,
   Obj1 = object(1,1,[0,2]),
   Obj2 = object(2,1,[2,1]),
   Obj3 = object(3,2,[X3,Y3]),
   Sbox1 = sbox(1,[0,0],[1,1]),
   Sbox2 = sbox(2,[0,0],[2,2]),
   Sboxes  = [Sbox1,Sbox2],
   Rules   = [(#\ (1                 #> 2                    #/\ 3                 #> 0                   ) #\/
	       #\ (3                 #> 1                    #/\ 2                 #> 2                   )),
	      (#\ (1                 #> X3                   #/\ X3+2              #> 0                   ) #\/
	       #\ (3                 #> Y3                   #/\ Y3+2              #> 2                   )),
	      (#\ (3                 #> X3                   #/\ X3+2              #> 2                   ) #\/
	       #\ (2                 #> Y3                   #/\ Y3+2              #> 1                   ))],
   geost(2,[Obj1,Obj2,Obj3],Sboxes,Rules).

?- X3 in 0..1,
   Y3 in 0..1,
   Obj1 = object(1,1,[0,2]),
   Obj2 = object(2,1,[2,1]),
   Obj3 = object(3,2,[X3,Y3]),
   Sbox1 = sbox(1,[0,0],[1,1]),
   Sbox2 = sbox(2,[0,0],[2,2]),
   Sboxes  = [Sbox1,Sbox2],
   Rules   = [(#\ (1                 #> X3                   #/\ X3+2              #> 0                   ) #\/
	       #\ (3                 #> Y3                   #/\ Y3+2              #> 2                   )),
	      (#\ (3                 #> X3                   #/\ X3+2              #> 2                   ) #\/
	       #\ (2                 #> Y3                   #/\ Y3+2              #> 1                   ))],
   geost(2,[Obj1,Obj2,Obj3],Sboxes,Rules).

?- X3 in 0..1,
   Y3 in 0..1,
   Obj1 = object(1,1,[0,2]),
   Obj2 = object(2,1,[2,1]),
   Obj3 = object(3,2,[X3,Y3]),
   Sbox1 = sbox(1,[0,0],[1,1]),
   Sbox2 = sbox(2,[0,0],[2,2]),
   Sboxes  = [Sbox1,Sbox2],
   Rules   = [(X3 #>= 1 #\/ X3 #=< -2 #\/ Y3 #>= 3 #\/ Y3 #=<  0),
	      (X3 #>= 3 #\/ X3 #=<  0 #\/ Y3 #>= 2 #\/ Y3 #=< -1)],
   geost(2,[Obj1,Obj2,Obj3],Sboxes,Rules).


crule      forbidden set
=====      =============

X3 #>=  1  (inf..0) * any
X3 #=< -2  (-1..sup) * any
Y3 #>=  3  any * (inf..2)
Y3 #=<  0  any * (1..sup)

(X3 #>= 1 #\/ X3 #=< -2 #\/ Y3 #>= 3 #\/ Y3 #=<  0)
           (-1..0) * (1..2)


X3 #>=  3  (inf..2) * any
X3 #=<  0  (1..sup) * any
Y3 #>=  2  any * (inf..1)
Y3 #=< -1  any * (0..sup)

(X3 #>= 3 #\/ X3 #=< 0 #\/ Y3 #>= 2 #\/ Y3 #=< -1)
           (1..2) * (0..1)


